// This file is automatically generated by scripts/generate_python_listener.py DO NOT EDIT!!!

/*
 Copyright 2019 Alain Dargelas
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

#ifndef SURELOG_SV3_1APYTHONLISTENER_H
#define SURELOG_SV3_1APYTHONLISTENER_H
#pragma once

#include <Surelog/API/PythonAPI.h>
#include <Surelog/ErrorReporting/ErrorDefinition.h>
#include <Surelog/ErrorReporting/Location.h>
#include <parser/SV3_1aParserBaseListener.h>

namespace SURELOG {

class PythonListen;

class SV3_1aPythonListener : public SV3_1aParserBaseListener {
private:
  PythonListen* m_pl = nullptr;
  PyThreadState* m_interpState = nullptr;
  antlr4::CommonTokenStream* m_tokens = nullptr;
  uint32_t m_lineOffset = 0;

public:
  SV3_1aPythonListener(PythonListen* pf, PyThreadState* interpState, antlr4::CommonTokenStream* tokens, uint32_t lineOffset);
  SV3_1aPythonListener(const SV3_1aPythonListener& orig);
  ~SV3_1aPythonListener() override;

  PyThreadState* getPyThreadState() { return m_interpState; }
  PythonListen*  getPythonListen() { return m_pl; }
  antlr4::CommonTokenStream* getTokenStream() { return m_tokens; }

  void logError(ErrorDefinition::ErrorType error, antlr4::ParserRuleContext* ctx, std::string object, bool printColumn = false);
  void logError(ErrorDefinition::ErrorType, Location& loc, bool showDuplicates = false);
  void logError(ErrorDefinition::ErrorType, Location& loc, Location& extraLoc, bool showDuplicates = false);

  void enterTop_level_rule(SV3_1aParser::Top_level_ruleContext * ctx) override {
    PythonAPI::evalScript("enterTop_level_rule", this, (parser_rule_context *) ctx);
  }
  void exitTop_level_rule(SV3_1aParser::Top_level_ruleContext * ctx) override {
    PythonAPI::evalScript("exitTop_level_rule", this, (parser_rule_context *) ctx);
  }

  void enterTop_level_library_rule(SV3_1aParser::Top_level_library_ruleContext * ctx) override {
    PythonAPI::evalScript("enterTop_level_library_rule", this, (parser_rule_context *) ctx);
  }
  void exitTop_level_library_rule(SV3_1aParser::Top_level_library_ruleContext * ctx) override {
    PythonAPI::evalScript("exitTop_level_library_rule", this, (parser_rule_context *) ctx);
  }

  void enterLibrary_text(SV3_1aParser::Library_textContext * ctx) override {
    PythonAPI::evalScript("enterLibrary_text", this, (parser_rule_context *) ctx);
  }
  void exitLibrary_text(SV3_1aParser::Library_textContext * ctx) override {
    PythonAPI::evalScript("exitLibrary_text", this, (parser_rule_context *) ctx);
  }

  void enterLibrary_descriptions(SV3_1aParser::Library_descriptionsContext * ctx) override {
    PythonAPI::evalScript("enterLibrary_descriptions", this, (parser_rule_context *) ctx);
  }
  void exitLibrary_descriptions(SV3_1aParser::Library_descriptionsContext * ctx) override {
    PythonAPI::evalScript("exitLibrary_descriptions", this, (parser_rule_context *) ctx);
  }

  void enterLibrary_declaration(SV3_1aParser::Library_declarationContext * ctx) override {
    PythonAPI::evalScript("enterLibrary_declaration", this, (parser_rule_context *) ctx);
  }
  void exitLibrary_declaration(SV3_1aParser::Library_declarationContext * ctx) override {
    PythonAPI::evalScript("exitLibrary_declaration", this, (parser_rule_context *) ctx);
  }

  void enterFile_path_spec(SV3_1aParser::File_path_specContext * ctx) override {
    PythonAPI::evalScript("enterFile_path_spec", this, (parser_rule_context *) ctx);
  }
  void exitFile_path_spec(SV3_1aParser::File_path_specContext * ctx) override {
    PythonAPI::evalScript("exitFile_path_spec", this, (parser_rule_context *) ctx);
  }

  void enterInclude_statement(SV3_1aParser::Include_statementContext * ctx) override {
    PythonAPI::evalScript("enterInclude_statement", this, (parser_rule_context *) ctx);
  }
  void exitInclude_statement(SV3_1aParser::Include_statementContext * ctx) override {
    PythonAPI::evalScript("exitInclude_statement", this, (parser_rule_context *) ctx);
  }

  void enterSource_text(SV3_1aParser::Source_textContext * ctx) override {
    PythonAPI::evalScript("enterSource_text", this, (parser_rule_context *) ctx);
  }
  void exitSource_text(SV3_1aParser::Source_textContext * ctx) override {
    PythonAPI::evalScript("exitSource_text", this, (parser_rule_context *) ctx);
  }

  void enterNull_rule(SV3_1aParser::Null_ruleContext * ctx) override {
    PythonAPI::evalScript("enterNull_rule", this, (parser_rule_context *) ctx);
  }
  void exitNull_rule(SV3_1aParser::Null_ruleContext * ctx) override {
    PythonAPI::evalScript("exitNull_rule", this, (parser_rule_context *) ctx);
  }

  void enterDescription(SV3_1aParser::DescriptionContext * ctx) override {
    PythonAPI::evalScript("enterDescription", this, (parser_rule_context *) ctx);
  }
  void exitDescription(SV3_1aParser::DescriptionContext * ctx) override {
    PythonAPI::evalScript("exitDescription", this, (parser_rule_context *) ctx);
  }

  void enterModule_nonansi_header(SV3_1aParser::Module_nonansi_headerContext * ctx) override {
    PythonAPI::evalScript("enterModule_nonansi_header", this, (parser_rule_context *) ctx);
  }
  void exitModule_nonansi_header(SV3_1aParser::Module_nonansi_headerContext * ctx) override {
    PythonAPI::evalScript("exitModule_nonansi_header", this, (parser_rule_context *) ctx);
  }

  void enterModule_ansi_header(SV3_1aParser::Module_ansi_headerContext * ctx) override {
    PythonAPI::evalScript("enterModule_ansi_header", this, (parser_rule_context *) ctx);
  }
  void exitModule_ansi_header(SV3_1aParser::Module_ansi_headerContext * ctx) override {
    PythonAPI::evalScript("exitModule_ansi_header", this, (parser_rule_context *) ctx);
  }

  void enterModule_declaration(SV3_1aParser::Module_declarationContext * ctx) override {
    PythonAPI::evalScript("enterModule_declaration", this, (parser_rule_context *) ctx);
  }
  void exitModule_declaration(SV3_1aParser::Module_declarationContext * ctx) override {
    PythonAPI::evalScript("exitModule_declaration", this, (parser_rule_context *) ctx);
  }

  void enterModule_keyword(SV3_1aParser::Module_keywordContext * ctx) override {
    PythonAPI::evalScript("enterModule_keyword", this, (parser_rule_context *) ctx);
  }
  void exitModule_keyword(SV3_1aParser::Module_keywordContext * ctx) override {
    PythonAPI::evalScript("exitModule_keyword", this, (parser_rule_context *) ctx);
  }

  void enterInterface_nonansi_header(SV3_1aParser::Interface_nonansi_headerContext * ctx) override {
    PythonAPI::evalScript("enterInterface_nonansi_header", this, (parser_rule_context *) ctx);
  }
  void exitInterface_nonansi_header(SV3_1aParser::Interface_nonansi_headerContext * ctx) override {
    PythonAPI::evalScript("exitInterface_nonansi_header", this, (parser_rule_context *) ctx);
  }

  void enterInterface_ansi_header(SV3_1aParser::Interface_ansi_headerContext * ctx) override {
    PythonAPI::evalScript("enterInterface_ansi_header", this, (parser_rule_context *) ctx);
  }
  void exitInterface_ansi_header(SV3_1aParser::Interface_ansi_headerContext * ctx) override {
    PythonAPI::evalScript("exitInterface_ansi_header", this, (parser_rule_context *) ctx);
  }

  void enterInterface_declaration(SV3_1aParser::Interface_declarationContext * ctx) override {
    PythonAPI::evalScript("enterInterface_declaration", this, (parser_rule_context *) ctx);
  }
  void exitInterface_declaration(SV3_1aParser::Interface_declarationContext * ctx) override {
    PythonAPI::evalScript("exitInterface_declaration", this, (parser_rule_context *) ctx);
  }

  void enterProgram_nonansi_header(SV3_1aParser::Program_nonansi_headerContext * ctx) override {
    PythonAPI::evalScript("enterProgram_nonansi_header", this, (parser_rule_context *) ctx);
  }
  void exitProgram_nonansi_header(SV3_1aParser::Program_nonansi_headerContext * ctx) override {
    PythonAPI::evalScript("exitProgram_nonansi_header", this, (parser_rule_context *) ctx);
  }

  void enterProgram_ansi_header(SV3_1aParser::Program_ansi_headerContext * ctx) override {
    PythonAPI::evalScript("enterProgram_ansi_header", this, (parser_rule_context *) ctx);
  }
  void exitProgram_ansi_header(SV3_1aParser::Program_ansi_headerContext * ctx) override {
    PythonAPI::evalScript("exitProgram_ansi_header", this, (parser_rule_context *) ctx);
  }

  void enterChecker_declaration(SV3_1aParser::Checker_declarationContext * ctx) override {
    PythonAPI::evalScript("enterChecker_declaration", this, (parser_rule_context *) ctx);
  }
  void exitChecker_declaration(SV3_1aParser::Checker_declarationContext * ctx) override {
    PythonAPI::evalScript("exitChecker_declaration", this, (parser_rule_context *) ctx);
  }

  void enterProgram_declaration(SV3_1aParser::Program_declarationContext * ctx) override {
    PythonAPI::evalScript("enterProgram_declaration", this, (parser_rule_context *) ctx);
  }
  void exitProgram_declaration(SV3_1aParser::Program_declarationContext * ctx) override {
    PythonAPI::evalScript("exitProgram_declaration", this, (parser_rule_context *) ctx);
  }

  void enterClass_declaration(SV3_1aParser::Class_declarationContext * ctx) override {
    PythonAPI::evalScript("enterClass_declaration", this, (parser_rule_context *) ctx);
  }
  void exitClass_declaration(SV3_1aParser::Class_declarationContext * ctx) override {
    PythonAPI::evalScript("exitClass_declaration", this, (parser_rule_context *) ctx);
  }

  void enterInterface_class_type(SV3_1aParser::Interface_class_typeContext * ctx) override {
    PythonAPI::evalScript("enterInterface_class_type", this, (parser_rule_context *) ctx);
  }
  void exitInterface_class_type(SV3_1aParser::Interface_class_typeContext * ctx) override {
    PythonAPI::evalScript("exitInterface_class_type", this, (parser_rule_context *) ctx);
  }

  void enterInterface_class_declaration(SV3_1aParser::Interface_class_declarationContext * ctx) override {
    PythonAPI::evalScript("enterInterface_class_declaration", this, (parser_rule_context *) ctx);
  }
  void exitInterface_class_declaration(SV3_1aParser::Interface_class_declarationContext * ctx) override {
    PythonAPI::evalScript("exitInterface_class_declaration", this, (parser_rule_context *) ctx);
  }

  void enterInterface_class_item(SV3_1aParser::Interface_class_itemContext * ctx) override {
    PythonAPI::evalScript("enterInterface_class_item", this, (parser_rule_context *) ctx);
  }
  void exitInterface_class_item(SV3_1aParser::Interface_class_itemContext * ctx) override {
    PythonAPI::evalScript("exitInterface_class_item", this, (parser_rule_context *) ctx);
  }

  void enterInterface_class_method(SV3_1aParser::Interface_class_methodContext * ctx) override {
    PythonAPI::evalScript("enterInterface_class_method", this, (parser_rule_context *) ctx);
  }
  void exitInterface_class_method(SV3_1aParser::Interface_class_methodContext * ctx) override {
    PythonAPI::evalScript("exitInterface_class_method", this, (parser_rule_context *) ctx);
  }

  void enterPackage_declaration(SV3_1aParser::Package_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPackage_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPackage_declaration(SV3_1aParser::Package_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPackage_declaration", this, (parser_rule_context *) ctx);
  }

  void enterTimeUnitsDecl_TimeUnitDiv(SV3_1aParser::TimeUnitsDecl_TimeUnitDivContext * ctx) override {
    PythonAPI::evalScript("enterTimeUnitsDecl_TimeUnitDiv", this, (parser_rule_context *) ctx);
  }
  void exitTimeUnitsDecl_TimeUnitDiv(SV3_1aParser::TimeUnitsDecl_TimeUnitDivContext * ctx) override {
    PythonAPI::evalScript("exitTimeUnitsDecl_TimeUnitDiv", this, (parser_rule_context *) ctx);
  }

  void enterTimeUnitsDecl_TimeUnit(SV3_1aParser::TimeUnitsDecl_TimeUnitContext * ctx) override {
    PythonAPI::evalScript("enterTimeUnitsDecl_TimeUnit", this, (parser_rule_context *) ctx);
  }
  void exitTimeUnitsDecl_TimeUnit(SV3_1aParser::TimeUnitsDecl_TimeUnitContext * ctx) override {
    PythonAPI::evalScript("exitTimeUnitsDecl_TimeUnit", this, (parser_rule_context *) ctx);
  }

  void enterTimeUnitsDecl_TimePrecision(SV3_1aParser::TimeUnitsDecl_TimePrecisionContext * ctx) override {
    PythonAPI::evalScript("enterTimeUnitsDecl_TimePrecision", this, (parser_rule_context *) ctx);
  }
  void exitTimeUnitsDecl_TimePrecision(SV3_1aParser::TimeUnitsDecl_TimePrecisionContext * ctx) override {
    PythonAPI::evalScript("exitTimeUnitsDecl_TimePrecision", this, (parser_rule_context *) ctx);
  }

  void enterTimeUnitsDecl_TimeUnitTimePrecision(SV3_1aParser::TimeUnitsDecl_TimeUnitTimePrecisionContext * ctx) override {
    PythonAPI::evalScript("enterTimeUnitsDecl_TimeUnitTimePrecision", this, (parser_rule_context *) ctx);
  }
  void exitTimeUnitsDecl_TimeUnitTimePrecision(SV3_1aParser::TimeUnitsDecl_TimeUnitTimePrecisionContext * ctx) override {
    PythonAPI::evalScript("exitTimeUnitsDecl_TimeUnitTimePrecision", this, (parser_rule_context *) ctx);
  }

  void enterTimeUnitsDecl_TimePrecisionTimeUnit(SV3_1aParser::TimeUnitsDecl_TimePrecisionTimeUnitContext * ctx) override {
    PythonAPI::evalScript("enterTimeUnitsDecl_TimePrecisionTimeUnit", this, (parser_rule_context *) ctx);
  }
  void exitTimeUnitsDecl_TimePrecisionTimeUnit(SV3_1aParser::TimeUnitsDecl_TimePrecisionTimeUnitContext * ctx) override {
    PythonAPI::evalScript("exitTimeUnitsDecl_TimePrecisionTimeUnit", this, (parser_rule_context *) ctx);
  }

  void enterParameter_port_list(SV3_1aParser::Parameter_port_listContext * ctx) override {
    PythonAPI::evalScript("enterParameter_port_list", this, (parser_rule_context *) ctx);
  }
  void exitParameter_port_list(SV3_1aParser::Parameter_port_listContext * ctx) override {
    PythonAPI::evalScript("exitParameter_port_list", this, (parser_rule_context *) ctx);
  }

  void enterParameter_port_declaration(SV3_1aParser::Parameter_port_declarationContext * ctx) override {
    PythonAPI::evalScript("enterParameter_port_declaration", this, (parser_rule_context *) ctx);
  }
  void exitParameter_port_declaration(SV3_1aParser::Parameter_port_declarationContext * ctx) override {
    PythonAPI::evalScript("exitParameter_port_declaration", this, (parser_rule_context *) ctx);
  }

  void enterList_of_ports(SV3_1aParser::List_of_portsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_ports", this, (parser_rule_context *) ctx);
  }
  void exitList_of_ports(SV3_1aParser::List_of_portsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_ports", this, (parser_rule_context *) ctx);
  }

  void enterList_of_port_declarations(SV3_1aParser::List_of_port_declarationsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_port_declarations", this, (parser_rule_context *) ctx);
  }
  void exitList_of_port_declarations(SV3_1aParser::List_of_port_declarationsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_port_declarations", this, (parser_rule_context *) ctx);
  }

  void enterPort_declaration(SV3_1aParser::Port_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPort_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPort_declaration(SV3_1aParser::Port_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPort_declaration", this, (parser_rule_context *) ctx);
  }

  void enterPort(SV3_1aParser::PortContext * ctx) override {
    PythonAPI::evalScript("enterPort", this, (parser_rule_context *) ctx);
  }
  void exitPort(SV3_1aParser::PortContext * ctx) override {
    PythonAPI::evalScript("exitPort", this, (parser_rule_context *) ctx);
  }

  void enterPort_expression(SV3_1aParser::Port_expressionContext * ctx) override {
    PythonAPI::evalScript("enterPort_expression", this, (parser_rule_context *) ctx);
  }
  void exitPort_expression(SV3_1aParser::Port_expressionContext * ctx) override {
    PythonAPI::evalScript("exitPort_expression", this, (parser_rule_context *) ctx);
  }

  void enterPort_reference(SV3_1aParser::Port_referenceContext * ctx) override {
    PythonAPI::evalScript("enterPort_reference", this, (parser_rule_context *) ctx);
  }
  void exitPort_reference(SV3_1aParser::Port_referenceContext * ctx) override {
    PythonAPI::evalScript("exitPort_reference", this, (parser_rule_context *) ctx);
  }

  void enterPort_direction(SV3_1aParser::Port_directionContext * ctx) override {
    PythonAPI::evalScript("enterPort_direction", this, (parser_rule_context *) ctx);
  }
  void exitPort_direction(SV3_1aParser::Port_directionContext * ctx) override {
    PythonAPI::evalScript("exitPort_direction", this, (parser_rule_context *) ctx);
  }

  void enterNet_port_header(SV3_1aParser::Net_port_headerContext * ctx) override {
    PythonAPI::evalScript("enterNet_port_header", this, (parser_rule_context *) ctx);
  }
  void exitNet_port_header(SV3_1aParser::Net_port_headerContext * ctx) override {
    PythonAPI::evalScript("exitNet_port_header", this, (parser_rule_context *) ctx);
  }

  void enterVariable_port_header(SV3_1aParser::Variable_port_headerContext * ctx) override {
    PythonAPI::evalScript("enterVariable_port_header", this, (parser_rule_context *) ctx);
  }
  void exitVariable_port_header(SV3_1aParser::Variable_port_headerContext * ctx) override {
    PythonAPI::evalScript("exitVariable_port_header", this, (parser_rule_context *) ctx);
  }

  void enterInterface_port_header(SV3_1aParser::Interface_port_headerContext * ctx) override {
    PythonAPI::evalScript("enterInterface_port_header", this, (parser_rule_context *) ctx);
  }
  void exitInterface_port_header(SV3_1aParser::Interface_port_headerContext * ctx) override {
    PythonAPI::evalScript("exitInterface_port_header", this, (parser_rule_context *) ctx);
  }

  void enterAnsi_port_declaration(SV3_1aParser::Ansi_port_declarationContext * ctx) override {
    PythonAPI::evalScript("enterAnsi_port_declaration", this, (parser_rule_context *) ctx);
  }
  void exitAnsi_port_declaration(SV3_1aParser::Ansi_port_declarationContext * ctx) override {
    PythonAPI::evalScript("exitAnsi_port_declaration", this, (parser_rule_context *) ctx);
  }

  void enterElaboration_system_task(SV3_1aParser::Elaboration_system_taskContext * ctx) override {
    PythonAPI::evalScript("enterElaboration_system_task", this, (parser_rule_context *) ctx);
  }
  void exitElaboration_system_task(SV3_1aParser::Elaboration_system_taskContext * ctx) override {
    PythonAPI::evalScript("exitElaboration_system_task", this, (parser_rule_context *) ctx);
  }

  void enterModule_common_item(SV3_1aParser::Module_common_itemContext * ctx) override {
    PythonAPI::evalScript("enterModule_common_item", this, (parser_rule_context *) ctx);
  }
  void exitModule_common_item(SV3_1aParser::Module_common_itemContext * ctx) override {
    PythonAPI::evalScript("exitModule_common_item", this, (parser_rule_context *) ctx);
  }

  void enterModule_item(SV3_1aParser::Module_itemContext * ctx) override {
    PythonAPI::evalScript("enterModule_item", this, (parser_rule_context *) ctx);
  }
  void exitModule_item(SV3_1aParser::Module_itemContext * ctx) override {
    PythonAPI::evalScript("exitModule_item", this, (parser_rule_context *) ctx);
  }

  void enterModule_or_generate_item(SV3_1aParser::Module_or_generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterModule_or_generate_item", this, (parser_rule_context *) ctx);
  }
  void exitModule_or_generate_item(SV3_1aParser::Module_or_generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitModule_or_generate_item", this, (parser_rule_context *) ctx);
  }

  void enterModule_or_generate_item_declaration(SV3_1aParser::Module_or_generate_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterModule_or_generate_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitModule_or_generate_item_declaration(SV3_1aParser::Module_or_generate_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitModule_or_generate_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterNon_port_module_item(SV3_1aParser::Non_port_module_itemContext * ctx) override {
    PythonAPI::evalScript("enterNon_port_module_item", this, (parser_rule_context *) ctx);
  }
  void exitNon_port_module_item(SV3_1aParser::Non_port_module_itemContext * ctx) override {
    PythonAPI::evalScript("exitNon_port_module_item", this, (parser_rule_context *) ctx);
  }

  void enterParameter_override(SV3_1aParser::Parameter_overrideContext * ctx) override {
    PythonAPI::evalScript("enterParameter_override", this, (parser_rule_context *) ctx);
  }
  void exitParameter_override(SV3_1aParser::Parameter_overrideContext * ctx) override {
    PythonAPI::evalScript("exitParameter_override", this, (parser_rule_context *) ctx);
  }

  void enterBind_directive(SV3_1aParser::Bind_directiveContext * ctx) override {
    PythonAPI::evalScript("enterBind_directive", this, (parser_rule_context *) ctx);
  }
  void exitBind_directive(SV3_1aParser::Bind_directiveContext * ctx) override {
    PythonAPI::evalScript("exitBind_directive", this, (parser_rule_context *) ctx);
  }

  void enterBind_instantiation(SV3_1aParser::Bind_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterBind_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitBind_instantiation(SV3_1aParser::Bind_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitBind_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterInterface_or_generate_item(SV3_1aParser::Interface_or_generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterInterface_or_generate_item", this, (parser_rule_context *) ctx);
  }
  void exitInterface_or_generate_item(SV3_1aParser::Interface_or_generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitInterface_or_generate_item", this, (parser_rule_context *) ctx);
  }

  void enterExtern_tf_declaration(SV3_1aParser::Extern_tf_declarationContext * ctx) override {
    PythonAPI::evalScript("enterExtern_tf_declaration", this, (parser_rule_context *) ctx);
  }
  void exitExtern_tf_declaration(SV3_1aParser::Extern_tf_declarationContext * ctx) override {
    PythonAPI::evalScript("exitExtern_tf_declaration", this, (parser_rule_context *) ctx);
  }

  void enterInterface_item(SV3_1aParser::Interface_itemContext * ctx) override {
    PythonAPI::evalScript("enterInterface_item", this, (parser_rule_context *) ctx);
  }
  void exitInterface_item(SV3_1aParser::Interface_itemContext * ctx) override {
    PythonAPI::evalScript("exitInterface_item", this, (parser_rule_context *) ctx);
  }

  void enterNon_port_interface_item(SV3_1aParser::Non_port_interface_itemContext * ctx) override {
    PythonAPI::evalScript("enterNon_port_interface_item", this, (parser_rule_context *) ctx);
  }
  void exitNon_port_interface_item(SV3_1aParser::Non_port_interface_itemContext * ctx) override {
    PythonAPI::evalScript("exitNon_port_interface_item", this, (parser_rule_context *) ctx);
  }

  void enterProgram_item(SV3_1aParser::Program_itemContext * ctx) override {
    PythonAPI::evalScript("enterProgram_item", this, (parser_rule_context *) ctx);
  }
  void exitProgram_item(SV3_1aParser::Program_itemContext * ctx) override {
    PythonAPI::evalScript("exitProgram_item", this, (parser_rule_context *) ctx);
  }

  void enterNon_port_program_item(SV3_1aParser::Non_port_program_itemContext * ctx) override {
    PythonAPI::evalScript("enterNon_port_program_item", this, (parser_rule_context *) ctx);
  }
  void exitNon_port_program_item(SV3_1aParser::Non_port_program_itemContext * ctx) override {
    PythonAPI::evalScript("exitNon_port_program_item", this, (parser_rule_context *) ctx);
  }

  void enterProgram_generate_item(SV3_1aParser::Program_generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterProgram_generate_item", this, (parser_rule_context *) ctx);
  }
  void exitProgram_generate_item(SV3_1aParser::Program_generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitProgram_generate_item", this, (parser_rule_context *) ctx);
  }

  void enterChecker_port_list(SV3_1aParser::Checker_port_listContext * ctx) override {
    PythonAPI::evalScript("enterChecker_port_list", this, (parser_rule_context *) ctx);
  }
  void exitChecker_port_list(SV3_1aParser::Checker_port_listContext * ctx) override {
    PythonAPI::evalScript("exitChecker_port_list", this, (parser_rule_context *) ctx);
  }

  void enterChecker_port_item(SV3_1aParser::Checker_port_itemContext * ctx) override {
    PythonAPI::evalScript("enterChecker_port_item", this, (parser_rule_context *) ctx);
  }
  void exitChecker_port_item(SV3_1aParser::Checker_port_itemContext * ctx) override {
    PythonAPI::evalScript("exitChecker_port_item", this, (parser_rule_context *) ctx);
  }

  void enterChecker_or_generate_item(SV3_1aParser::Checker_or_generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterChecker_or_generate_item", this, (parser_rule_context *) ctx);
  }
  void exitChecker_or_generate_item(SV3_1aParser::Checker_or_generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitChecker_or_generate_item", this, (parser_rule_context *) ctx);
  }

  void enterChecker_or_generate_item_declaration(SV3_1aParser::Checker_or_generate_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterChecker_or_generate_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitChecker_or_generate_item_declaration(SV3_1aParser::Checker_or_generate_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitChecker_or_generate_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterChecker_generate_item(SV3_1aParser::Checker_generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterChecker_generate_item", this, (parser_rule_context *) ctx);
  }
  void exitChecker_generate_item(SV3_1aParser::Checker_generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitChecker_generate_item", this, (parser_rule_context *) ctx);
  }

  void enterClass_item(SV3_1aParser::Class_itemContext * ctx) override {
    PythonAPI::evalScript("enterClass_item", this, (parser_rule_context *) ctx);
  }
  void exitClass_item(SV3_1aParser::Class_itemContext * ctx) override {
    PythonAPI::evalScript("exitClass_item", this, (parser_rule_context *) ctx);
  }

  void enterClass_property(SV3_1aParser::Class_propertyContext * ctx) override {
    PythonAPI::evalScript("enterClass_property", this, (parser_rule_context *) ctx);
  }
  void exitClass_property(SV3_1aParser::Class_propertyContext * ctx) override {
    PythonAPI::evalScript("exitClass_property", this, (parser_rule_context *) ctx);
  }

  void enterPure_virtual_qualifier(SV3_1aParser::Pure_virtual_qualifierContext * ctx) override {
    PythonAPI::evalScript("enterPure_virtual_qualifier", this, (parser_rule_context *) ctx);
  }
  void exitPure_virtual_qualifier(SV3_1aParser::Pure_virtual_qualifierContext * ctx) override {
    PythonAPI::evalScript("exitPure_virtual_qualifier", this, (parser_rule_context *) ctx);
  }

  void enterExtern_qualifier(SV3_1aParser::Extern_qualifierContext * ctx) override {
    PythonAPI::evalScript("enterExtern_qualifier", this, (parser_rule_context *) ctx);
  }
  void exitExtern_qualifier(SV3_1aParser::Extern_qualifierContext * ctx) override {
    PythonAPI::evalScript("exitExtern_qualifier", this, (parser_rule_context *) ctx);
  }

  void enterClass_method(SV3_1aParser::Class_methodContext * ctx) override {
    PythonAPI::evalScript("enterClass_method", this, (parser_rule_context *) ctx);
  }
  void exitClass_method(SV3_1aParser::Class_methodContext * ctx) override {
    PythonAPI::evalScript("exitClass_method", this, (parser_rule_context *) ctx);
  }

  void enterClass_constructor_prototype(SV3_1aParser::Class_constructor_prototypeContext * ctx) override {
    PythonAPI::evalScript("enterClass_constructor_prototype", this, (parser_rule_context *) ctx);
  }
  void exitClass_constructor_prototype(SV3_1aParser::Class_constructor_prototypeContext * ctx) override {
    PythonAPI::evalScript("exitClass_constructor_prototype", this, (parser_rule_context *) ctx);
  }

  void enterClass_constraint(SV3_1aParser::Class_constraintContext * ctx) override {
    PythonAPI::evalScript("enterClass_constraint", this, (parser_rule_context *) ctx);
  }
  void exitClass_constraint(SV3_1aParser::Class_constraintContext * ctx) override {
    PythonAPI::evalScript("exitClass_constraint", this, (parser_rule_context *) ctx);
  }

  void enterClassItemQualifier_Static(SV3_1aParser::ClassItemQualifier_StaticContext * ctx) override {
    PythonAPI::evalScript("enterClassItemQualifier_Static", this, (parser_rule_context *) ctx);
  }
  void exitClassItemQualifier_Static(SV3_1aParser::ClassItemQualifier_StaticContext * ctx) override {
    PythonAPI::evalScript("exitClassItemQualifier_Static", this, (parser_rule_context *) ctx);
  }

  void enterClassItemQualifier_Protected(SV3_1aParser::ClassItemQualifier_ProtectedContext * ctx) override {
    PythonAPI::evalScript("enterClassItemQualifier_Protected", this, (parser_rule_context *) ctx);
  }
  void exitClassItemQualifier_Protected(SV3_1aParser::ClassItemQualifier_ProtectedContext * ctx) override {
    PythonAPI::evalScript("exitClassItemQualifier_Protected", this, (parser_rule_context *) ctx);
  }

  void enterClassItemQualifier_Local(SV3_1aParser::ClassItemQualifier_LocalContext * ctx) override {
    PythonAPI::evalScript("enterClassItemQualifier_Local", this, (parser_rule_context *) ctx);
  }
  void exitClassItemQualifier_Local(SV3_1aParser::ClassItemQualifier_LocalContext * ctx) override {
    PythonAPI::evalScript("exitClassItemQualifier_Local", this, (parser_rule_context *) ctx);
  }

  void enterPropQualifier_Rand(SV3_1aParser::PropQualifier_RandContext * ctx) override {
    PythonAPI::evalScript("enterPropQualifier_Rand", this, (parser_rule_context *) ctx);
  }
  void exitPropQualifier_Rand(SV3_1aParser::PropQualifier_RandContext * ctx) override {
    PythonAPI::evalScript("exitPropQualifier_Rand", this, (parser_rule_context *) ctx);
  }

  void enterPropQualifier_Randc(SV3_1aParser::PropQualifier_RandcContext * ctx) override {
    PythonAPI::evalScript("enterPropQualifier_Randc", this, (parser_rule_context *) ctx);
  }
  void exitPropQualifier_Randc(SV3_1aParser::PropQualifier_RandcContext * ctx) override {
    PythonAPI::evalScript("exitPropQualifier_Randc", this, (parser_rule_context *) ctx);
  }

  void enterPropQualifier_ClassItem(SV3_1aParser::PropQualifier_ClassItemContext * ctx) override {
    PythonAPI::evalScript("enterPropQualifier_ClassItem", this, (parser_rule_context *) ctx);
  }
  void exitPropQualifier_ClassItem(SV3_1aParser::PropQualifier_ClassItemContext * ctx) override {
    PythonAPI::evalScript("exitPropQualifier_ClassItem", this, (parser_rule_context *) ctx);
  }

  void enterMethodQualifier_Virtual(SV3_1aParser::MethodQualifier_VirtualContext * ctx) override {
    PythonAPI::evalScript("enterMethodQualifier_Virtual", this, (parser_rule_context *) ctx);
  }
  void exitMethodQualifier_Virtual(SV3_1aParser::MethodQualifier_VirtualContext * ctx) override {
    PythonAPI::evalScript("exitMethodQualifier_Virtual", this, (parser_rule_context *) ctx);
  }

  void enterMethodQualifier_ClassItem(SV3_1aParser::MethodQualifier_ClassItemContext * ctx) override {
    PythonAPI::evalScript("enterMethodQualifier_ClassItem", this, (parser_rule_context *) ctx);
  }
  void exitMethodQualifier_ClassItem(SV3_1aParser::MethodQualifier_ClassItemContext * ctx) override {
    PythonAPI::evalScript("exitMethodQualifier_ClassItem", this, (parser_rule_context *) ctx);
  }

  void enterMethod_prototype(SV3_1aParser::Method_prototypeContext * ctx) override {
    PythonAPI::evalScript("enterMethod_prototype", this, (parser_rule_context *) ctx);
  }
  void exitMethod_prototype(SV3_1aParser::Method_prototypeContext * ctx) override {
    PythonAPI::evalScript("exitMethod_prototype", this, (parser_rule_context *) ctx);
  }

  void enterSuper_dot_new(SV3_1aParser::Super_dot_newContext * ctx) override {
    PythonAPI::evalScript("enterSuper_dot_new", this, (parser_rule_context *) ctx);
  }
  void exitSuper_dot_new(SV3_1aParser::Super_dot_newContext * ctx) override {
    PythonAPI::evalScript("exitSuper_dot_new", this, (parser_rule_context *) ctx);
  }

  void enterClass_constructor_declaration(SV3_1aParser::Class_constructor_declarationContext * ctx) override {
    PythonAPI::evalScript("enterClass_constructor_declaration", this, (parser_rule_context *) ctx);
  }
  void exitClass_constructor_declaration(SV3_1aParser::Class_constructor_declarationContext * ctx) override {
    PythonAPI::evalScript("exitClass_constructor_declaration", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_declaration(SV3_1aParser::Constraint_declarationContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_declaration", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_declaration(SV3_1aParser::Constraint_declarationContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_declaration", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_block(SV3_1aParser::Constraint_blockContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_block", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_block(SV3_1aParser::Constraint_blockContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_block", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_block_item(SV3_1aParser::Constraint_block_itemContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_block_item", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_block_item(SV3_1aParser::Constraint_block_itemContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_block_item", this, (parser_rule_context *) ctx);
  }

  void enterSolve_before_list(SV3_1aParser::Solve_before_listContext * ctx) override {
    PythonAPI::evalScript("enterSolve_before_list", this, (parser_rule_context *) ctx);
  }
  void exitSolve_before_list(SV3_1aParser::Solve_before_listContext * ctx) override {
    PythonAPI::evalScript("exitSolve_before_list", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_primary(SV3_1aParser::Constraint_primaryContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_primary", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_primary(SV3_1aParser::Constraint_primaryContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_primary", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_expression(SV3_1aParser::Constraint_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_expression", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_expression(SV3_1aParser::Constraint_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_expression", this, (parser_rule_context *) ctx);
  }

  void enterUniqueness_constraint(SV3_1aParser::Uniqueness_constraintContext * ctx) override {
    PythonAPI::evalScript("enterUniqueness_constraint", this, (parser_rule_context *) ctx);
  }
  void exitUniqueness_constraint(SV3_1aParser::Uniqueness_constraintContext * ctx) override {
    PythonAPI::evalScript("exitUniqueness_constraint", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_set(SV3_1aParser::Constraint_setContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_set", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_set(SV3_1aParser::Constraint_setContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_set", this, (parser_rule_context *) ctx);
  }

  void enterDist_list(SV3_1aParser::Dist_listContext * ctx) override {
    PythonAPI::evalScript("enterDist_list", this, (parser_rule_context *) ctx);
  }
  void exitDist_list(SV3_1aParser::Dist_listContext * ctx) override {
    PythonAPI::evalScript("exitDist_list", this, (parser_rule_context *) ctx);
  }

  void enterDist_item(SV3_1aParser::Dist_itemContext * ctx) override {
    PythonAPI::evalScript("enterDist_item", this, (parser_rule_context *) ctx);
  }
  void exitDist_item(SV3_1aParser::Dist_itemContext * ctx) override {
    PythonAPI::evalScript("exitDist_item", this, (parser_rule_context *) ctx);
  }

  void enterDistWeight_AssignValue(SV3_1aParser::DistWeight_AssignValueContext * ctx) override {
    PythonAPI::evalScript("enterDistWeight_AssignValue", this, (parser_rule_context *) ctx);
  }
  void exitDistWeight_AssignValue(SV3_1aParser::DistWeight_AssignValueContext * ctx) override {
    PythonAPI::evalScript("exitDistWeight_AssignValue", this, (parser_rule_context *) ctx);
  }

  void enterDistWeight_AssignRange(SV3_1aParser::DistWeight_AssignRangeContext * ctx) override {
    PythonAPI::evalScript("enterDistWeight_AssignRange", this, (parser_rule_context *) ctx);
  }
  void exitDistWeight_AssignRange(SV3_1aParser::DistWeight_AssignRangeContext * ctx) override {
    PythonAPI::evalScript("exitDistWeight_AssignRange", this, (parser_rule_context *) ctx);
  }

  void enterConstraint_prototype(SV3_1aParser::Constraint_prototypeContext * ctx) override {
    PythonAPI::evalScript("enterConstraint_prototype", this, (parser_rule_context *) ctx);
  }
  void exitConstraint_prototype(SV3_1aParser::Constraint_prototypeContext * ctx) override {
    PythonAPI::evalScript("exitConstraint_prototype", this, (parser_rule_context *) ctx);
  }

  void enterExtern_constraint_declaration(SV3_1aParser::Extern_constraint_declarationContext * ctx) override {
    PythonAPI::evalScript("enterExtern_constraint_declaration", this, (parser_rule_context *) ctx);
  }
  void exitExtern_constraint_declaration(SV3_1aParser::Extern_constraint_declarationContext * ctx) override {
    PythonAPI::evalScript("exitExtern_constraint_declaration", this, (parser_rule_context *) ctx);
  }

  void enterIdentifier_list(SV3_1aParser::Identifier_listContext * ctx) override {
    PythonAPI::evalScript("enterIdentifier_list", this, (parser_rule_context *) ctx);
  }
  void exitIdentifier_list(SV3_1aParser::Identifier_listContext * ctx) override {
    PythonAPI::evalScript("exitIdentifier_list", this, (parser_rule_context *) ctx);
  }

  void enterPackage_item(SV3_1aParser::Package_itemContext * ctx) override {
    PythonAPI::evalScript("enterPackage_item", this, (parser_rule_context *) ctx);
  }
  void exitPackage_item(SV3_1aParser::Package_itemContext * ctx) override {
    PythonAPI::evalScript("exitPackage_item", this, (parser_rule_context *) ctx);
  }

  void enterPackage_or_generate_item_declaration(SV3_1aParser::Package_or_generate_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPackage_or_generate_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPackage_or_generate_item_declaration(SV3_1aParser::Package_or_generate_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPackage_or_generate_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterAnonymous_program(SV3_1aParser::Anonymous_programContext * ctx) override {
    PythonAPI::evalScript("enterAnonymous_program", this, (parser_rule_context *) ctx);
  }
  void exitAnonymous_program(SV3_1aParser::Anonymous_programContext * ctx) override {
    PythonAPI::evalScript("exitAnonymous_program", this, (parser_rule_context *) ctx);
  }

  void enterAnonymous_program_item(SV3_1aParser::Anonymous_program_itemContext * ctx) override {
    PythonAPI::evalScript("enterAnonymous_program_item", this, (parser_rule_context *) ctx);
  }
  void exitAnonymous_program_item(SV3_1aParser::Anonymous_program_itemContext * ctx) override {
    PythonAPI::evalScript("exitAnonymous_program_item", this, (parser_rule_context *) ctx);
  }

  void enterLocal_parameter_declaration(SV3_1aParser::Local_parameter_declarationContext * ctx) override {
    PythonAPI::evalScript("enterLocal_parameter_declaration", this, (parser_rule_context *) ctx);
  }
  void exitLocal_parameter_declaration(SV3_1aParser::Local_parameter_declarationContext * ctx) override {
    PythonAPI::evalScript("exitLocal_parameter_declaration", this, (parser_rule_context *) ctx);
  }

  void enterParameter_declaration(SV3_1aParser::Parameter_declarationContext * ctx) override {
    PythonAPI::evalScript("enterParameter_declaration", this, (parser_rule_context *) ctx);
  }
  void exitParameter_declaration(SV3_1aParser::Parameter_declarationContext * ctx) override {
    PythonAPI::evalScript("exitParameter_declaration", this, (parser_rule_context *) ctx);
  }

  void enterSpecparam_declaration(SV3_1aParser::Specparam_declarationContext * ctx) override {
    PythonAPI::evalScript("enterSpecparam_declaration", this, (parser_rule_context *) ctx);
  }
  void exitSpecparam_declaration(SV3_1aParser::Specparam_declarationContext * ctx) override {
    PythonAPI::evalScript("exitSpecparam_declaration", this, (parser_rule_context *) ctx);
  }

  void enterInout_declaration(SV3_1aParser::Inout_declarationContext * ctx) override {
    PythonAPI::evalScript("enterInout_declaration", this, (parser_rule_context *) ctx);
  }
  void exitInout_declaration(SV3_1aParser::Inout_declarationContext * ctx) override {
    PythonAPI::evalScript("exitInout_declaration", this, (parser_rule_context *) ctx);
  }

  void enterInput_declaration(SV3_1aParser::Input_declarationContext * ctx) override {
    PythonAPI::evalScript("enterInput_declaration", this, (parser_rule_context *) ctx);
  }
  void exitInput_declaration(SV3_1aParser::Input_declarationContext * ctx) override {
    PythonAPI::evalScript("exitInput_declaration", this, (parser_rule_context *) ctx);
  }

  void enterOutput_declaration(SV3_1aParser::Output_declarationContext * ctx) override {
    PythonAPI::evalScript("enterOutput_declaration", this, (parser_rule_context *) ctx);
  }
  void exitOutput_declaration(SV3_1aParser::Output_declarationContext * ctx) override {
    PythonAPI::evalScript("exitOutput_declaration", this, (parser_rule_context *) ctx);
  }

  void enterInterface_port_declaration(SV3_1aParser::Interface_port_declarationContext * ctx) override {
    PythonAPI::evalScript("enterInterface_port_declaration", this, (parser_rule_context *) ctx);
  }
  void exitInterface_port_declaration(SV3_1aParser::Interface_port_declarationContext * ctx) override {
    PythonAPI::evalScript("exitInterface_port_declaration", this, (parser_rule_context *) ctx);
  }

  void enterRef_declaration(SV3_1aParser::Ref_declarationContext * ctx) override {
    PythonAPI::evalScript("enterRef_declaration", this, (parser_rule_context *) ctx);
  }
  void exitRef_declaration(SV3_1aParser::Ref_declarationContext * ctx) override {
    PythonAPI::evalScript("exitRef_declaration", this, (parser_rule_context *) ctx);
  }

  void enterData_declaration(SV3_1aParser::Data_declarationContext * ctx) override {
    PythonAPI::evalScript("enterData_declaration", this, (parser_rule_context *) ctx);
  }
  void exitData_declaration(SV3_1aParser::Data_declarationContext * ctx) override {
    PythonAPI::evalScript("exitData_declaration", this, (parser_rule_context *) ctx);
  }

  void enterVariable_impl_declaration(SV3_1aParser::Variable_impl_declarationContext * ctx) override {
    PythonAPI::evalScript("enterVariable_impl_declaration", this, (parser_rule_context *) ctx);
  }
  void exitVariable_impl_declaration(SV3_1aParser::Variable_impl_declarationContext * ctx) override {
    PythonAPI::evalScript("exitVariable_impl_declaration", this, (parser_rule_context *) ctx);
  }

  void enterVariable_declaration(SV3_1aParser::Variable_declarationContext * ctx) override {
    PythonAPI::evalScript("enterVariable_declaration", this, (parser_rule_context *) ctx);
  }
  void exitVariable_declaration(SV3_1aParser::Variable_declarationContext * ctx) override {
    PythonAPI::evalScript("exitVariable_declaration", this, (parser_rule_context *) ctx);
  }

  void enterPackage_import_declaration(SV3_1aParser::Package_import_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPackage_import_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPackage_import_declaration(SV3_1aParser::Package_import_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPackage_import_declaration", this, (parser_rule_context *) ctx);
  }

  void enterPackage_import_item(SV3_1aParser::Package_import_itemContext * ctx) override {
    PythonAPI::evalScript("enterPackage_import_item", this, (parser_rule_context *) ctx);
  }
  void exitPackage_import_item(SV3_1aParser::Package_import_itemContext * ctx) override {
    PythonAPI::evalScript("exitPackage_import_item", this, (parser_rule_context *) ctx);
  }

  void enterPackage_export_declaration(SV3_1aParser::Package_export_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPackage_export_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPackage_export_declaration(SV3_1aParser::Package_export_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPackage_export_declaration", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_declaration(SV3_1aParser::Genvar_declarationContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_declaration", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_declaration(SV3_1aParser::Genvar_declarationContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_declaration", this, (parser_rule_context *) ctx);
  }

  void enterNet_declaration(SV3_1aParser::Net_declarationContext * ctx) override {
    PythonAPI::evalScript("enterNet_declaration", this, (parser_rule_context *) ctx);
  }
  void exitNet_declaration(SV3_1aParser::Net_declarationContext * ctx) override {
    PythonAPI::evalScript("exitNet_declaration", this, (parser_rule_context *) ctx);
  }

  void enterType_declaration(SV3_1aParser::Type_declarationContext * ctx) override {
    PythonAPI::evalScript("enterType_declaration", this, (parser_rule_context *) ctx);
  }
  void exitType_declaration(SV3_1aParser::Type_declarationContext * ctx) override {
    PythonAPI::evalScript("exitType_declaration", this, (parser_rule_context *) ctx);
  }

  void enterEnum_keyword(SV3_1aParser::Enum_keywordContext * ctx) override {
    PythonAPI::evalScript("enterEnum_keyword", this, (parser_rule_context *) ctx);
  }
  void exitEnum_keyword(SV3_1aParser::Enum_keywordContext * ctx) override {
    PythonAPI::evalScript("exitEnum_keyword", this, (parser_rule_context *) ctx);
  }

  void enterStruct_keyword(SV3_1aParser::Struct_keywordContext * ctx) override {
    PythonAPI::evalScript("enterStruct_keyword", this, (parser_rule_context *) ctx);
  }
  void exitStruct_keyword(SV3_1aParser::Struct_keywordContext * ctx) override {
    PythonAPI::evalScript("exitStruct_keyword", this, (parser_rule_context *) ctx);
  }

  void enterUnion_keyword(SV3_1aParser::Union_keywordContext * ctx) override {
    PythonAPI::evalScript("enterUnion_keyword", this, (parser_rule_context *) ctx);
  }
  void exitUnion_keyword(SV3_1aParser::Union_keywordContext * ctx) override {
    PythonAPI::evalScript("exitUnion_keyword", this, (parser_rule_context *) ctx);
  }

  void enterClass_keyword(SV3_1aParser::Class_keywordContext * ctx) override {
    PythonAPI::evalScript("enterClass_keyword", this, (parser_rule_context *) ctx);
  }
  void exitClass_keyword(SV3_1aParser::Class_keywordContext * ctx) override {
    PythonAPI::evalScript("exitClass_keyword", this, (parser_rule_context *) ctx);
  }

  void enterInterface_class_keyword(SV3_1aParser::Interface_class_keywordContext * ctx) override {
    PythonAPI::evalScript("enterInterface_class_keyword", this, (parser_rule_context *) ctx);
  }
  void exitInterface_class_keyword(SV3_1aParser::Interface_class_keywordContext * ctx) override {
    PythonAPI::evalScript("exitInterface_class_keyword", this, (parser_rule_context *) ctx);
  }

  void enterNet_type_declaration(SV3_1aParser::Net_type_declarationContext * ctx) override {
    PythonAPI::evalScript("enterNet_type_declaration", this, (parser_rule_context *) ctx);
  }
  void exitNet_type_declaration(SV3_1aParser::Net_type_declarationContext * ctx) override {
    PythonAPI::evalScript("exitNet_type_declaration", this, (parser_rule_context *) ctx);
  }

  void enterLifetime_Static(SV3_1aParser::Lifetime_StaticContext * ctx) override {
    PythonAPI::evalScript("enterLifetime_Static", this, (parser_rule_context *) ctx);
  }
  void exitLifetime_Static(SV3_1aParser::Lifetime_StaticContext * ctx) override {
    PythonAPI::evalScript("exitLifetime_Static", this, (parser_rule_context *) ctx);
  }

  void enterLifetime_Automatic(SV3_1aParser::Lifetime_AutomaticContext * ctx) override {
    PythonAPI::evalScript("enterLifetime_Automatic", this, (parser_rule_context *) ctx);
  }
  void exitLifetime_Automatic(SV3_1aParser::Lifetime_AutomaticContext * ctx) override {
    PythonAPI::evalScript("exitLifetime_Automatic", this, (parser_rule_context *) ctx);
  }

  void enterCasting_type(SV3_1aParser::Casting_typeContext * ctx) override {
    PythonAPI::evalScript("enterCasting_type", this, (parser_rule_context *) ctx);
  }
  void exitCasting_type(SV3_1aParser::Casting_typeContext * ctx) override {
    PythonAPI::evalScript("exitCasting_type", this, (parser_rule_context *) ctx);
  }

  void enterData_type(SV3_1aParser::Data_typeContext * ctx) override {
    PythonAPI::evalScript("enterData_type", this, (parser_rule_context *) ctx);
  }
  void exitData_type(SV3_1aParser::Data_typeContext * ctx) override {
    PythonAPI::evalScript("exitData_type", this, (parser_rule_context *) ctx);
  }

  void enterPacked_keyword(SV3_1aParser::Packed_keywordContext * ctx) override {
    PythonAPI::evalScript("enterPacked_keyword", this, (parser_rule_context *) ctx);
  }
  void exitPacked_keyword(SV3_1aParser::Packed_keywordContext * ctx) override {
    PythonAPI::evalScript("exitPacked_keyword", this, (parser_rule_context *) ctx);
  }

  void enterString_type(SV3_1aParser::String_typeContext * ctx) override {
    PythonAPI::evalScript("enterString_type", this, (parser_rule_context *) ctx);
  }
  void exitString_type(SV3_1aParser::String_typeContext * ctx) override {
    PythonAPI::evalScript("exitString_type", this, (parser_rule_context *) ctx);
  }

  void enterString_value(SV3_1aParser::String_valueContext * ctx) override {
    PythonAPI::evalScript("enterString_value", this, (parser_rule_context *) ctx);
  }
  void exitString_value(SV3_1aParser::String_valueContext * ctx) override {
    PythonAPI::evalScript("exitString_value", this, (parser_rule_context *) ctx);
  }

  void enterChandle_type(SV3_1aParser::Chandle_typeContext * ctx) override {
    PythonAPI::evalScript("enterChandle_type", this, (parser_rule_context *) ctx);
  }
  void exitChandle_type(SV3_1aParser::Chandle_typeContext * ctx) override {
    PythonAPI::evalScript("exitChandle_type", this, (parser_rule_context *) ctx);
  }

  void enterEvent_type(SV3_1aParser::Event_typeContext * ctx) override {
    PythonAPI::evalScript("enterEvent_type", this, (parser_rule_context *) ctx);
  }
  void exitEvent_type(SV3_1aParser::Event_typeContext * ctx) override {
    PythonAPI::evalScript("exitEvent_type", this, (parser_rule_context *) ctx);
  }

  void enterConst_type(SV3_1aParser::Const_typeContext * ctx) override {
    PythonAPI::evalScript("enterConst_type", this, (parser_rule_context *) ctx);
  }
  void exitConst_type(SV3_1aParser::Const_typeContext * ctx) override {
    PythonAPI::evalScript("exitConst_type", this, (parser_rule_context *) ctx);
  }

  void enterVar_type(SV3_1aParser::Var_typeContext * ctx) override {
    PythonAPI::evalScript("enterVar_type", this, (parser_rule_context *) ctx);
  }
  void exitVar_type(SV3_1aParser::Var_typeContext * ctx) override {
    PythonAPI::evalScript("exitVar_type", this, (parser_rule_context *) ctx);
  }

  void enterData_type_or_implicit(SV3_1aParser::Data_type_or_implicitContext * ctx) override {
    PythonAPI::evalScript("enterData_type_or_implicit", this, (parser_rule_context *) ctx);
  }
  void exitData_type_or_implicit(SV3_1aParser::Data_type_or_implicitContext * ctx) override {
    PythonAPI::evalScript("exitData_type_or_implicit", this, (parser_rule_context *) ctx);
  }

  void enterImplicit_data_type(SV3_1aParser::Implicit_data_typeContext * ctx) override {
    PythonAPI::evalScript("enterImplicit_data_type", this, (parser_rule_context *) ctx);
  }
  void exitImplicit_data_type(SV3_1aParser::Implicit_data_typeContext * ctx) override {
    PythonAPI::evalScript("exitImplicit_data_type", this, (parser_rule_context *) ctx);
  }

  void enterEnum_base_type(SV3_1aParser::Enum_base_typeContext * ctx) override {
    PythonAPI::evalScript("enterEnum_base_type", this, (parser_rule_context *) ctx);
  }
  void exitEnum_base_type(SV3_1aParser::Enum_base_typeContext * ctx) override {
    PythonAPI::evalScript("exitEnum_base_type", this, (parser_rule_context *) ctx);
  }

  void enterEnum_name_declaration(SV3_1aParser::Enum_name_declarationContext * ctx) override {
    PythonAPI::evalScript("enterEnum_name_declaration", this, (parser_rule_context *) ctx);
  }
  void exitEnum_name_declaration(SV3_1aParser::Enum_name_declarationContext * ctx) override {
    PythonAPI::evalScript("exitEnum_name_declaration", this, (parser_rule_context *) ctx);
  }

  void enterClass_scope(SV3_1aParser::Class_scopeContext * ctx) override {
    PythonAPI::evalScript("enterClass_scope", this, (parser_rule_context *) ctx);
  }
  void exitClass_scope(SV3_1aParser::Class_scopeContext * ctx) override {
    PythonAPI::evalScript("exitClass_scope", this, (parser_rule_context *) ctx);
  }

  void enterClass_type(SV3_1aParser::Class_typeContext * ctx) override {
    PythonAPI::evalScript("enterClass_type", this, (parser_rule_context *) ctx);
  }
  void exitClass_type(SV3_1aParser::Class_typeContext * ctx) override {
    PythonAPI::evalScript("exitClass_type", this, (parser_rule_context *) ctx);
  }

  void enterInteger_type(SV3_1aParser::Integer_typeContext * ctx) override {
    PythonAPI::evalScript("enterInteger_type", this, (parser_rule_context *) ctx);
  }
  void exitInteger_type(SV3_1aParser::Integer_typeContext * ctx) override {
    PythonAPI::evalScript("exitInteger_type", this, (parser_rule_context *) ctx);
  }

  void enterInteger_atom_type(SV3_1aParser::Integer_atom_typeContext * ctx) override {
    PythonAPI::evalScript("enterInteger_atom_type", this, (parser_rule_context *) ctx);
  }
  void exitInteger_atom_type(SV3_1aParser::Integer_atom_typeContext * ctx) override {
    PythonAPI::evalScript("exitInteger_atom_type", this, (parser_rule_context *) ctx);
  }

  void enterInteger_vector_type(SV3_1aParser::Integer_vector_typeContext * ctx) override {
    PythonAPI::evalScript("enterInteger_vector_type", this, (parser_rule_context *) ctx);
  }
  void exitInteger_vector_type(SV3_1aParser::Integer_vector_typeContext * ctx) override {
    PythonAPI::evalScript("exitInteger_vector_type", this, (parser_rule_context *) ctx);
  }

  void enterNon_integer_type(SV3_1aParser::Non_integer_typeContext * ctx) override {
    PythonAPI::evalScript("enterNon_integer_type", this, (parser_rule_context *) ctx);
  }
  void exitNon_integer_type(SV3_1aParser::Non_integer_typeContext * ctx) override {
    PythonAPI::evalScript("exitNon_integer_type", this, (parser_rule_context *) ctx);
  }

  void enterNet_type(SV3_1aParser::Net_typeContext * ctx) override {
    PythonAPI::evalScript("enterNet_type", this, (parser_rule_context *) ctx);
  }
  void exitNet_type(SV3_1aParser::Net_typeContext * ctx) override {
    PythonAPI::evalScript("exitNet_type", this, (parser_rule_context *) ctx);
  }

  void enterNet_port_type(SV3_1aParser::Net_port_typeContext * ctx) override {
    PythonAPI::evalScript("enterNet_port_type", this, (parser_rule_context *) ctx);
  }
  void exitNet_port_type(SV3_1aParser::Net_port_typeContext * ctx) override {
    PythonAPI::evalScript("exitNet_port_type", this, (parser_rule_context *) ctx);
  }

  void enterVariable_port_type(SV3_1aParser::Variable_port_typeContext * ctx) override {
    PythonAPI::evalScript("enterVariable_port_type", this, (parser_rule_context *) ctx);
  }
  void exitVariable_port_type(SV3_1aParser::Variable_port_typeContext * ctx) override {
    PythonAPI::evalScript("exitVariable_port_type", this, (parser_rule_context *) ctx);
  }

  void enterVar_data_type(SV3_1aParser::Var_data_typeContext * ctx) override {
    PythonAPI::evalScript("enterVar_data_type", this, (parser_rule_context *) ctx);
  }
  void exitVar_data_type(SV3_1aParser::Var_data_typeContext * ctx) override {
    PythonAPI::evalScript("exitVar_data_type", this, (parser_rule_context *) ctx);
  }

  void enterSigning(SV3_1aParser::SigningContext * ctx) override {
    PythonAPI::evalScript("enterSigning", this, (parser_rule_context *) ctx);
  }
  void exitSigning(SV3_1aParser::SigningContext * ctx) override {
    PythonAPI::evalScript("exitSigning", this, (parser_rule_context *) ctx);
  }

  void enterSimple_type(SV3_1aParser::Simple_typeContext * ctx) override {
    PythonAPI::evalScript("enterSimple_type", this, (parser_rule_context *) ctx);
  }
  void exitSimple_type(SV3_1aParser::Simple_typeContext * ctx) override {
    PythonAPI::evalScript("exitSimple_type", this, (parser_rule_context *) ctx);
  }

  void enterRandomQualifier_Rand(SV3_1aParser::RandomQualifier_RandContext * ctx) override {
    PythonAPI::evalScript("enterRandomQualifier_Rand", this, (parser_rule_context *) ctx);
  }
  void exitRandomQualifier_Rand(SV3_1aParser::RandomQualifier_RandContext * ctx) override {
    PythonAPI::evalScript("exitRandomQualifier_Rand", this, (parser_rule_context *) ctx);
  }

  void enterRandomQualifier_RandC(SV3_1aParser::RandomQualifier_RandCContext * ctx) override {
    PythonAPI::evalScript("enterRandomQualifier_RandC", this, (parser_rule_context *) ctx);
  }
  void exitRandomQualifier_RandC(SV3_1aParser::RandomQualifier_RandCContext * ctx) override {
    PythonAPI::evalScript("exitRandomQualifier_RandC", this, (parser_rule_context *) ctx);
  }

  void enterStruct_union_member(SV3_1aParser::Struct_union_memberContext * ctx) override {
    PythonAPI::evalScript("enterStruct_union_member", this, (parser_rule_context *) ctx);
  }
  void exitStruct_union_member(SV3_1aParser::Struct_union_memberContext * ctx) override {
    PythonAPI::evalScript("exitStruct_union_member", this, (parser_rule_context *) ctx);
  }

  void enterData_type_or_void(SV3_1aParser::Data_type_or_voidContext * ctx) override {
    PythonAPI::evalScript("enterData_type_or_void", this, (parser_rule_context *) ctx);
  }
  void exitData_type_or_void(SV3_1aParser::Data_type_or_voidContext * ctx) override {
    PythonAPI::evalScript("exitData_type_or_void", this, (parser_rule_context *) ctx);
  }

  void enterStruct_union(SV3_1aParser::Struct_unionContext * ctx) override {
    PythonAPI::evalScript("enterStruct_union", this, (parser_rule_context *) ctx);
  }
  void exitStruct_union(SV3_1aParser::Struct_unionContext * ctx) override {
    PythonAPI::evalScript("exitStruct_union", this, (parser_rule_context *) ctx);
  }

  void enterTagged_keyword(SV3_1aParser::Tagged_keywordContext * ctx) override {
    PythonAPI::evalScript("enterTagged_keyword", this, (parser_rule_context *) ctx);
  }
  void exitTagged_keyword(SV3_1aParser::Tagged_keywordContext * ctx) override {
    PythonAPI::evalScript("exitTagged_keyword", this, (parser_rule_context *) ctx);
  }

  void enterType_reference(SV3_1aParser::Type_referenceContext * ctx) override {
    PythonAPI::evalScript("enterType_reference", this, (parser_rule_context *) ctx);
  }
  void exitType_reference(SV3_1aParser::Type_referenceContext * ctx) override {
    PythonAPI::evalScript("exitType_reference", this, (parser_rule_context *) ctx);
  }

  void enterDrive_strength(SV3_1aParser::Drive_strengthContext * ctx) override {
    PythonAPI::evalScript("enterDrive_strength", this, (parser_rule_context *) ctx);
  }
  void exitDrive_strength(SV3_1aParser::Drive_strengthContext * ctx) override {
    PythonAPI::evalScript("exitDrive_strength", this, (parser_rule_context *) ctx);
  }

  void enterStrength0(SV3_1aParser::Strength0Context * ctx) override {
    PythonAPI::evalScript("enterStrength0", this, (parser_rule_context *) ctx);
  }
  void exitStrength0(SV3_1aParser::Strength0Context * ctx) override {
    PythonAPI::evalScript("exitStrength0", this, (parser_rule_context *) ctx);
  }

  void enterStrength1(SV3_1aParser::Strength1Context * ctx) override {
    PythonAPI::evalScript("enterStrength1", this, (parser_rule_context *) ctx);
  }
  void exitStrength1(SV3_1aParser::Strength1Context * ctx) override {
    PythonAPI::evalScript("exitStrength1", this, (parser_rule_context *) ctx);
  }

  void enterCharge_strength(SV3_1aParser::Charge_strengthContext * ctx) override {
    PythonAPI::evalScript("enterCharge_strength", this, (parser_rule_context *) ctx);
  }
  void exitCharge_strength(SV3_1aParser::Charge_strengthContext * ctx) override {
    PythonAPI::evalScript("exitCharge_strength", this, (parser_rule_context *) ctx);
  }

  void enterDelay3(SV3_1aParser::Delay3Context * ctx) override {
    PythonAPI::evalScript("enterDelay3", this, (parser_rule_context *) ctx);
  }
  void exitDelay3(SV3_1aParser::Delay3Context * ctx) override {
    PythonAPI::evalScript("exitDelay3", this, (parser_rule_context *) ctx);
  }

  void enterDelay2(SV3_1aParser::Delay2Context * ctx) override {
    PythonAPI::evalScript("enterDelay2", this, (parser_rule_context *) ctx);
  }
  void exitDelay2(SV3_1aParser::Delay2Context * ctx) override {
    PythonAPI::evalScript("exitDelay2", this, (parser_rule_context *) ctx);
  }

  void enterPound_delay_value(SV3_1aParser::Pound_delay_valueContext * ctx) override {
    PythonAPI::evalScript("enterPound_delay_value", this, (parser_rule_context *) ctx);
  }
  void exitPound_delay_value(SV3_1aParser::Pound_delay_valueContext * ctx) override {
    PythonAPI::evalScript("exitPound_delay_value", this, (parser_rule_context *) ctx);
  }

  void enterDelay_value(SV3_1aParser::Delay_valueContext * ctx) override {
    PythonAPI::evalScript("enterDelay_value", this, (parser_rule_context *) ctx);
  }
  void exitDelay_value(SV3_1aParser::Delay_valueContext * ctx) override {
    PythonAPI::evalScript("exitDelay_value", this, (parser_rule_context *) ctx);
  }

  void enterList_of_defparam_assignments(SV3_1aParser::List_of_defparam_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_defparam_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_defparam_assignments(SV3_1aParser::List_of_defparam_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_defparam_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_interface_identifiers(SV3_1aParser::List_of_interface_identifiersContext * ctx) override {
    PythonAPI::evalScript("enterList_of_interface_identifiers", this, (parser_rule_context *) ctx);
  }
  void exitList_of_interface_identifiers(SV3_1aParser::List_of_interface_identifiersContext * ctx) override {
    PythonAPI::evalScript("exitList_of_interface_identifiers", this, (parser_rule_context *) ctx);
  }

  void enterList_of_net_decl_assignments(SV3_1aParser::List_of_net_decl_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_net_decl_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_net_decl_assignments(SV3_1aParser::List_of_net_decl_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_net_decl_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_param_assignments(SV3_1aParser::List_of_param_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_param_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_param_assignments(SV3_1aParser::List_of_param_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_param_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_port_identifiers(SV3_1aParser::List_of_port_identifiersContext * ctx) override {
    PythonAPI::evalScript("enterList_of_port_identifiers", this, (parser_rule_context *) ctx);
  }
  void exitList_of_port_identifiers(SV3_1aParser::List_of_port_identifiersContext * ctx) override {
    PythonAPI::evalScript("exitList_of_port_identifiers", this, (parser_rule_context *) ctx);
  }

  void enterList_of_specparam_assignments(SV3_1aParser::List_of_specparam_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_specparam_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_specparam_assignments(SV3_1aParser::List_of_specparam_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_specparam_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_tf_variable_identifiers(SV3_1aParser::List_of_tf_variable_identifiersContext * ctx) override {
    PythonAPI::evalScript("enterList_of_tf_variable_identifiers", this, (parser_rule_context *) ctx);
  }
  void exitList_of_tf_variable_identifiers(SV3_1aParser::List_of_tf_variable_identifiersContext * ctx) override {
    PythonAPI::evalScript("exitList_of_tf_variable_identifiers", this, (parser_rule_context *) ctx);
  }

  void enterList_of_type_assignments(SV3_1aParser::List_of_type_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_type_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_type_assignments(SV3_1aParser::List_of_type_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_type_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_variable_decl_assignments(SV3_1aParser::List_of_variable_decl_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_variable_decl_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_variable_decl_assignments(SV3_1aParser::List_of_variable_decl_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_variable_decl_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_variable_identifiers(SV3_1aParser::List_of_variable_identifiersContext * ctx) override {
    PythonAPI::evalScript("enterList_of_variable_identifiers", this, (parser_rule_context *) ctx);
  }
  void exitList_of_variable_identifiers(SV3_1aParser::List_of_variable_identifiersContext * ctx) override {
    PythonAPI::evalScript("exitList_of_variable_identifiers", this, (parser_rule_context *) ctx);
  }

  void enterList_of_variable_port_identifiers(SV3_1aParser::List_of_variable_port_identifiersContext * ctx) override {
    PythonAPI::evalScript("enterList_of_variable_port_identifiers", this, (parser_rule_context *) ctx);
  }
  void exitList_of_variable_port_identifiers(SV3_1aParser::List_of_variable_port_identifiersContext * ctx) override {
    PythonAPI::evalScript("exitList_of_variable_port_identifiers", this, (parser_rule_context *) ctx);
  }

  void enterList_of_virtual_interface_decl(SV3_1aParser::List_of_virtual_interface_declContext * ctx) override {
    PythonAPI::evalScript("enterList_of_virtual_interface_decl", this, (parser_rule_context *) ctx);
  }
  void exitList_of_virtual_interface_decl(SV3_1aParser::List_of_virtual_interface_declContext * ctx) override {
    PythonAPI::evalScript("exitList_of_virtual_interface_decl", this, (parser_rule_context *) ctx);
  }

  void enterDefparam_assignment(SV3_1aParser::Defparam_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterDefparam_assignment", this, (parser_rule_context *) ctx);
  }
  void exitDefparam_assignment(SV3_1aParser::Defparam_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitDefparam_assignment", this, (parser_rule_context *) ctx);
  }

  void enterNet_decl_assignment(SV3_1aParser::Net_decl_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterNet_decl_assignment", this, (parser_rule_context *) ctx);
  }
  void exitNet_decl_assignment(SV3_1aParser::Net_decl_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitNet_decl_assignment", this, (parser_rule_context *) ctx);
  }

  void enterParam_assignment(SV3_1aParser::Param_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterParam_assignment", this, (parser_rule_context *) ctx);
  }
  void exitParam_assignment(SV3_1aParser::Param_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitParam_assignment", this, (parser_rule_context *) ctx);
  }

  void enterSpecparam_assignment(SV3_1aParser::Specparam_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterSpecparam_assignment", this, (parser_rule_context *) ctx);
  }
  void exitSpecparam_assignment(SV3_1aParser::Specparam_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitSpecparam_assignment", this, (parser_rule_context *) ctx);
  }

  void enterPulse_control_specparam(SV3_1aParser::Pulse_control_specparamContext * ctx) override {
    PythonAPI::evalScript("enterPulse_control_specparam", this, (parser_rule_context *) ctx);
  }
  void exitPulse_control_specparam(SV3_1aParser::Pulse_control_specparamContext * ctx) override {
    PythonAPI::evalScript("exitPulse_control_specparam", this, (parser_rule_context *) ctx);
  }

  void enterVariable_decl_assignment(SV3_1aParser::Variable_decl_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterVariable_decl_assignment", this, (parser_rule_context *) ctx);
  }
  void exitVariable_decl_assignment(SV3_1aParser::Variable_decl_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitVariable_decl_assignment", this, (parser_rule_context *) ctx);
  }

  void enterClass_new(SV3_1aParser::Class_newContext * ctx) override {
    PythonAPI::evalScript("enterClass_new", this, (parser_rule_context *) ctx);
  }
  void exitClass_new(SV3_1aParser::Class_newContext * ctx) override {
    PythonAPI::evalScript("exitClass_new", this, (parser_rule_context *) ctx);
  }

  void enterDynamic_array_new(SV3_1aParser::Dynamic_array_newContext * ctx) override {
    PythonAPI::evalScript("enterDynamic_array_new", this, (parser_rule_context *) ctx);
  }
  void exitDynamic_array_new(SV3_1aParser::Dynamic_array_newContext * ctx) override {
    PythonAPI::evalScript("exitDynamic_array_new", this, (parser_rule_context *) ctx);
  }

  void enterUnpacked_dimension(SV3_1aParser::Unpacked_dimensionContext * ctx) override {
    PythonAPI::evalScript("enterUnpacked_dimension", this, (parser_rule_context *) ctx);
  }
  void exitUnpacked_dimension(SV3_1aParser::Unpacked_dimensionContext * ctx) override {
    PythonAPI::evalScript("exitUnpacked_dimension", this, (parser_rule_context *) ctx);
  }

  void enterPacked_dimension(SV3_1aParser::Packed_dimensionContext * ctx) override {
    PythonAPI::evalScript("enterPacked_dimension", this, (parser_rule_context *) ctx);
  }
  void exitPacked_dimension(SV3_1aParser::Packed_dimensionContext * ctx) override {
    PythonAPI::evalScript("exitPacked_dimension", this, (parser_rule_context *) ctx);
  }

  void enterAssociative_dimension(SV3_1aParser::Associative_dimensionContext * ctx) override {
    PythonAPI::evalScript("enterAssociative_dimension", this, (parser_rule_context *) ctx);
  }
  void exitAssociative_dimension(SV3_1aParser::Associative_dimensionContext * ctx) override {
    PythonAPI::evalScript("exitAssociative_dimension", this, (parser_rule_context *) ctx);
  }

  void enterVariable_dimension(SV3_1aParser::Variable_dimensionContext * ctx) override {
    PythonAPI::evalScript("enterVariable_dimension", this, (parser_rule_context *) ctx);
  }
  void exitVariable_dimension(SV3_1aParser::Variable_dimensionContext * ctx) override {
    PythonAPI::evalScript("exitVariable_dimension", this, (parser_rule_context *) ctx);
  }

  void enterQueue_dimension(SV3_1aParser::Queue_dimensionContext * ctx) override {
    PythonAPI::evalScript("enterQueue_dimension", this, (parser_rule_context *) ctx);
  }
  void exitQueue_dimension(SV3_1aParser::Queue_dimensionContext * ctx) override {
    PythonAPI::evalScript("exitQueue_dimension", this, (parser_rule_context *) ctx);
  }

  void enterUnsized_dimension(SV3_1aParser::Unsized_dimensionContext * ctx) override {
    PythonAPI::evalScript("enterUnsized_dimension", this, (parser_rule_context *) ctx);
  }
  void exitUnsized_dimension(SV3_1aParser::Unsized_dimensionContext * ctx) override {
    PythonAPI::evalScript("exitUnsized_dimension", this, (parser_rule_context *) ctx);
  }

  void enterFunction_data_type(SV3_1aParser::Function_data_typeContext * ctx) override {
    PythonAPI::evalScript("enterFunction_data_type", this, (parser_rule_context *) ctx);
  }
  void exitFunction_data_type(SV3_1aParser::Function_data_typeContext * ctx) override {
    PythonAPI::evalScript("exitFunction_data_type", this, (parser_rule_context *) ctx);
  }

  void enterFunction_data_type_or_implicit(SV3_1aParser::Function_data_type_or_implicitContext * ctx) override {
    PythonAPI::evalScript("enterFunction_data_type_or_implicit", this, (parser_rule_context *) ctx);
  }
  void exitFunction_data_type_or_implicit(SV3_1aParser::Function_data_type_or_implicitContext * ctx) override {
    PythonAPI::evalScript("exitFunction_data_type_or_implicit", this, (parser_rule_context *) ctx);
  }

  void enterFunction_declaration(SV3_1aParser::Function_declarationContext * ctx) override {
    PythonAPI::evalScript("enterFunction_declaration", this, (parser_rule_context *) ctx);
  }
  void exitFunction_declaration(SV3_1aParser::Function_declarationContext * ctx) override {
    PythonAPI::evalScript("exitFunction_declaration", this, (parser_rule_context *) ctx);
  }

  void enterFunction_body_declaration(SV3_1aParser::Function_body_declarationContext * ctx) override {
    PythonAPI::evalScript("enterFunction_body_declaration", this, (parser_rule_context *) ctx);
  }
  void exitFunction_body_declaration(SV3_1aParser::Function_body_declarationContext * ctx) override {
    PythonAPI::evalScript("exitFunction_body_declaration", this, (parser_rule_context *) ctx);
  }

  void enterFunction_prototype(SV3_1aParser::Function_prototypeContext * ctx) override {
    PythonAPI::evalScript("enterFunction_prototype", this, (parser_rule_context *) ctx);
  }
  void exitFunction_prototype(SV3_1aParser::Function_prototypeContext * ctx) override {
    PythonAPI::evalScript("exitFunction_prototype", this, (parser_rule_context *) ctx);
  }

  void enterDpi_import_export(SV3_1aParser::Dpi_import_exportContext * ctx) override {
    PythonAPI::evalScript("enterDpi_import_export", this, (parser_rule_context *) ctx);
  }
  void exitDpi_import_export(SV3_1aParser::Dpi_import_exportContext * ctx) override {
    PythonAPI::evalScript("exitDpi_import_export", this, (parser_rule_context *) ctx);
  }

  void enterContext_keyword(SV3_1aParser::Context_keywordContext * ctx) override {
    PythonAPI::evalScript("enterContext_keyword", this, (parser_rule_context *) ctx);
  }
  void exitContext_keyword(SV3_1aParser::Context_keywordContext * ctx) override {
    PythonAPI::evalScript("exitContext_keyword", this, (parser_rule_context *) ctx);
  }

  void enterFunction_name_decl(SV3_1aParser::Function_name_declContext * ctx) override {
    PythonAPI::evalScript("enterFunction_name_decl", this, (parser_rule_context *) ctx);
  }
  void exitFunction_name_decl(SV3_1aParser::Function_name_declContext * ctx) override {
    PythonAPI::evalScript("exitFunction_name_decl", this, (parser_rule_context *) ctx);
  }

  void enterTask_name_decl(SV3_1aParser::Task_name_declContext * ctx) override {
    PythonAPI::evalScript("enterTask_name_decl", this, (parser_rule_context *) ctx);
  }
  void exitTask_name_decl(SV3_1aParser::Task_name_declContext * ctx) override {
    PythonAPI::evalScript("exitTask_name_decl", this, (parser_rule_context *) ctx);
  }

  void enterPure_keyword(SV3_1aParser::Pure_keywordContext * ctx) override {
    PythonAPI::evalScript("enterPure_keyword", this, (parser_rule_context *) ctx);
  }
  void exitPure_keyword(SV3_1aParser::Pure_keywordContext * ctx) override {
    PythonAPI::evalScript("exitPure_keyword", this, (parser_rule_context *) ctx);
  }

  void enterTask_declaration(SV3_1aParser::Task_declarationContext * ctx) override {
    PythonAPI::evalScript("enterTask_declaration", this, (parser_rule_context *) ctx);
  }
  void exitTask_declaration(SV3_1aParser::Task_declarationContext * ctx) override {
    PythonAPI::evalScript("exitTask_declaration", this, (parser_rule_context *) ctx);
  }

  void enterTask_body_declaration(SV3_1aParser::Task_body_declarationContext * ctx) override {
    PythonAPI::evalScript("enterTask_body_declaration", this, (parser_rule_context *) ctx);
  }
  void exitTask_body_declaration(SV3_1aParser::Task_body_declarationContext * ctx) override {
    PythonAPI::evalScript("exitTask_body_declaration", this, (parser_rule_context *) ctx);
  }

  void enterTf_item_declaration(SV3_1aParser::Tf_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterTf_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitTf_item_declaration(SV3_1aParser::Tf_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitTf_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterTf_port_list(SV3_1aParser::Tf_port_listContext * ctx) override {
    PythonAPI::evalScript("enterTf_port_list", this, (parser_rule_context *) ctx);
  }
  void exitTf_port_list(SV3_1aParser::Tf_port_listContext * ctx) override {
    PythonAPI::evalScript("exitTf_port_list", this, (parser_rule_context *) ctx);
  }

  void enterTf_port_item(SV3_1aParser::Tf_port_itemContext * ctx) override {
    PythonAPI::evalScript("enterTf_port_item", this, (parser_rule_context *) ctx);
  }
  void exitTf_port_item(SV3_1aParser::Tf_port_itemContext * ctx) override {
    PythonAPI::evalScript("exitTf_port_item", this, (parser_rule_context *) ctx);
  }

  void enterTf_port_direction(SV3_1aParser::Tf_port_directionContext * ctx) override {
    PythonAPI::evalScript("enterTf_port_direction", this, (parser_rule_context *) ctx);
  }
  void exitTf_port_direction(SV3_1aParser::Tf_port_directionContext * ctx) override {
    PythonAPI::evalScript("exitTf_port_direction", this, (parser_rule_context *) ctx);
  }

  void enterTf_port_declaration(SV3_1aParser::Tf_port_declarationContext * ctx) override {
    PythonAPI::evalScript("enterTf_port_declaration", this, (parser_rule_context *) ctx);
  }
  void exitTf_port_declaration(SV3_1aParser::Tf_port_declarationContext * ctx) override {
    PythonAPI::evalScript("exitTf_port_declaration", this, (parser_rule_context *) ctx);
  }

  void enterTask_prototype(SV3_1aParser::Task_prototypeContext * ctx) override {
    PythonAPI::evalScript("enterTask_prototype", this, (parser_rule_context *) ctx);
  }
  void exitTask_prototype(SV3_1aParser::Task_prototypeContext * ctx) override {
    PythonAPI::evalScript("exitTask_prototype", this, (parser_rule_context *) ctx);
  }

  void enterBlock_item_declaration(SV3_1aParser::Block_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterBlock_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitBlock_item_declaration(SV3_1aParser::Block_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitBlock_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterOverload_declaration(SV3_1aParser::Overload_declarationContext * ctx) override {
    PythonAPI::evalScript("enterOverload_declaration", this, (parser_rule_context *) ctx);
  }
  void exitOverload_declaration(SV3_1aParser::Overload_declarationContext * ctx) override {
    PythonAPI::evalScript("exitOverload_declaration", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Plus(SV3_1aParser::OverloadOp_PlusContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Plus", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Plus(SV3_1aParser::OverloadOp_PlusContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Plus", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_PlusPlus(SV3_1aParser::OverloadOp_PlusPlusContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_PlusPlus", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_PlusPlus(SV3_1aParser::OverloadOp_PlusPlusContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_PlusPlus", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Minus(SV3_1aParser::OverloadOp_MinusContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Minus", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Minus(SV3_1aParser::OverloadOp_MinusContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Minus", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_MinusMinus(SV3_1aParser::OverloadOp_MinusMinusContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_MinusMinus", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_MinusMinus(SV3_1aParser::OverloadOp_MinusMinusContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_MinusMinus", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Mult(SV3_1aParser::OverloadOp_MultContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Mult", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Mult(SV3_1aParser::OverloadOp_MultContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Mult", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_StarStar(SV3_1aParser::OverloadOp_StarStarContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_StarStar", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_StarStar(SV3_1aParser::OverloadOp_StarStarContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_StarStar", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Div(SV3_1aParser::OverloadOp_DivContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Div", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Div(SV3_1aParser::OverloadOp_DivContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Div", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Percent(SV3_1aParser::OverloadOp_PercentContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Percent", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Percent(SV3_1aParser::OverloadOp_PercentContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Percent", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Equiv(SV3_1aParser::OverloadOp_EquivContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Equiv", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Equiv(SV3_1aParser::OverloadOp_EquivContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Equiv", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_NotEqual(SV3_1aParser::OverloadOp_NotEqualContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_NotEqual", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_NotEqual(SV3_1aParser::OverloadOp_NotEqualContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_NotEqual", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Less(SV3_1aParser::OverloadOp_LessContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Less", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Less(SV3_1aParser::OverloadOp_LessContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Less", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_LessEqual(SV3_1aParser::OverloadOp_LessEqualContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_LessEqual", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_LessEqual(SV3_1aParser::OverloadOp_LessEqualContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_LessEqual", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Greater(SV3_1aParser::OverloadOp_GreaterContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Greater", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Greater(SV3_1aParser::OverloadOp_GreaterContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Greater", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_GreaterEqual(SV3_1aParser::OverloadOp_GreaterEqualContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_GreaterEqual", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_GreaterEqual(SV3_1aParser::OverloadOp_GreaterEqualContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_GreaterEqual", this, (parser_rule_context *) ctx);
  }

  void enterOverloadOp_Equal(SV3_1aParser::OverloadOp_EqualContext * ctx) override {
    PythonAPI::evalScript("enterOverloadOp_Equal", this, (parser_rule_context *) ctx);
  }
  void exitOverloadOp_Equal(SV3_1aParser::OverloadOp_EqualContext * ctx) override {
    PythonAPI::evalScript("exitOverloadOp_Equal", this, (parser_rule_context *) ctx);
  }

  void enterOverload_proto_formals(SV3_1aParser::Overload_proto_formalsContext * ctx) override {
    PythonAPI::evalScript("enterOverload_proto_formals", this, (parser_rule_context *) ctx);
  }
  void exitOverload_proto_formals(SV3_1aParser::Overload_proto_formalsContext * ctx) override {
    PythonAPI::evalScript("exitOverload_proto_formals", this, (parser_rule_context *) ctx);
  }

  void enterVirtual_interface_declaration(SV3_1aParser::Virtual_interface_declarationContext * ctx) override {
    PythonAPI::evalScript("enterVirtual_interface_declaration", this, (parser_rule_context *) ctx);
  }
  void exitVirtual_interface_declaration(SV3_1aParser::Virtual_interface_declarationContext * ctx) override {
    PythonAPI::evalScript("exitVirtual_interface_declaration", this, (parser_rule_context *) ctx);
  }

  void enterModport_item(SV3_1aParser::Modport_itemContext * ctx) override {
    PythonAPI::evalScript("enterModport_item", this, (parser_rule_context *) ctx);
  }
  void exitModport_item(SV3_1aParser::Modport_itemContext * ctx) override {
    PythonAPI::evalScript("exitModport_item", this, (parser_rule_context *) ctx);
  }

  void enterModport_ports_declaration(SV3_1aParser::Modport_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("enterModport_ports_declaration", this, (parser_rule_context *) ctx);
  }
  void exitModport_ports_declaration(SV3_1aParser::Modport_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("exitModport_ports_declaration", this, (parser_rule_context *) ctx);
  }

  void enterModport_simple_ports_declaration(SV3_1aParser::Modport_simple_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("enterModport_simple_ports_declaration", this, (parser_rule_context *) ctx);
  }
  void exitModport_simple_ports_declaration(SV3_1aParser::Modport_simple_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("exitModport_simple_ports_declaration", this, (parser_rule_context *) ctx);
  }

  void enterModport_simple_port(SV3_1aParser::Modport_simple_portContext * ctx) override {
    PythonAPI::evalScript("enterModport_simple_port", this, (parser_rule_context *) ctx);
  }
  void exitModport_simple_port(SV3_1aParser::Modport_simple_portContext * ctx) override {
    PythonAPI::evalScript("exitModport_simple_port", this, (parser_rule_context *) ctx);
  }

  void enterModport_hierarchical_ports_declaration(SV3_1aParser::Modport_hierarchical_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("enterModport_hierarchical_ports_declaration", this, (parser_rule_context *) ctx);
  }
  void exitModport_hierarchical_ports_declaration(SV3_1aParser::Modport_hierarchical_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("exitModport_hierarchical_ports_declaration", this, (parser_rule_context *) ctx);
  }

  void enterModport_tf_ports_declaration(SV3_1aParser::Modport_tf_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("enterModport_tf_ports_declaration", this, (parser_rule_context *) ctx);
  }
  void exitModport_tf_ports_declaration(SV3_1aParser::Modport_tf_ports_declarationContext * ctx) override {
    PythonAPI::evalScript("exitModport_tf_ports_declaration", this, (parser_rule_context *) ctx);
  }

  void enterModport_tf_port(SV3_1aParser::Modport_tf_portContext * ctx) override {
    PythonAPI::evalScript("enterModport_tf_port", this, (parser_rule_context *) ctx);
  }
  void exitModport_tf_port(SV3_1aParser::Modport_tf_portContext * ctx) override {
    PythonAPI::evalScript("exitModport_tf_port", this, (parser_rule_context *) ctx);
  }

  void enterConcurrent_assertion_item(SV3_1aParser::Concurrent_assertion_itemContext * ctx) override {
    PythonAPI::evalScript("enterConcurrent_assertion_item", this, (parser_rule_context *) ctx);
  }
  void exitConcurrent_assertion_item(SV3_1aParser::Concurrent_assertion_itemContext * ctx) override {
    PythonAPI::evalScript("exitConcurrent_assertion_item", this, (parser_rule_context *) ctx);
  }

  void enterConcurrent_assertion_statement(SV3_1aParser::Concurrent_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("enterConcurrent_assertion_statement", this, (parser_rule_context *) ctx);
  }
  void exitConcurrent_assertion_statement(SV3_1aParser::Concurrent_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("exitConcurrent_assertion_statement", this, (parser_rule_context *) ctx);
  }

  void enterAssert_property_statement(SV3_1aParser::Assert_property_statementContext * ctx) override {
    PythonAPI::evalScript("enterAssert_property_statement", this, (parser_rule_context *) ctx);
  }
  void exitAssert_property_statement(SV3_1aParser::Assert_property_statementContext * ctx) override {
    PythonAPI::evalScript("exitAssert_property_statement", this, (parser_rule_context *) ctx);
  }

  void enterAssume_property_statement(SV3_1aParser::Assume_property_statementContext * ctx) override {
    PythonAPI::evalScript("enterAssume_property_statement", this, (parser_rule_context *) ctx);
  }
  void exitAssume_property_statement(SV3_1aParser::Assume_property_statementContext * ctx) override {
    PythonAPI::evalScript("exitAssume_property_statement", this, (parser_rule_context *) ctx);
  }

  void enterCover_property_statement(SV3_1aParser::Cover_property_statementContext * ctx) override {
    PythonAPI::evalScript("enterCover_property_statement", this, (parser_rule_context *) ctx);
  }
  void exitCover_property_statement(SV3_1aParser::Cover_property_statementContext * ctx) override {
    PythonAPI::evalScript("exitCover_property_statement", this, (parser_rule_context *) ctx);
  }

  void enterExpect_property_statement(SV3_1aParser::Expect_property_statementContext * ctx) override {
    PythonAPI::evalScript("enterExpect_property_statement", this, (parser_rule_context *) ctx);
  }
  void exitExpect_property_statement(SV3_1aParser::Expect_property_statementContext * ctx) override {
    PythonAPI::evalScript("exitExpect_property_statement", this, (parser_rule_context *) ctx);
  }

  void enterCover_sequence_statement(SV3_1aParser::Cover_sequence_statementContext * ctx) override {
    PythonAPI::evalScript("enterCover_sequence_statement", this, (parser_rule_context *) ctx);
  }
  void exitCover_sequence_statement(SV3_1aParser::Cover_sequence_statementContext * ctx) override {
    PythonAPI::evalScript("exitCover_sequence_statement", this, (parser_rule_context *) ctx);
  }

  void enterRestrict_property_statement(SV3_1aParser::Restrict_property_statementContext * ctx) override {
    PythonAPI::evalScript("enterRestrict_property_statement", this, (parser_rule_context *) ctx);
  }
  void exitRestrict_property_statement(SV3_1aParser::Restrict_property_statementContext * ctx) override {
    PythonAPI::evalScript("exitRestrict_property_statement", this, (parser_rule_context *) ctx);
  }

  void enterProperty_instance(SV3_1aParser::Property_instanceContext * ctx) override {
    PythonAPI::evalScript("enterProperty_instance", this, (parser_rule_context *) ctx);
  }
  void exitProperty_instance(SV3_1aParser::Property_instanceContext * ctx) override {
    PythonAPI::evalScript("exitProperty_instance", this, (parser_rule_context *) ctx);
  }

  void enterProperty_actual_arg(SV3_1aParser::Property_actual_argContext * ctx) override {
    PythonAPI::evalScript("enterProperty_actual_arg", this, (parser_rule_context *) ctx);
  }
  void exitProperty_actual_arg(SV3_1aParser::Property_actual_argContext * ctx) override {
    PythonAPI::evalScript("exitProperty_actual_arg", this, (parser_rule_context *) ctx);
  }

  void enterConcurrent_assertion_item_declaration(SV3_1aParser::Concurrent_assertion_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterConcurrent_assertion_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitConcurrent_assertion_item_declaration(SV3_1aParser::Concurrent_assertion_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitConcurrent_assertion_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterAssertion_item_declaration(SV3_1aParser::Assertion_item_declarationContext * ctx) override {
    PythonAPI::evalScript("enterAssertion_item_declaration", this, (parser_rule_context *) ctx);
  }
  void exitAssertion_item_declaration(SV3_1aParser::Assertion_item_declarationContext * ctx) override {
    PythonAPI::evalScript("exitAssertion_item_declaration", this, (parser_rule_context *) ctx);
  }

  void enterProperty_declaration(SV3_1aParser::Property_declarationContext * ctx) override {
    PythonAPI::evalScript("enterProperty_declaration", this, (parser_rule_context *) ctx);
  }
  void exitProperty_declaration(SV3_1aParser::Property_declarationContext * ctx) override {
    PythonAPI::evalScript("exitProperty_declaration", this, (parser_rule_context *) ctx);
  }

  void enterProperty_port_list(SV3_1aParser::Property_port_listContext * ctx) override {
    PythonAPI::evalScript("enterProperty_port_list", this, (parser_rule_context *) ctx);
  }
  void exitProperty_port_list(SV3_1aParser::Property_port_listContext * ctx) override {
    PythonAPI::evalScript("exitProperty_port_list", this, (parser_rule_context *) ctx);
  }

  void enterProperty_port_item(SV3_1aParser::Property_port_itemContext * ctx) override {
    PythonAPI::evalScript("enterProperty_port_item", this, (parser_rule_context *) ctx);
  }
  void exitProperty_port_item(SV3_1aParser::Property_port_itemContext * ctx) override {
    PythonAPI::evalScript("exitProperty_port_item", this, (parser_rule_context *) ctx);
  }

  void enterProperty_lvar_port_direction(SV3_1aParser::Property_lvar_port_directionContext * ctx) override {
    PythonAPI::evalScript("enterProperty_lvar_port_direction", this, (parser_rule_context *) ctx);
  }
  void exitProperty_lvar_port_direction(SV3_1aParser::Property_lvar_port_directionContext * ctx) override {
    PythonAPI::evalScript("exitProperty_lvar_port_direction", this, (parser_rule_context *) ctx);
  }

  void enterProperty_formal_type(SV3_1aParser::Property_formal_typeContext * ctx) override {
    PythonAPI::evalScript("enterProperty_formal_type", this, (parser_rule_context *) ctx);
  }
  void exitProperty_formal_type(SV3_1aParser::Property_formal_typeContext * ctx) override {
    PythonAPI::evalScript("exitProperty_formal_type", this, (parser_rule_context *) ctx);
  }

  void enterProperty_spec(SV3_1aParser::Property_specContext * ctx) override {
    PythonAPI::evalScript("enterProperty_spec", this, (parser_rule_context *) ctx);
  }
  void exitProperty_spec(SV3_1aParser::Property_specContext * ctx) override {
    PythonAPI::evalScript("exitProperty_spec", this, (parser_rule_context *) ctx);
  }

  void enterProperty_expr(SV3_1aParser::Property_exprContext * ctx) override {
    PythonAPI::evalScript("enterProperty_expr", this, (parser_rule_context *) ctx);
  }
  void exitProperty_expr(SV3_1aParser::Property_exprContext * ctx) override {
    PythonAPI::evalScript("exitProperty_expr", this, (parser_rule_context *) ctx);
  }

  void enterProperty_case_item(SV3_1aParser::Property_case_itemContext * ctx) override {
    PythonAPI::evalScript("enterProperty_case_item", this, (parser_rule_context *) ctx);
  }
  void exitProperty_case_item(SV3_1aParser::Property_case_itemContext * ctx) override {
    PythonAPI::evalScript("exitProperty_case_item", this, (parser_rule_context *) ctx);
  }

  void enterSequence_declaration(SV3_1aParser::Sequence_declarationContext * ctx) override {
    PythonAPI::evalScript("enterSequence_declaration", this, (parser_rule_context *) ctx);
  }
  void exitSequence_declaration(SV3_1aParser::Sequence_declarationContext * ctx) override {
    PythonAPI::evalScript("exitSequence_declaration", this, (parser_rule_context *) ctx);
  }

  void enterSequence_expr(SV3_1aParser::Sequence_exprContext * ctx) override {
    PythonAPI::evalScript("enterSequence_expr", this, (parser_rule_context *) ctx);
  }
  void exitSequence_expr(SV3_1aParser::Sequence_exprContext * ctx) override {
    PythonAPI::evalScript("exitSequence_expr", this, (parser_rule_context *) ctx);
  }

  void enterCycle_delay_range(SV3_1aParser::Cycle_delay_rangeContext * ctx) override {
    PythonAPI::evalScript("enterCycle_delay_range", this, (parser_rule_context *) ctx);
  }
  void exitCycle_delay_range(SV3_1aParser::Cycle_delay_rangeContext * ctx) override {
    PythonAPI::evalScript("exitCycle_delay_range", this, (parser_rule_context *) ctx);
  }

  void enterSequence_method_call(SV3_1aParser::Sequence_method_callContext * ctx) override {
    PythonAPI::evalScript("enterSequence_method_call", this, (parser_rule_context *) ctx);
  }
  void exitSequence_method_call(SV3_1aParser::Sequence_method_callContext * ctx) override {
    PythonAPI::evalScript("exitSequence_method_call", this, (parser_rule_context *) ctx);
  }

  void enterSequence_match_item(SV3_1aParser::Sequence_match_itemContext * ctx) override {
    PythonAPI::evalScript("enterSequence_match_item", this, (parser_rule_context *) ctx);
  }
  void exitSequence_match_item(SV3_1aParser::Sequence_match_itemContext * ctx) override {
    PythonAPI::evalScript("exitSequence_match_item", this, (parser_rule_context *) ctx);
  }

  void enterSequence_port_list(SV3_1aParser::Sequence_port_listContext * ctx) override {
    PythonAPI::evalScript("enterSequence_port_list", this, (parser_rule_context *) ctx);
  }
  void exitSequence_port_list(SV3_1aParser::Sequence_port_listContext * ctx) override {
    PythonAPI::evalScript("exitSequence_port_list", this, (parser_rule_context *) ctx);
  }

  void enterSequence_port_item(SV3_1aParser::Sequence_port_itemContext * ctx) override {
    PythonAPI::evalScript("enterSequence_port_item", this, (parser_rule_context *) ctx);
  }
  void exitSequence_port_item(SV3_1aParser::Sequence_port_itemContext * ctx) override {
    PythonAPI::evalScript("exitSequence_port_item", this, (parser_rule_context *) ctx);
  }

  void enterSeqLvarPortDir_Input(SV3_1aParser::SeqLvarPortDir_InputContext * ctx) override {
    PythonAPI::evalScript("enterSeqLvarPortDir_Input", this, (parser_rule_context *) ctx);
  }
  void exitSeqLvarPortDir_Input(SV3_1aParser::SeqLvarPortDir_InputContext * ctx) override {
    PythonAPI::evalScript("exitSeqLvarPortDir_Input", this, (parser_rule_context *) ctx);
  }

  void enterSeqLvarPortDir_Inout(SV3_1aParser::SeqLvarPortDir_InoutContext * ctx) override {
    PythonAPI::evalScript("enterSeqLvarPortDir_Inout", this, (parser_rule_context *) ctx);
  }
  void exitSeqLvarPortDir_Inout(SV3_1aParser::SeqLvarPortDir_InoutContext * ctx) override {
    PythonAPI::evalScript("exitSeqLvarPortDir_Inout", this, (parser_rule_context *) ctx);
  }

  void enterSeqLvarPortDir_Output(SV3_1aParser::SeqLvarPortDir_OutputContext * ctx) override {
    PythonAPI::evalScript("enterSeqLvarPortDir_Output", this, (parser_rule_context *) ctx);
  }
  void exitSeqLvarPortDir_Output(SV3_1aParser::SeqLvarPortDir_OutputContext * ctx) override {
    PythonAPI::evalScript("exitSeqLvarPortDir_Output", this, (parser_rule_context *) ctx);
  }

  void enterSeqFormatType_Data(SV3_1aParser::SeqFormatType_DataContext * ctx) override {
    PythonAPI::evalScript("enterSeqFormatType_Data", this, (parser_rule_context *) ctx);
  }
  void exitSeqFormatType_Data(SV3_1aParser::SeqFormatType_DataContext * ctx) override {
    PythonAPI::evalScript("exitSeqFormatType_Data", this, (parser_rule_context *) ctx);
  }

  void enterSeqFormatType_Sequence(SV3_1aParser::SeqFormatType_SequenceContext * ctx) override {
    PythonAPI::evalScript("enterSeqFormatType_Sequence", this, (parser_rule_context *) ctx);
  }
  void exitSeqFormatType_Sequence(SV3_1aParser::SeqFormatType_SequenceContext * ctx) override {
    PythonAPI::evalScript("exitSeqFormatType_Sequence", this, (parser_rule_context *) ctx);
  }

  void enterSeqFormatType_Untyped(SV3_1aParser::SeqFormatType_UntypedContext * ctx) override {
    PythonAPI::evalScript("enterSeqFormatType_Untyped", this, (parser_rule_context *) ctx);
  }
  void exitSeqFormatType_Untyped(SV3_1aParser::SeqFormatType_UntypedContext * ctx) override {
    PythonAPI::evalScript("exitSeqFormatType_Untyped", this, (parser_rule_context *) ctx);
  }

  void enterSequence_instance(SV3_1aParser::Sequence_instanceContext * ctx) override {
    PythonAPI::evalScript("enterSequence_instance", this, (parser_rule_context *) ctx);
  }
  void exitSequence_instance(SV3_1aParser::Sequence_instanceContext * ctx) override {
    PythonAPI::evalScript("exitSequence_instance", this, (parser_rule_context *) ctx);
  }

  void enterSequence_arg(SV3_1aParser::Sequence_argContext * ctx) override {
    PythonAPI::evalScript("enterSequence_arg", this, (parser_rule_context *) ctx);
  }
  void exitSequence_arg(SV3_1aParser::Sequence_argContext * ctx) override {
    PythonAPI::evalScript("exitSequence_arg", this, (parser_rule_context *) ctx);
  }

  void enterSequence_list_of_arguments(SV3_1aParser::Sequence_list_of_argumentsContext * ctx) override {
    PythonAPI::evalScript("enterSequence_list_of_arguments", this, (parser_rule_context *) ctx);
  }
  void exitSequence_list_of_arguments(SV3_1aParser::Sequence_list_of_argumentsContext * ctx) override {
    PythonAPI::evalScript("exitSequence_list_of_arguments", this, (parser_rule_context *) ctx);
  }

  void enterSequence_actual_arg(SV3_1aParser::Sequence_actual_argContext * ctx) override {
    PythonAPI::evalScript("enterSequence_actual_arg", this, (parser_rule_context *) ctx);
  }
  void exitSequence_actual_arg(SV3_1aParser::Sequence_actual_argContext * ctx) override {
    PythonAPI::evalScript("exitSequence_actual_arg", this, (parser_rule_context *) ctx);
  }

  void enterActual_arg_list(SV3_1aParser::Actual_arg_listContext * ctx) override {
    PythonAPI::evalScript("enterActual_arg_list", this, (parser_rule_context *) ctx);
  }
  void exitActual_arg_list(SV3_1aParser::Actual_arg_listContext * ctx) override {
    PythonAPI::evalScript("exitActual_arg_list", this, (parser_rule_context *) ctx);
  }

  void enterActual_arg_expr(SV3_1aParser::Actual_arg_exprContext * ctx) override {
    PythonAPI::evalScript("enterActual_arg_expr", this, (parser_rule_context *) ctx);
  }
  void exitActual_arg_expr(SV3_1aParser::Actual_arg_exprContext * ctx) override {
    PythonAPI::evalScript("exitActual_arg_expr", this, (parser_rule_context *) ctx);
  }

  void enterBoolean_abbrev(SV3_1aParser::Boolean_abbrevContext * ctx) override {
    PythonAPI::evalScript("enterBoolean_abbrev", this, (parser_rule_context *) ctx);
  }
  void exitBoolean_abbrev(SV3_1aParser::Boolean_abbrevContext * ctx) override {
    PythonAPI::evalScript("exitBoolean_abbrev", this, (parser_rule_context *) ctx);
  }

  void enterConsecutive_repetition(SV3_1aParser::Consecutive_repetitionContext * ctx) override {
    PythonAPI::evalScript("enterConsecutive_repetition", this, (parser_rule_context *) ctx);
  }
  void exitConsecutive_repetition(SV3_1aParser::Consecutive_repetitionContext * ctx) override {
    PythonAPI::evalScript("exitConsecutive_repetition", this, (parser_rule_context *) ctx);
  }

  void enterNon_consecutive_repetition(SV3_1aParser::Non_consecutive_repetitionContext * ctx) override {
    PythonAPI::evalScript("enterNon_consecutive_repetition", this, (parser_rule_context *) ctx);
  }
  void exitNon_consecutive_repetition(SV3_1aParser::Non_consecutive_repetitionContext * ctx) override {
    PythonAPI::evalScript("exitNon_consecutive_repetition", this, (parser_rule_context *) ctx);
  }

  void enterGoto_repetition(SV3_1aParser::Goto_repetitionContext * ctx) override {
    PythonAPI::evalScript("enterGoto_repetition", this, (parser_rule_context *) ctx);
  }
  void exitGoto_repetition(SV3_1aParser::Goto_repetitionContext * ctx) override {
    PythonAPI::evalScript("exitGoto_repetition", this, (parser_rule_context *) ctx);
  }

  void enterConst_or_range_expression(SV3_1aParser::Const_or_range_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConst_or_range_expression", this, (parser_rule_context *) ctx);
  }
  void exitConst_or_range_expression(SV3_1aParser::Const_or_range_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConst_or_range_expression", this, (parser_rule_context *) ctx);
  }

  void enterCycle_delay_const_range_expression(SV3_1aParser::Cycle_delay_const_range_expressionContext * ctx) override {
    PythonAPI::evalScript("enterCycle_delay_const_range_expression", this, (parser_rule_context *) ctx);
  }
  void exitCycle_delay_const_range_expression(SV3_1aParser::Cycle_delay_const_range_expressionContext * ctx) override {
    PythonAPI::evalScript("exitCycle_delay_const_range_expression", this, (parser_rule_context *) ctx);
  }

  void enterExpression_or_dist(SV3_1aParser::Expression_or_distContext * ctx) override {
    PythonAPI::evalScript("enterExpression_or_dist", this, (parser_rule_context *) ctx);
  }
  void exitExpression_or_dist(SV3_1aParser::Expression_or_distContext * ctx) override {
    PythonAPI::evalScript("exitExpression_or_dist", this, (parser_rule_context *) ctx);
  }

  void enterAssertion_variable_declaration(SV3_1aParser::Assertion_variable_declarationContext * ctx) override {
    PythonAPI::evalScript("enterAssertion_variable_declaration", this, (parser_rule_context *) ctx);
  }
  void exitAssertion_variable_declaration(SV3_1aParser::Assertion_variable_declarationContext * ctx) override {
    PythonAPI::evalScript("exitAssertion_variable_declaration", this, (parser_rule_context *) ctx);
  }

  void enterLet_declaration(SV3_1aParser::Let_declarationContext * ctx) override {
    PythonAPI::evalScript("enterLet_declaration", this, (parser_rule_context *) ctx);
  }
  void exitLet_declaration(SV3_1aParser::Let_declarationContext * ctx) override {
    PythonAPI::evalScript("exitLet_declaration", this, (parser_rule_context *) ctx);
  }

  void enterLet_port_list(SV3_1aParser::Let_port_listContext * ctx) override {
    PythonAPI::evalScript("enterLet_port_list", this, (parser_rule_context *) ctx);
  }
  void exitLet_port_list(SV3_1aParser::Let_port_listContext * ctx) override {
    PythonAPI::evalScript("exitLet_port_list", this, (parser_rule_context *) ctx);
  }

  void enterLet_port_item(SV3_1aParser::Let_port_itemContext * ctx) override {
    PythonAPI::evalScript("enterLet_port_item", this, (parser_rule_context *) ctx);
  }
  void exitLet_port_item(SV3_1aParser::Let_port_itemContext * ctx) override {
    PythonAPI::evalScript("exitLet_port_item", this, (parser_rule_context *) ctx);
  }

  void enterLet_formal_type(SV3_1aParser::Let_formal_typeContext * ctx) override {
    PythonAPI::evalScript("enterLet_formal_type", this, (parser_rule_context *) ctx);
  }
  void exitLet_formal_type(SV3_1aParser::Let_formal_typeContext * ctx) override {
    PythonAPI::evalScript("exitLet_formal_type", this, (parser_rule_context *) ctx);
  }

  void enterCovergroup_declaration(SV3_1aParser::Covergroup_declarationContext * ctx) override {
    PythonAPI::evalScript("enterCovergroup_declaration", this, (parser_rule_context *) ctx);
  }
  void exitCovergroup_declaration(SV3_1aParser::Covergroup_declarationContext * ctx) override {
    PythonAPI::evalScript("exitCovergroup_declaration", this, (parser_rule_context *) ctx);
  }

  void enterCoverage_spec_or_option(SV3_1aParser::Coverage_spec_or_optionContext * ctx) override {
    PythonAPI::evalScript("enterCoverage_spec_or_option", this, (parser_rule_context *) ctx);
  }
  void exitCoverage_spec_or_option(SV3_1aParser::Coverage_spec_or_optionContext * ctx) override {
    PythonAPI::evalScript("exitCoverage_spec_or_option", this, (parser_rule_context *) ctx);
  }

  void enterCoverage_option(SV3_1aParser::Coverage_optionContext * ctx) override {
    PythonAPI::evalScript("enterCoverage_option", this, (parser_rule_context *) ctx);
  }
  void exitCoverage_option(SV3_1aParser::Coverage_optionContext * ctx) override {
    PythonAPI::evalScript("exitCoverage_option", this, (parser_rule_context *) ctx);
  }

  void enterCoverage_spec(SV3_1aParser::Coverage_specContext * ctx) override {
    PythonAPI::evalScript("enterCoverage_spec", this, (parser_rule_context *) ctx);
  }
  void exitCoverage_spec(SV3_1aParser::Coverage_specContext * ctx) override {
    PythonAPI::evalScript("exitCoverage_spec", this, (parser_rule_context *) ctx);
  }

  void enterCoverage_event(SV3_1aParser::Coverage_eventContext * ctx) override {
    PythonAPI::evalScript("enterCoverage_event", this, (parser_rule_context *) ctx);
  }
  void exitCoverage_event(SV3_1aParser::Coverage_eventContext * ctx) override {
    PythonAPI::evalScript("exitCoverage_event", this, (parser_rule_context *) ctx);
  }

  void enterBlock_event_expression(SV3_1aParser::Block_event_expressionContext * ctx) override {
    PythonAPI::evalScript("enterBlock_event_expression", this, (parser_rule_context *) ctx);
  }
  void exitBlock_event_expression(SV3_1aParser::Block_event_expressionContext * ctx) override {
    PythonAPI::evalScript("exitBlock_event_expression", this, (parser_rule_context *) ctx);
  }

  void enterHierarchical_btf_identifier(SV3_1aParser::Hierarchical_btf_identifierContext * ctx) override {
    PythonAPI::evalScript("enterHierarchical_btf_identifier", this, (parser_rule_context *) ctx);
  }
  void exitHierarchical_btf_identifier(SV3_1aParser::Hierarchical_btf_identifierContext * ctx) override {
    PythonAPI::evalScript("exitHierarchical_btf_identifier", this, (parser_rule_context *) ctx);
  }

  void enterCover_point(SV3_1aParser::Cover_pointContext * ctx) override {
    PythonAPI::evalScript("enterCover_point", this, (parser_rule_context *) ctx);
  }
  void exitCover_point(SV3_1aParser::Cover_pointContext * ctx) override {
    PythonAPI::evalScript("exitCover_point", this, (parser_rule_context *) ctx);
  }

  void enterBins_or_empty(SV3_1aParser::Bins_or_emptyContext * ctx) override {
    PythonAPI::evalScript("enterBins_or_empty", this, (parser_rule_context *) ctx);
  }
  void exitBins_or_empty(SV3_1aParser::Bins_or_emptyContext * ctx) override {
    PythonAPI::evalScript("exitBins_or_empty", this, (parser_rule_context *) ctx);
  }

  void enterBins_or_options(SV3_1aParser::Bins_or_optionsContext * ctx) override {
    PythonAPI::evalScript("enterBins_or_options", this, (parser_rule_context *) ctx);
  }
  void exitBins_or_options(SV3_1aParser::Bins_or_optionsContext * ctx) override {
    PythonAPI::evalScript("exitBins_or_options", this, (parser_rule_context *) ctx);
  }

  void enterBins_Bins(SV3_1aParser::Bins_BinsContext * ctx) override {
    PythonAPI::evalScript("enterBins_Bins", this, (parser_rule_context *) ctx);
  }
  void exitBins_Bins(SV3_1aParser::Bins_BinsContext * ctx) override {
    PythonAPI::evalScript("exitBins_Bins", this, (parser_rule_context *) ctx);
  }

  void enterBins_Illegal(SV3_1aParser::Bins_IllegalContext * ctx) override {
    PythonAPI::evalScript("enterBins_Illegal", this, (parser_rule_context *) ctx);
  }
  void exitBins_Illegal(SV3_1aParser::Bins_IllegalContext * ctx) override {
    PythonAPI::evalScript("exitBins_Illegal", this, (parser_rule_context *) ctx);
  }

  void enterBins_Ignore(SV3_1aParser::Bins_IgnoreContext * ctx) override {
    PythonAPI::evalScript("enterBins_Ignore", this, (parser_rule_context *) ctx);
  }
  void exitBins_Ignore(SV3_1aParser::Bins_IgnoreContext * ctx) override {
    PythonAPI::evalScript("exitBins_Ignore", this, (parser_rule_context *) ctx);
  }

  void enterRange_list(SV3_1aParser::Range_listContext * ctx) override {
    PythonAPI::evalScript("enterRange_list", this, (parser_rule_context *) ctx);
  }
  void exitRange_list(SV3_1aParser::Range_listContext * ctx) override {
    PythonAPI::evalScript("exitRange_list", this, (parser_rule_context *) ctx);
  }

  void enterTrans_list(SV3_1aParser::Trans_listContext * ctx) override {
    PythonAPI::evalScript("enterTrans_list", this, (parser_rule_context *) ctx);
  }
  void exitTrans_list(SV3_1aParser::Trans_listContext * ctx) override {
    PythonAPI::evalScript("exitTrans_list", this, (parser_rule_context *) ctx);
  }

  void enterTrans_set(SV3_1aParser::Trans_setContext * ctx) override {
    PythonAPI::evalScript("enterTrans_set", this, (parser_rule_context *) ctx);
  }
  void exitTrans_set(SV3_1aParser::Trans_setContext * ctx) override {
    PythonAPI::evalScript("exitTrans_set", this, (parser_rule_context *) ctx);
  }

  void enterTrans_range_list(SV3_1aParser::Trans_range_listContext * ctx) override {
    PythonAPI::evalScript("enterTrans_range_list", this, (parser_rule_context *) ctx);
  }
  void exitTrans_range_list(SV3_1aParser::Trans_range_listContext * ctx) override {
    PythonAPI::evalScript("exitTrans_range_list", this, (parser_rule_context *) ctx);
  }

  void enterRepeat_range(SV3_1aParser::Repeat_rangeContext * ctx) override {
    PythonAPI::evalScript("enterRepeat_range", this, (parser_rule_context *) ctx);
  }
  void exitRepeat_range(SV3_1aParser::Repeat_rangeContext * ctx) override {
    PythonAPI::evalScript("exitRepeat_range", this, (parser_rule_context *) ctx);
  }

  void enterCover_cross(SV3_1aParser::Cover_crossContext * ctx) override {
    PythonAPI::evalScript("enterCover_cross", this, (parser_rule_context *) ctx);
  }
  void exitCover_cross(SV3_1aParser::Cover_crossContext * ctx) override {
    PythonAPI::evalScript("exitCover_cross", this, (parser_rule_context *) ctx);
  }

  void enterList_of_cross_items(SV3_1aParser::List_of_cross_itemsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_cross_items", this, (parser_rule_context *) ctx);
  }
  void exitList_of_cross_items(SV3_1aParser::List_of_cross_itemsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_cross_items", this, (parser_rule_context *) ctx);
  }

  void enterCross_item(SV3_1aParser::Cross_itemContext * ctx) override {
    PythonAPI::evalScript("enterCross_item", this, (parser_rule_context *) ctx);
  }
  void exitCross_item(SV3_1aParser::Cross_itemContext * ctx) override {
    PythonAPI::evalScript("exitCross_item", this, (parser_rule_context *) ctx);
  }

  void enterCross_body(SV3_1aParser::Cross_bodyContext * ctx) override {
    PythonAPI::evalScript("enterCross_body", this, (parser_rule_context *) ctx);
  }
  void exitCross_body(SV3_1aParser::Cross_bodyContext * ctx) override {
    PythonAPI::evalScript("exitCross_body", this, (parser_rule_context *) ctx);
  }

  void enterCross_body_item(SV3_1aParser::Cross_body_itemContext * ctx) override {
    PythonAPI::evalScript("enterCross_body_item", this, (parser_rule_context *) ctx);
  }
  void exitCross_body_item(SV3_1aParser::Cross_body_itemContext * ctx) override {
    PythonAPI::evalScript("exitCross_body_item", this, (parser_rule_context *) ctx);
  }

  void enterBins_selection_or_option(SV3_1aParser::Bins_selection_or_optionContext * ctx) override {
    PythonAPI::evalScript("enterBins_selection_or_option", this, (parser_rule_context *) ctx);
  }
  void exitBins_selection_or_option(SV3_1aParser::Bins_selection_or_optionContext * ctx) override {
    PythonAPI::evalScript("exitBins_selection_or_option", this, (parser_rule_context *) ctx);
  }

  void enterBins_selection(SV3_1aParser::Bins_selectionContext * ctx) override {
    PythonAPI::evalScript("enterBins_selection", this, (parser_rule_context *) ctx);
  }
  void exitBins_selection(SV3_1aParser::Bins_selectionContext * ctx) override {
    PythonAPI::evalScript("exitBins_selection", this, (parser_rule_context *) ctx);
  }

  void enterSelect_expression(SV3_1aParser::Select_expressionContext * ctx) override {
    PythonAPI::evalScript("enterSelect_expression", this, (parser_rule_context *) ctx);
  }
  void exitSelect_expression(SV3_1aParser::Select_expressionContext * ctx) override {
    PythonAPI::evalScript("exitSelect_expression", this, (parser_rule_context *) ctx);
  }

  void enterSelect_condition(SV3_1aParser::Select_conditionContext * ctx) override {
    PythonAPI::evalScript("enterSelect_condition", this, (parser_rule_context *) ctx);
  }
  void exitSelect_condition(SV3_1aParser::Select_conditionContext * ctx) override {
    PythonAPI::evalScript("exitSelect_condition", this, (parser_rule_context *) ctx);
  }

  void enterBins_expression(SV3_1aParser::Bins_expressionContext * ctx) override {
    PythonAPI::evalScript("enterBins_expression", this, (parser_rule_context *) ctx);
  }
  void exitBins_expression(SV3_1aParser::Bins_expressionContext * ctx) override {
    PythonAPI::evalScript("exitBins_expression", this, (parser_rule_context *) ctx);
  }

  void enterOpen_range_list(SV3_1aParser::Open_range_listContext * ctx) override {
    PythonAPI::evalScript("enterOpen_range_list", this, (parser_rule_context *) ctx);
  }
  void exitOpen_range_list(SV3_1aParser::Open_range_listContext * ctx) override {
    PythonAPI::evalScript("exitOpen_range_list", this, (parser_rule_context *) ctx);
  }

  void enterGate_instantiation(SV3_1aParser::Gate_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterGate_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitGate_instantiation(SV3_1aParser::Gate_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitGate_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterCmos_switch_instance(SV3_1aParser::Cmos_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("enterCmos_switch_instance", this, (parser_rule_context *) ctx);
  }
  void exitCmos_switch_instance(SV3_1aParser::Cmos_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("exitCmos_switch_instance", this, (parser_rule_context *) ctx);
  }

  void enterEnable_gate_instance(SV3_1aParser::Enable_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("enterEnable_gate_instance", this, (parser_rule_context *) ctx);
  }
  void exitEnable_gate_instance(SV3_1aParser::Enable_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("exitEnable_gate_instance", this, (parser_rule_context *) ctx);
  }

  void enterMos_switch_instance(SV3_1aParser::Mos_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("enterMos_switch_instance", this, (parser_rule_context *) ctx);
  }
  void exitMos_switch_instance(SV3_1aParser::Mos_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("exitMos_switch_instance", this, (parser_rule_context *) ctx);
  }

  void enterN_input_gate_instance(SV3_1aParser::N_input_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("enterN_input_gate_instance", this, (parser_rule_context *) ctx);
  }
  void exitN_input_gate_instance(SV3_1aParser::N_input_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("exitN_input_gate_instance", this, (parser_rule_context *) ctx);
  }

  void enterN_output_gate_instance(SV3_1aParser::N_output_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("enterN_output_gate_instance", this, (parser_rule_context *) ctx);
  }
  void exitN_output_gate_instance(SV3_1aParser::N_output_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("exitN_output_gate_instance", this, (parser_rule_context *) ctx);
  }

  void enterPass_switch_instance(SV3_1aParser::Pass_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("enterPass_switch_instance", this, (parser_rule_context *) ctx);
  }
  void exitPass_switch_instance(SV3_1aParser::Pass_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("exitPass_switch_instance", this, (parser_rule_context *) ctx);
  }

  void enterPass_enable_switch_instance(SV3_1aParser::Pass_enable_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("enterPass_enable_switch_instance", this, (parser_rule_context *) ctx);
  }
  void exitPass_enable_switch_instance(SV3_1aParser::Pass_enable_switch_instanceContext * ctx) override {
    PythonAPI::evalScript("exitPass_enable_switch_instance", this, (parser_rule_context *) ctx);
  }

  void enterPull_gate_instance(SV3_1aParser::Pull_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("enterPull_gate_instance", this, (parser_rule_context *) ctx);
  }
  void exitPull_gate_instance(SV3_1aParser::Pull_gate_instanceContext * ctx) override {
    PythonAPI::evalScript("exitPull_gate_instance", this, (parser_rule_context *) ctx);
  }

  void enterPulldown_strength(SV3_1aParser::Pulldown_strengthContext * ctx) override {
    PythonAPI::evalScript("enterPulldown_strength", this, (parser_rule_context *) ctx);
  }
  void exitPulldown_strength(SV3_1aParser::Pulldown_strengthContext * ctx) override {
    PythonAPI::evalScript("exitPulldown_strength", this, (parser_rule_context *) ctx);
  }

  void enterPullup_strength(SV3_1aParser::Pullup_strengthContext * ctx) override {
    PythonAPI::evalScript("enterPullup_strength", this, (parser_rule_context *) ctx);
  }
  void exitPullup_strength(SV3_1aParser::Pullup_strengthContext * ctx) override {
    PythonAPI::evalScript("exitPullup_strength", this, (parser_rule_context *) ctx);
  }

  void enterCmosSwitchType_Cmos(SV3_1aParser::CmosSwitchType_CmosContext * ctx) override {
    PythonAPI::evalScript("enterCmosSwitchType_Cmos", this, (parser_rule_context *) ctx);
  }
  void exitCmosSwitchType_Cmos(SV3_1aParser::CmosSwitchType_CmosContext * ctx) override {
    PythonAPI::evalScript("exitCmosSwitchType_Cmos", this, (parser_rule_context *) ctx);
  }

  void enterCmosSwitchType_RCmos(SV3_1aParser::CmosSwitchType_RCmosContext * ctx) override {
    PythonAPI::evalScript("enterCmosSwitchType_RCmos", this, (parser_rule_context *) ctx);
  }
  void exitCmosSwitchType_RCmos(SV3_1aParser::CmosSwitchType_RCmosContext * ctx) override {
    PythonAPI::evalScript("exitCmosSwitchType_RCmos", this, (parser_rule_context *) ctx);
  }

  void enterEnableGateType_Bufif0(SV3_1aParser::EnableGateType_Bufif0Context * ctx) override {
    PythonAPI::evalScript("enterEnableGateType_Bufif0", this, (parser_rule_context *) ctx);
  }
  void exitEnableGateType_Bufif0(SV3_1aParser::EnableGateType_Bufif0Context * ctx) override {
    PythonAPI::evalScript("exitEnableGateType_Bufif0", this, (parser_rule_context *) ctx);
  }

  void enterEnableGateType_Bufif1(SV3_1aParser::EnableGateType_Bufif1Context * ctx) override {
    PythonAPI::evalScript("enterEnableGateType_Bufif1", this, (parser_rule_context *) ctx);
  }
  void exitEnableGateType_Bufif1(SV3_1aParser::EnableGateType_Bufif1Context * ctx) override {
    PythonAPI::evalScript("exitEnableGateType_Bufif1", this, (parser_rule_context *) ctx);
  }

  void enterEnableGateType_Notif0(SV3_1aParser::EnableGateType_Notif0Context * ctx) override {
    PythonAPI::evalScript("enterEnableGateType_Notif0", this, (parser_rule_context *) ctx);
  }
  void exitEnableGateType_Notif0(SV3_1aParser::EnableGateType_Notif0Context * ctx) override {
    PythonAPI::evalScript("exitEnableGateType_Notif0", this, (parser_rule_context *) ctx);
  }

  void enterEnableGateType_Notif1(SV3_1aParser::EnableGateType_Notif1Context * ctx) override {
    PythonAPI::evalScript("enterEnableGateType_Notif1", this, (parser_rule_context *) ctx);
  }
  void exitEnableGateType_Notif1(SV3_1aParser::EnableGateType_Notif1Context * ctx) override {
    PythonAPI::evalScript("exitEnableGateType_Notif1", this, (parser_rule_context *) ctx);
  }

  void enterMosSwitchType_NMos(SV3_1aParser::MosSwitchType_NMosContext * ctx) override {
    PythonAPI::evalScript("enterMosSwitchType_NMos", this, (parser_rule_context *) ctx);
  }
  void exitMosSwitchType_NMos(SV3_1aParser::MosSwitchType_NMosContext * ctx) override {
    PythonAPI::evalScript("exitMosSwitchType_NMos", this, (parser_rule_context *) ctx);
  }

  void enterMosSwitchType_PMos(SV3_1aParser::MosSwitchType_PMosContext * ctx) override {
    PythonAPI::evalScript("enterMosSwitchType_PMos", this, (parser_rule_context *) ctx);
  }
  void exitMosSwitchType_PMos(SV3_1aParser::MosSwitchType_PMosContext * ctx) override {
    PythonAPI::evalScript("exitMosSwitchType_PMos", this, (parser_rule_context *) ctx);
  }

  void enterMosSwitchType_RNMos(SV3_1aParser::MosSwitchType_RNMosContext * ctx) override {
    PythonAPI::evalScript("enterMosSwitchType_RNMos", this, (parser_rule_context *) ctx);
  }
  void exitMosSwitchType_RNMos(SV3_1aParser::MosSwitchType_RNMosContext * ctx) override {
    PythonAPI::evalScript("exitMosSwitchType_RNMos", this, (parser_rule_context *) ctx);
  }

  void enterMosSwitchType_RPMos(SV3_1aParser::MosSwitchType_RPMosContext * ctx) override {
    PythonAPI::evalScript("enterMosSwitchType_RPMos", this, (parser_rule_context *) ctx);
  }
  void exitMosSwitchType_RPMos(SV3_1aParser::MosSwitchType_RPMosContext * ctx) override {
    PythonAPI::evalScript("exitMosSwitchType_RPMos", this, (parser_rule_context *) ctx);
  }

  void enterNInpGate_And(SV3_1aParser::NInpGate_AndContext * ctx) override {
    PythonAPI::evalScript("enterNInpGate_And", this, (parser_rule_context *) ctx);
  }
  void exitNInpGate_And(SV3_1aParser::NInpGate_AndContext * ctx) override {
    PythonAPI::evalScript("exitNInpGate_And", this, (parser_rule_context *) ctx);
  }

  void enterNInpGate_Nand(SV3_1aParser::NInpGate_NandContext * ctx) override {
    PythonAPI::evalScript("enterNInpGate_Nand", this, (parser_rule_context *) ctx);
  }
  void exitNInpGate_Nand(SV3_1aParser::NInpGate_NandContext * ctx) override {
    PythonAPI::evalScript("exitNInpGate_Nand", this, (parser_rule_context *) ctx);
  }

  void enterNInpGate_Or(SV3_1aParser::NInpGate_OrContext * ctx) override {
    PythonAPI::evalScript("enterNInpGate_Or", this, (parser_rule_context *) ctx);
  }
  void exitNInpGate_Or(SV3_1aParser::NInpGate_OrContext * ctx) override {
    PythonAPI::evalScript("exitNInpGate_Or", this, (parser_rule_context *) ctx);
  }

  void enterNInpGate_Nor(SV3_1aParser::NInpGate_NorContext * ctx) override {
    PythonAPI::evalScript("enterNInpGate_Nor", this, (parser_rule_context *) ctx);
  }
  void exitNInpGate_Nor(SV3_1aParser::NInpGate_NorContext * ctx) override {
    PythonAPI::evalScript("exitNInpGate_Nor", this, (parser_rule_context *) ctx);
  }

  void enterNInpGate_Xor(SV3_1aParser::NInpGate_XorContext * ctx) override {
    PythonAPI::evalScript("enterNInpGate_Xor", this, (parser_rule_context *) ctx);
  }
  void exitNInpGate_Xor(SV3_1aParser::NInpGate_XorContext * ctx) override {
    PythonAPI::evalScript("exitNInpGate_Xor", this, (parser_rule_context *) ctx);
  }

  void enterNInpGate_Xnor(SV3_1aParser::NInpGate_XnorContext * ctx) override {
    PythonAPI::evalScript("enterNInpGate_Xnor", this, (parser_rule_context *) ctx);
  }
  void exitNInpGate_Xnor(SV3_1aParser::NInpGate_XnorContext * ctx) override {
    PythonAPI::evalScript("exitNInpGate_Xnor", this, (parser_rule_context *) ctx);
  }

  void enterNOutGate_Buf(SV3_1aParser::NOutGate_BufContext * ctx) override {
    PythonAPI::evalScript("enterNOutGate_Buf", this, (parser_rule_context *) ctx);
  }
  void exitNOutGate_Buf(SV3_1aParser::NOutGate_BufContext * ctx) override {
    PythonAPI::evalScript("exitNOutGate_Buf", this, (parser_rule_context *) ctx);
  }

  void enterNOutGate_Not(SV3_1aParser::NOutGate_NotContext * ctx) override {
    PythonAPI::evalScript("enterNOutGate_Not", this, (parser_rule_context *) ctx);
  }
  void exitNOutGate_Not(SV3_1aParser::NOutGate_NotContext * ctx) override {
    PythonAPI::evalScript("exitNOutGate_Not", this, (parser_rule_context *) ctx);
  }

  void enterPassEnSwitch_Tranif0(SV3_1aParser::PassEnSwitch_Tranif0Context * ctx) override {
    PythonAPI::evalScript("enterPassEnSwitch_Tranif0", this, (parser_rule_context *) ctx);
  }
  void exitPassEnSwitch_Tranif0(SV3_1aParser::PassEnSwitch_Tranif0Context * ctx) override {
    PythonAPI::evalScript("exitPassEnSwitch_Tranif0", this, (parser_rule_context *) ctx);
  }

  void enterPassEnSwitch_Tranif1(SV3_1aParser::PassEnSwitch_Tranif1Context * ctx) override {
    PythonAPI::evalScript("enterPassEnSwitch_Tranif1", this, (parser_rule_context *) ctx);
  }
  void exitPassEnSwitch_Tranif1(SV3_1aParser::PassEnSwitch_Tranif1Context * ctx) override {
    PythonAPI::evalScript("exitPassEnSwitch_Tranif1", this, (parser_rule_context *) ctx);
  }

  void enterPassEnSwitch_RTranif1(SV3_1aParser::PassEnSwitch_RTranif1Context * ctx) override {
    PythonAPI::evalScript("enterPassEnSwitch_RTranif1", this, (parser_rule_context *) ctx);
  }
  void exitPassEnSwitch_RTranif1(SV3_1aParser::PassEnSwitch_RTranif1Context * ctx) override {
    PythonAPI::evalScript("exitPassEnSwitch_RTranif1", this, (parser_rule_context *) ctx);
  }

  void enterPassEnSwitch_RTranif0(SV3_1aParser::PassEnSwitch_RTranif0Context * ctx) override {
    PythonAPI::evalScript("enterPassEnSwitch_RTranif0", this, (parser_rule_context *) ctx);
  }
  void exitPassEnSwitch_RTranif0(SV3_1aParser::PassEnSwitch_RTranif0Context * ctx) override {
    PythonAPI::evalScript("exitPassEnSwitch_RTranif0", this, (parser_rule_context *) ctx);
  }

  void enterPassSwitch_Tran(SV3_1aParser::PassSwitch_TranContext * ctx) override {
    PythonAPI::evalScript("enterPassSwitch_Tran", this, (parser_rule_context *) ctx);
  }
  void exitPassSwitch_Tran(SV3_1aParser::PassSwitch_TranContext * ctx) override {
    PythonAPI::evalScript("exitPassSwitch_Tran", this, (parser_rule_context *) ctx);
  }

  void enterPassSwitch_RTran(SV3_1aParser::PassSwitch_RTranContext * ctx) override {
    PythonAPI::evalScript("enterPassSwitch_RTran", this, (parser_rule_context *) ctx);
  }
  void exitPassSwitch_RTran(SV3_1aParser::PassSwitch_RTranContext * ctx) override {
    PythonAPI::evalScript("exitPassSwitch_RTran", this, (parser_rule_context *) ctx);
  }

  void enterModule_instantiation(SV3_1aParser::Module_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterModule_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitModule_instantiation(SV3_1aParser::Module_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitModule_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterParameter_value_assignment(SV3_1aParser::Parameter_value_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterParameter_value_assignment", this, (parser_rule_context *) ctx);
  }
  void exitParameter_value_assignment(SV3_1aParser::Parameter_value_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitParameter_value_assignment", this, (parser_rule_context *) ctx);
  }

  void enterList_of_parameter_assignments(SV3_1aParser::List_of_parameter_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_parameter_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_parameter_assignments(SV3_1aParser::List_of_parameter_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_parameter_assignments", this, (parser_rule_context *) ctx);
  }

  void enterOrdered_parameter_assignment(SV3_1aParser::Ordered_parameter_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterOrdered_parameter_assignment", this, (parser_rule_context *) ctx);
  }
  void exitOrdered_parameter_assignment(SV3_1aParser::Ordered_parameter_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitOrdered_parameter_assignment", this, (parser_rule_context *) ctx);
  }

  void enterNamed_parameter_assignment(SV3_1aParser::Named_parameter_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterNamed_parameter_assignment", this, (parser_rule_context *) ctx);
  }
  void exitNamed_parameter_assignment(SV3_1aParser::Named_parameter_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitNamed_parameter_assignment", this, (parser_rule_context *) ctx);
  }

  void enterHierarchical_instance(SV3_1aParser::Hierarchical_instanceContext * ctx) override {
    PythonAPI::evalScript("enterHierarchical_instance", this, (parser_rule_context *) ctx);
  }
  void exitHierarchical_instance(SV3_1aParser::Hierarchical_instanceContext * ctx) override {
    PythonAPI::evalScript("exitHierarchical_instance", this, (parser_rule_context *) ctx);
  }

  void enterName_of_instance(SV3_1aParser::Name_of_instanceContext * ctx) override {
    PythonAPI::evalScript("enterName_of_instance", this, (parser_rule_context *) ctx);
  }
  void exitName_of_instance(SV3_1aParser::Name_of_instanceContext * ctx) override {
    PythonAPI::evalScript("exitName_of_instance", this, (parser_rule_context *) ctx);
  }

  void enterList_of_port_connections(SV3_1aParser::List_of_port_connectionsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_port_connections", this, (parser_rule_context *) ctx);
  }
  void exitList_of_port_connections(SV3_1aParser::List_of_port_connectionsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_port_connections", this, (parser_rule_context *) ctx);
  }

  void enterOrdered_port_connection(SV3_1aParser::Ordered_port_connectionContext * ctx) override {
    PythonAPI::evalScript("enterOrdered_port_connection", this, (parser_rule_context *) ctx);
  }
  void exitOrdered_port_connection(SV3_1aParser::Ordered_port_connectionContext * ctx) override {
    PythonAPI::evalScript("exitOrdered_port_connection", this, (parser_rule_context *) ctx);
  }

  void enterNamed_port_connection(SV3_1aParser::Named_port_connectionContext * ctx) override {
    PythonAPI::evalScript("enterNamed_port_connection", this, (parser_rule_context *) ctx);
  }
  void exitNamed_port_connection(SV3_1aParser::Named_port_connectionContext * ctx) override {
    PythonAPI::evalScript("exitNamed_port_connection", this, (parser_rule_context *) ctx);
  }

  void enterChecker_instantiation(SV3_1aParser::Checker_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterChecker_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitChecker_instantiation(SV3_1aParser::Checker_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitChecker_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterList_of_checker_port_connections(SV3_1aParser::List_of_checker_port_connectionsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_checker_port_connections", this, (parser_rule_context *) ctx);
  }
  void exitList_of_checker_port_connections(SV3_1aParser::List_of_checker_port_connectionsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_checker_port_connections", this, (parser_rule_context *) ctx);
  }

  void enterOrdered_checker_port_connection(SV3_1aParser::Ordered_checker_port_connectionContext * ctx) override {
    PythonAPI::evalScript("enterOrdered_checker_port_connection", this, (parser_rule_context *) ctx);
  }
  void exitOrdered_checker_port_connection(SV3_1aParser::Ordered_checker_port_connectionContext * ctx) override {
    PythonAPI::evalScript("exitOrdered_checker_port_connection", this, (parser_rule_context *) ctx);
  }

  void enterNamed_checker_port_connection(SV3_1aParser::Named_checker_port_connectionContext * ctx) override {
    PythonAPI::evalScript("enterNamed_checker_port_connection", this, (parser_rule_context *) ctx);
  }
  void exitNamed_checker_port_connection(SV3_1aParser::Named_checker_port_connectionContext * ctx) override {
    PythonAPI::evalScript("exitNamed_checker_port_connection", this, (parser_rule_context *) ctx);
  }

  void enterGenerated_module_instantiation(SV3_1aParser::Generated_module_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterGenerated_module_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitGenerated_module_instantiation(SV3_1aParser::Generated_module_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitGenerated_module_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_module_item(SV3_1aParser::Generate_module_itemContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_module_item", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_module_item(SV3_1aParser::Generate_module_itemContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_module_item", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_module_conditional_statement(SV3_1aParser::Generate_module_conditional_statementContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_module_conditional_statement", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_module_conditional_statement(SV3_1aParser::Generate_module_conditional_statementContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_module_conditional_statement", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_module_case_statement(SV3_1aParser::Generate_module_case_statementContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_module_case_statement", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_module_case_statement(SV3_1aParser::Generate_module_case_statementContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_module_case_statement", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_module_case_item(SV3_1aParser::Genvar_module_case_itemContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_module_case_item", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_module_case_item(SV3_1aParser::Genvar_module_case_itemContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_module_case_item", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_module_loop_statement(SV3_1aParser::Generate_module_loop_statementContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_module_loop_statement", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_module_loop_statement(SV3_1aParser::Generate_module_loop_statementContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_module_loop_statement", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_assignment(SV3_1aParser::Genvar_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_assignment", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_assignment(SV3_1aParser::Genvar_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_assignment", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_decl_assignment(SV3_1aParser::Genvar_decl_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_decl_assignment", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_decl_assignment(SV3_1aParser::Genvar_decl_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_decl_assignment", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_module_named_block(SV3_1aParser::Generate_module_named_blockContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_module_named_block", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_module_named_block(SV3_1aParser::Generate_module_named_blockContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_module_named_block", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_module_block(SV3_1aParser::Generate_module_blockContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_module_block", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_module_block(SV3_1aParser::Generate_module_blockContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_module_block", this, (parser_rule_context *) ctx);
  }

  void enterGenerated_interface_instantiation(SV3_1aParser::Generated_interface_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterGenerated_interface_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitGenerated_interface_instantiation(SV3_1aParser::Generated_interface_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitGenerated_interface_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_interface_item(SV3_1aParser::Generate_interface_itemContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_interface_item", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_interface_item(SV3_1aParser::Generate_interface_itemContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_interface_item", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_interface_conditional_statement(SV3_1aParser::Generate_interface_conditional_statementContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_interface_conditional_statement", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_interface_conditional_statement(SV3_1aParser::Generate_interface_conditional_statementContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_interface_conditional_statement", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_interface_case_statement(SV3_1aParser::Generate_interface_case_statementContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_interface_case_statement", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_interface_case_statement(SV3_1aParser::Generate_interface_case_statementContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_interface_case_statement", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_interface_case_item(SV3_1aParser::Genvar_interface_case_itemContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_interface_case_item", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_interface_case_item(SV3_1aParser::Genvar_interface_case_itemContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_interface_case_item", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_interface_loop_statement(SV3_1aParser::Generate_interface_loop_statementContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_interface_loop_statement", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_interface_loop_statement(SV3_1aParser::Generate_interface_loop_statementContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_interface_loop_statement", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_interface_named_block(SV3_1aParser::Generate_interface_named_blockContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_interface_named_block", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_interface_named_block(SV3_1aParser::Generate_interface_named_blockContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_interface_named_block", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_interface_block(SV3_1aParser::Generate_interface_blockContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_interface_block", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_interface_block(SV3_1aParser::Generate_interface_blockContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_interface_block", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_region(SV3_1aParser::Generate_regionContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_region", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_region(SV3_1aParser::Generate_regionContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_region", this, (parser_rule_context *) ctx);
  }

  void enterLoop_generate_construct(SV3_1aParser::Loop_generate_constructContext * ctx) override {
    PythonAPI::evalScript("enterLoop_generate_construct", this, (parser_rule_context *) ctx);
  }
  void exitLoop_generate_construct(SV3_1aParser::Loop_generate_constructContext * ctx) override {
    PythonAPI::evalScript("exitLoop_generate_construct", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_initialization(SV3_1aParser::Genvar_initializationContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_initialization", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_initialization(SV3_1aParser::Genvar_initializationContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_initialization", this, (parser_rule_context *) ctx);
  }

  void enterGenvar_iteration(SV3_1aParser::Genvar_iterationContext * ctx) override {
    PythonAPI::evalScript("enterGenvar_iteration", this, (parser_rule_context *) ctx);
  }
  void exitGenvar_iteration(SV3_1aParser::Genvar_iterationContext * ctx) override {
    PythonAPI::evalScript("exitGenvar_iteration", this, (parser_rule_context *) ctx);
  }

  void enterConditional_generate_construct(SV3_1aParser::Conditional_generate_constructContext * ctx) override {
    PythonAPI::evalScript("enterConditional_generate_construct", this, (parser_rule_context *) ctx);
  }
  void exitConditional_generate_construct(SV3_1aParser::Conditional_generate_constructContext * ctx) override {
    PythonAPI::evalScript("exitConditional_generate_construct", this, (parser_rule_context *) ctx);
  }

  void enterIf_generate_construct(SV3_1aParser::If_generate_constructContext * ctx) override {
    PythonAPI::evalScript("enterIf_generate_construct", this, (parser_rule_context *) ctx);
  }
  void exitIf_generate_construct(SV3_1aParser::If_generate_constructContext * ctx) override {
    PythonAPI::evalScript("exitIf_generate_construct", this, (parser_rule_context *) ctx);
  }

  void enterCase_generate_construct(SV3_1aParser::Case_generate_constructContext * ctx) override {
    PythonAPI::evalScript("enterCase_generate_construct", this, (parser_rule_context *) ctx);
  }
  void exitCase_generate_construct(SV3_1aParser::Case_generate_constructContext * ctx) override {
    PythonAPI::evalScript("exitCase_generate_construct", this, (parser_rule_context *) ctx);
  }

  void enterCase_generate_item(SV3_1aParser::Case_generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterCase_generate_item", this, (parser_rule_context *) ctx);
  }
  void exitCase_generate_item(SV3_1aParser::Case_generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitCase_generate_item", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_begin_end_block(SV3_1aParser::Generate_begin_end_blockContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_begin_end_block", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_begin_end_block(SV3_1aParser::Generate_begin_end_blockContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_begin_end_block", this, (parser_rule_context *) ctx);
  }

  void enterGenerate_item(SV3_1aParser::Generate_itemContext * ctx) override {
    PythonAPI::evalScript("enterGenerate_item", this, (parser_rule_context *) ctx);
  }
  void exitGenerate_item(SV3_1aParser::Generate_itemContext * ctx) override {
    PythonAPI::evalScript("exitGenerate_item", this, (parser_rule_context *) ctx);
  }

  void enterUdp_nonansi_declaration(SV3_1aParser::Udp_nonansi_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_nonansi_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_nonansi_declaration(SV3_1aParser::Udp_nonansi_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_nonansi_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_ansi_declaration(SV3_1aParser::Udp_ansi_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_ansi_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_ansi_declaration(SV3_1aParser::Udp_ansi_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_ansi_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_declaration(SV3_1aParser::Udp_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_declaration(SV3_1aParser::Udp_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_port_list(SV3_1aParser::Udp_port_listContext * ctx) override {
    PythonAPI::evalScript("enterUdp_port_list", this, (parser_rule_context *) ctx);
  }
  void exitUdp_port_list(SV3_1aParser::Udp_port_listContext * ctx) override {
    PythonAPI::evalScript("exitUdp_port_list", this, (parser_rule_context *) ctx);
  }

  void enterUdp_declaration_port_list(SV3_1aParser::Udp_declaration_port_listContext * ctx) override {
    PythonAPI::evalScript("enterUdp_declaration_port_list", this, (parser_rule_context *) ctx);
  }
  void exitUdp_declaration_port_list(SV3_1aParser::Udp_declaration_port_listContext * ctx) override {
    PythonAPI::evalScript("exitUdp_declaration_port_list", this, (parser_rule_context *) ctx);
  }

  void enterUdp_port_declaration(SV3_1aParser::Udp_port_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_port_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_port_declaration(SV3_1aParser::Udp_port_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_port_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_output_declaration(SV3_1aParser::Udp_output_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_output_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_output_declaration(SV3_1aParser::Udp_output_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_output_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_input_declaration(SV3_1aParser::Udp_input_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_input_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_input_declaration(SV3_1aParser::Udp_input_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_input_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_reg_declaration(SV3_1aParser::Udp_reg_declarationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_reg_declaration", this, (parser_rule_context *) ctx);
  }
  void exitUdp_reg_declaration(SV3_1aParser::Udp_reg_declarationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_reg_declaration", this, (parser_rule_context *) ctx);
  }

  void enterUdp_body(SV3_1aParser::Udp_bodyContext * ctx) override {
    PythonAPI::evalScript("enterUdp_body", this, (parser_rule_context *) ctx);
  }
  void exitUdp_body(SV3_1aParser::Udp_bodyContext * ctx) override {
    PythonAPI::evalScript("exitUdp_body", this, (parser_rule_context *) ctx);
  }

  void enterCombinational_body(SV3_1aParser::Combinational_bodyContext * ctx) override {
    PythonAPI::evalScript("enterCombinational_body", this, (parser_rule_context *) ctx);
  }
  void exitCombinational_body(SV3_1aParser::Combinational_bodyContext * ctx) override {
    PythonAPI::evalScript("exitCombinational_body", this, (parser_rule_context *) ctx);
  }

  void enterCombinational_entry(SV3_1aParser::Combinational_entryContext * ctx) override {
    PythonAPI::evalScript("enterCombinational_entry", this, (parser_rule_context *) ctx);
  }
  void exitCombinational_entry(SV3_1aParser::Combinational_entryContext * ctx) override {
    PythonAPI::evalScript("exitCombinational_entry", this, (parser_rule_context *) ctx);
  }

  void enterSequential_body(SV3_1aParser::Sequential_bodyContext * ctx) override {
    PythonAPI::evalScript("enterSequential_body", this, (parser_rule_context *) ctx);
  }
  void exitSequential_body(SV3_1aParser::Sequential_bodyContext * ctx) override {
    PythonAPI::evalScript("exitSequential_body", this, (parser_rule_context *) ctx);
  }

  void enterUdp_initial_statement(SV3_1aParser::Udp_initial_statementContext * ctx) override {
    PythonAPI::evalScript("enterUdp_initial_statement", this, (parser_rule_context *) ctx);
  }
  void exitUdp_initial_statement(SV3_1aParser::Udp_initial_statementContext * ctx) override {
    PythonAPI::evalScript("exitUdp_initial_statement", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1Tickb0(SV3_1aParser::InitVal_1Tickb0Context * ctx) override {
    PythonAPI::evalScript("enterInitVal_1Tickb0", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1Tickb0(SV3_1aParser::InitVal_1Tickb0Context * ctx) override {
    PythonAPI::evalScript("exitInitVal_1Tickb0", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1Tickb1(SV3_1aParser::InitVal_1Tickb1Context * ctx) override {
    PythonAPI::evalScript("enterInitVal_1Tickb1", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1Tickb1(SV3_1aParser::InitVal_1Tickb1Context * ctx) override {
    PythonAPI::evalScript("exitInitVal_1Tickb1", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1TickB0(SV3_1aParser::InitVal_1TickB0Context * ctx) override {
    PythonAPI::evalScript("enterInitVal_1TickB0", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1TickB0(SV3_1aParser::InitVal_1TickB0Context * ctx) override {
    PythonAPI::evalScript("exitInitVal_1TickB0", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1TickB1(SV3_1aParser::InitVal_1TickB1Context * ctx) override {
    PythonAPI::evalScript("enterInitVal_1TickB1", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1TickB1(SV3_1aParser::InitVal_1TickB1Context * ctx) override {
    PythonAPI::evalScript("exitInitVal_1TickB1", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1Tickbx(SV3_1aParser::InitVal_1TickbxContext * ctx) override {
    PythonAPI::evalScript("enterInitVal_1Tickbx", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1Tickbx(SV3_1aParser::InitVal_1TickbxContext * ctx) override {
    PythonAPI::evalScript("exitInitVal_1Tickbx", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1TickbX(SV3_1aParser::InitVal_1TickbXContext * ctx) override {
    PythonAPI::evalScript("enterInitVal_1TickbX", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1TickbX(SV3_1aParser::InitVal_1TickbXContext * ctx) override {
    PythonAPI::evalScript("exitInitVal_1TickbX", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1TickBx(SV3_1aParser::InitVal_1TickBxContext * ctx) override {
    PythonAPI::evalScript("enterInitVal_1TickBx", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1TickBx(SV3_1aParser::InitVal_1TickBxContext * ctx) override {
    PythonAPI::evalScript("exitInitVal_1TickBx", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_1TickBX(SV3_1aParser::InitVal_1TickBXContext * ctx) override {
    PythonAPI::evalScript("enterInitVal_1TickBX", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_1TickBX(SV3_1aParser::InitVal_1TickBXContext * ctx) override {
    PythonAPI::evalScript("exitInitVal_1TickBX", this, (parser_rule_context *) ctx);
  }

  void enterInitVal_Integral(SV3_1aParser::InitVal_IntegralContext * ctx) override {
    PythonAPI::evalScript("enterInitVal_Integral", this, (parser_rule_context *) ctx);
  }
  void exitInitVal_Integral(SV3_1aParser::InitVal_IntegralContext * ctx) override {
    PythonAPI::evalScript("exitInitVal_Integral", this, (parser_rule_context *) ctx);
  }

  void enterSequential_entry(SV3_1aParser::Sequential_entryContext * ctx) override {
    PythonAPI::evalScript("enterSequential_entry", this, (parser_rule_context *) ctx);
  }
  void exitSequential_entry(SV3_1aParser::Sequential_entryContext * ctx) override {
    PythonAPI::evalScript("exitSequential_entry", this, (parser_rule_context *) ctx);
  }

  void enterSeq_input_list(SV3_1aParser::Seq_input_listContext * ctx) override {
    PythonAPI::evalScript("enterSeq_input_list", this, (parser_rule_context *) ctx);
  }
  void exitSeq_input_list(SV3_1aParser::Seq_input_listContext * ctx) override {
    PythonAPI::evalScript("exitSeq_input_list", this, (parser_rule_context *) ctx);
  }

  void enterLevel_input_list(SV3_1aParser::Level_input_listContext * ctx) override {
    PythonAPI::evalScript("enterLevel_input_list", this, (parser_rule_context *) ctx);
  }
  void exitLevel_input_list(SV3_1aParser::Level_input_listContext * ctx) override {
    PythonAPI::evalScript("exitLevel_input_list", this, (parser_rule_context *) ctx);
  }

  void enterEdge_input_list(SV3_1aParser::Edge_input_listContext * ctx) override {
    PythonAPI::evalScript("enterEdge_input_list", this, (parser_rule_context *) ctx);
  }
  void exitEdge_input_list(SV3_1aParser::Edge_input_listContext * ctx) override {
    PythonAPI::evalScript("exitEdge_input_list", this, (parser_rule_context *) ctx);
  }

  void enterEdge_indicator(SV3_1aParser::Edge_indicatorContext * ctx) override {
    PythonAPI::evalScript("enterEdge_indicator", this, (parser_rule_context *) ctx);
  }
  void exitEdge_indicator(SV3_1aParser::Edge_indicatorContext * ctx) override {
    PythonAPI::evalScript("exitEdge_indicator", this, (parser_rule_context *) ctx);
  }

  void enterNext_state(SV3_1aParser::Next_stateContext * ctx) override {
    PythonAPI::evalScript("enterNext_state", this, (parser_rule_context *) ctx);
  }
  void exitNext_state(SV3_1aParser::Next_stateContext * ctx) override {
    PythonAPI::evalScript("exitNext_state", this, (parser_rule_context *) ctx);
  }

  void enterOutput_symbol(SV3_1aParser::Output_symbolContext * ctx) override {
    PythonAPI::evalScript("enterOutput_symbol", this, (parser_rule_context *) ctx);
  }
  void exitOutput_symbol(SV3_1aParser::Output_symbolContext * ctx) override {
    PythonAPI::evalScript("exitOutput_symbol", this, (parser_rule_context *) ctx);
  }

  void enterLevel_symbol(SV3_1aParser::Level_symbolContext * ctx) override {
    PythonAPI::evalScript("enterLevel_symbol", this, (parser_rule_context *) ctx);
  }
  void exitLevel_symbol(SV3_1aParser::Level_symbolContext * ctx) override {
    PythonAPI::evalScript("exitLevel_symbol", this, (parser_rule_context *) ctx);
  }

  void enterEdge_symbol(SV3_1aParser::Edge_symbolContext * ctx) override {
    PythonAPI::evalScript("enterEdge_symbol", this, (parser_rule_context *) ctx);
  }
  void exitEdge_symbol(SV3_1aParser::Edge_symbolContext * ctx) override {
    PythonAPI::evalScript("exitEdge_symbol", this, (parser_rule_context *) ctx);
  }

  void enterUdp_instantiation(SV3_1aParser::Udp_instantiationContext * ctx) override {
    PythonAPI::evalScript("enterUdp_instantiation", this, (parser_rule_context *) ctx);
  }
  void exitUdp_instantiation(SV3_1aParser::Udp_instantiationContext * ctx) override {
    PythonAPI::evalScript("exitUdp_instantiation", this, (parser_rule_context *) ctx);
  }

  void enterUdp_instance(SV3_1aParser::Udp_instanceContext * ctx) override {
    PythonAPI::evalScript("enterUdp_instance", this, (parser_rule_context *) ctx);
  }
  void exitUdp_instance(SV3_1aParser::Udp_instanceContext * ctx) override {
    PythonAPI::evalScript("exitUdp_instance", this, (parser_rule_context *) ctx);
  }

  void enterContinuous_assign(SV3_1aParser::Continuous_assignContext * ctx) override {
    PythonAPI::evalScript("enterContinuous_assign", this, (parser_rule_context *) ctx);
  }
  void exitContinuous_assign(SV3_1aParser::Continuous_assignContext * ctx) override {
    PythonAPI::evalScript("exitContinuous_assign", this, (parser_rule_context *) ctx);
  }

  void enterList_of_net_assignments(SV3_1aParser::List_of_net_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_net_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_net_assignments(SV3_1aParser::List_of_net_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_net_assignments", this, (parser_rule_context *) ctx);
  }

  void enterList_of_variable_assignments(SV3_1aParser::List_of_variable_assignmentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_variable_assignments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_variable_assignments(SV3_1aParser::List_of_variable_assignmentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_variable_assignments", this, (parser_rule_context *) ctx);
  }

  void enterNet_alias(SV3_1aParser::Net_aliasContext * ctx) override {
    PythonAPI::evalScript("enterNet_alias", this, (parser_rule_context *) ctx);
  }
  void exitNet_alias(SV3_1aParser::Net_aliasContext * ctx) override {
    PythonAPI::evalScript("exitNet_alias", this, (parser_rule_context *) ctx);
  }

  void enterNet_assignment(SV3_1aParser::Net_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterNet_assignment", this, (parser_rule_context *) ctx);
  }
  void exitNet_assignment(SV3_1aParser::Net_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitNet_assignment", this, (parser_rule_context *) ctx);
  }

  void enterInitial_construct(SV3_1aParser::Initial_constructContext * ctx) override {
    PythonAPI::evalScript("enterInitial_construct", this, (parser_rule_context *) ctx);
  }
  void exitInitial_construct(SV3_1aParser::Initial_constructContext * ctx) override {
    PythonAPI::evalScript("exitInitial_construct", this, (parser_rule_context *) ctx);
  }

  void enterAlways_construct(SV3_1aParser::Always_constructContext * ctx) override {
    PythonAPI::evalScript("enterAlways_construct", this, (parser_rule_context *) ctx);
  }
  void exitAlways_construct(SV3_1aParser::Always_constructContext * ctx) override {
    PythonAPI::evalScript("exitAlways_construct", this, (parser_rule_context *) ctx);
  }

  void enterAlways_keyword(SV3_1aParser::Always_keywordContext * ctx) override {
    PythonAPI::evalScript("enterAlways_keyword", this, (parser_rule_context *) ctx);
  }
  void exitAlways_keyword(SV3_1aParser::Always_keywordContext * ctx) override {
    PythonAPI::evalScript("exitAlways_keyword", this, (parser_rule_context *) ctx);
  }

  void enterBlocking_assignment(SV3_1aParser::Blocking_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterBlocking_assignment", this, (parser_rule_context *) ctx);
  }
  void exitBlocking_assignment(SV3_1aParser::Blocking_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitBlocking_assignment", this, (parser_rule_context *) ctx);
  }

  void enterOperator_assignment(SV3_1aParser::Operator_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterOperator_assignment", this, (parser_rule_context *) ctx);
  }
  void exitOperator_assignment(SV3_1aParser::Operator_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitOperator_assignment", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_operator(SV3_1aParser::Assignment_operatorContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_operator", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_operator(SV3_1aParser::Assignment_operatorContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_operator", this, (parser_rule_context *) ctx);
  }

  void enterNonblocking_assignment(SV3_1aParser::Nonblocking_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterNonblocking_assignment", this, (parser_rule_context *) ctx);
  }
  void exitNonblocking_assignment(SV3_1aParser::Nonblocking_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitNonblocking_assignment", this, (parser_rule_context *) ctx);
  }

  void enterProcedural_continuous_assignment(SV3_1aParser::Procedural_continuous_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterProcedural_continuous_assignment", this, (parser_rule_context *) ctx);
  }
  void exitProcedural_continuous_assignment(SV3_1aParser::Procedural_continuous_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitProcedural_continuous_assignment", this, (parser_rule_context *) ctx);
  }

  void enterVariable_assignment(SV3_1aParser::Variable_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterVariable_assignment", this, (parser_rule_context *) ctx);
  }
  void exitVariable_assignment(SV3_1aParser::Variable_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitVariable_assignment", this, (parser_rule_context *) ctx);
  }

  void enterAction_block(SV3_1aParser::Action_blockContext * ctx) override {
    PythonAPI::evalScript("enterAction_block", this, (parser_rule_context *) ctx);
  }
  void exitAction_block(SV3_1aParser::Action_blockContext * ctx) override {
    PythonAPI::evalScript("exitAction_block", this, (parser_rule_context *) ctx);
  }

  void enterSeq_block(SV3_1aParser::Seq_blockContext * ctx) override {
    PythonAPI::evalScript("enterSeq_block", this, (parser_rule_context *) ctx);
  }
  void exitSeq_block(SV3_1aParser::Seq_blockContext * ctx) override {
    PythonAPI::evalScript("exitSeq_block", this, (parser_rule_context *) ctx);
  }

  void enterPar_block(SV3_1aParser::Par_blockContext * ctx) override {
    PythonAPI::evalScript("enterPar_block", this, (parser_rule_context *) ctx);
  }
  void exitPar_block(SV3_1aParser::Par_blockContext * ctx) override {
    PythonAPI::evalScript("exitPar_block", this, (parser_rule_context *) ctx);
  }

  void enterJoin_keyword(SV3_1aParser::Join_keywordContext * ctx) override {
    PythonAPI::evalScript("enterJoin_keyword", this, (parser_rule_context *) ctx);
  }
  void exitJoin_keyword(SV3_1aParser::Join_keywordContext * ctx) override {
    PythonAPI::evalScript("exitJoin_keyword", this, (parser_rule_context *) ctx);
  }

  void enterJoin_any_keyword(SV3_1aParser::Join_any_keywordContext * ctx) override {
    PythonAPI::evalScript("enterJoin_any_keyword", this, (parser_rule_context *) ctx);
  }
  void exitJoin_any_keyword(SV3_1aParser::Join_any_keywordContext * ctx) override {
    PythonAPI::evalScript("exitJoin_any_keyword", this, (parser_rule_context *) ctx);
  }

  void enterJoin_none_keyword(SV3_1aParser::Join_none_keywordContext * ctx) override {
    PythonAPI::evalScript("enterJoin_none_keyword", this, (parser_rule_context *) ctx);
  }
  void exitJoin_none_keyword(SV3_1aParser::Join_none_keywordContext * ctx) override {
    PythonAPI::evalScript("exitJoin_none_keyword", this, (parser_rule_context *) ctx);
  }

  void enterStatement_or_null(SV3_1aParser::Statement_or_nullContext * ctx) override {
    PythonAPI::evalScript("enterStatement_or_null", this, (parser_rule_context *) ctx);
  }
  void exitStatement_or_null(SV3_1aParser::Statement_or_nullContext * ctx) override {
    PythonAPI::evalScript("exitStatement_or_null", this, (parser_rule_context *) ctx);
  }

  void enterStatement(SV3_1aParser::StatementContext * ctx) override {
    PythonAPI::evalScript("enterStatement", this, (parser_rule_context *) ctx);
  }
  void exitStatement(SV3_1aParser::StatementContext * ctx) override {
    PythonAPI::evalScript("exitStatement", this, (parser_rule_context *) ctx);
  }

  void enterStatement_item(SV3_1aParser::Statement_itemContext * ctx) override {
    PythonAPI::evalScript("enterStatement_item", this, (parser_rule_context *) ctx);
  }
  void exitStatement_item(SV3_1aParser::Statement_itemContext * ctx) override {
    PythonAPI::evalScript("exitStatement_item", this, (parser_rule_context *) ctx);
  }

  void enterFunction_statement_or_null(SV3_1aParser::Function_statement_or_nullContext * ctx) override {
    PythonAPI::evalScript("enterFunction_statement_or_null", this, (parser_rule_context *) ctx);
  }
  void exitFunction_statement_or_null(SV3_1aParser::Function_statement_or_nullContext * ctx) override {
    PythonAPI::evalScript("exitFunction_statement_or_null", this, (parser_rule_context *) ctx);
  }

  void enterProcedural_timing_control_statement(SV3_1aParser::Procedural_timing_control_statementContext * ctx) override {
    PythonAPI::evalScript("enterProcedural_timing_control_statement", this, (parser_rule_context *) ctx);
  }
  void exitProcedural_timing_control_statement(SV3_1aParser::Procedural_timing_control_statementContext * ctx) override {
    PythonAPI::evalScript("exitProcedural_timing_control_statement", this, (parser_rule_context *) ctx);
  }

  void enterDelay_or_event_control(SV3_1aParser::Delay_or_event_controlContext * ctx) override {
    PythonAPI::evalScript("enterDelay_or_event_control", this, (parser_rule_context *) ctx);
  }
  void exitDelay_or_event_control(SV3_1aParser::Delay_or_event_controlContext * ctx) override {
    PythonAPI::evalScript("exitDelay_or_event_control", this, (parser_rule_context *) ctx);
  }

  void enterDelay_control(SV3_1aParser::Delay_controlContext * ctx) override {
    PythonAPI::evalScript("enterDelay_control", this, (parser_rule_context *) ctx);
  }
  void exitDelay_control(SV3_1aParser::Delay_controlContext * ctx) override {
    PythonAPI::evalScript("exitDelay_control", this, (parser_rule_context *) ctx);
  }

  void enterEvent_control(SV3_1aParser::Event_controlContext * ctx) override {
    PythonAPI::evalScript("enterEvent_control", this, (parser_rule_context *) ctx);
  }
  void exitEvent_control(SV3_1aParser::Event_controlContext * ctx) override {
    PythonAPI::evalScript("exitEvent_control", this, (parser_rule_context *) ctx);
  }

  void enterEvent_expression(SV3_1aParser::Event_expressionContext * ctx) override {
    PythonAPI::evalScript("enterEvent_expression", this, (parser_rule_context *) ctx);
  }
  void exitEvent_expression(SV3_1aParser::Event_expressionContext * ctx) override {
    PythonAPI::evalScript("exitEvent_expression", this, (parser_rule_context *) ctx);
  }

  void enterOr_operator(SV3_1aParser::Or_operatorContext * ctx) override {
    PythonAPI::evalScript("enterOr_operator", this, (parser_rule_context *) ctx);
  }
  void exitOr_operator(SV3_1aParser::Or_operatorContext * ctx) override {
    PythonAPI::evalScript("exitOr_operator", this, (parser_rule_context *) ctx);
  }

  void enterComma_operator(SV3_1aParser::Comma_operatorContext * ctx) override {
    PythonAPI::evalScript("enterComma_operator", this, (parser_rule_context *) ctx);
  }
  void exitComma_operator(SV3_1aParser::Comma_operatorContext * ctx) override {
    PythonAPI::evalScript("exitComma_operator", this, (parser_rule_context *) ctx);
  }

  void enterProcedural_timing_control(SV3_1aParser::Procedural_timing_controlContext * ctx) override {
    PythonAPI::evalScript("enterProcedural_timing_control", this, (parser_rule_context *) ctx);
  }
  void exitProcedural_timing_control(SV3_1aParser::Procedural_timing_controlContext * ctx) override {
    PythonAPI::evalScript("exitProcedural_timing_control", this, (parser_rule_context *) ctx);
  }

  void enterJump_statement(SV3_1aParser::Jump_statementContext * ctx) override {
    PythonAPI::evalScript("enterJump_statement", this, (parser_rule_context *) ctx);
  }
  void exitJump_statement(SV3_1aParser::Jump_statementContext * ctx) override {
    PythonAPI::evalScript("exitJump_statement", this, (parser_rule_context *) ctx);
  }

  void enterFinal_construct(SV3_1aParser::Final_constructContext * ctx) override {
    PythonAPI::evalScript("enterFinal_construct", this, (parser_rule_context *) ctx);
  }
  void exitFinal_construct(SV3_1aParser::Final_constructContext * ctx) override {
    PythonAPI::evalScript("exitFinal_construct", this, (parser_rule_context *) ctx);
  }

  void enterWait_statement(SV3_1aParser::Wait_statementContext * ctx) override {
    PythonAPI::evalScript("enterWait_statement", this, (parser_rule_context *) ctx);
  }
  void exitWait_statement(SV3_1aParser::Wait_statementContext * ctx) override {
    PythonAPI::evalScript("exitWait_statement", this, (parser_rule_context *) ctx);
  }

  void enterEvent_trigger(SV3_1aParser::Event_triggerContext * ctx) override {
    PythonAPI::evalScript("enterEvent_trigger", this, (parser_rule_context *) ctx);
  }
  void exitEvent_trigger(SV3_1aParser::Event_triggerContext * ctx) override {
    PythonAPI::evalScript("exitEvent_trigger", this, (parser_rule_context *) ctx);
  }

  void enterDisable_statement(SV3_1aParser::Disable_statementContext * ctx) override {
    PythonAPI::evalScript("enterDisable_statement", this, (parser_rule_context *) ctx);
  }
  void exitDisable_statement(SV3_1aParser::Disable_statementContext * ctx) override {
    PythonAPI::evalScript("exitDisable_statement", this, (parser_rule_context *) ctx);
  }

  void enterConditional_statement(SV3_1aParser::Conditional_statementContext * ctx) override {
    PythonAPI::evalScript("enterConditional_statement", this, (parser_rule_context *) ctx);
  }
  void exitConditional_statement(SV3_1aParser::Conditional_statementContext * ctx) override {
    PythonAPI::evalScript("exitConditional_statement", this, (parser_rule_context *) ctx);
  }

  void enterUnique_priority(SV3_1aParser::Unique_priorityContext * ctx) override {
    PythonAPI::evalScript("enterUnique_priority", this, (parser_rule_context *) ctx);
  }
  void exitUnique_priority(SV3_1aParser::Unique_priorityContext * ctx) override {
    PythonAPI::evalScript("exitUnique_priority", this, (parser_rule_context *) ctx);
  }

  void enterCond_predicate(SV3_1aParser::Cond_predicateContext * ctx) override {
    PythonAPI::evalScript("enterCond_predicate", this, (parser_rule_context *) ctx);
  }
  void exitCond_predicate(SV3_1aParser::Cond_predicateContext * ctx) override {
    PythonAPI::evalScript("exitCond_predicate", this, (parser_rule_context *) ctx);
  }

  void enterExpression_or_cond_pattern(SV3_1aParser::Expression_or_cond_patternContext * ctx) override {
    PythonAPI::evalScript("enterExpression_or_cond_pattern", this, (parser_rule_context *) ctx);
  }
  void exitExpression_or_cond_pattern(SV3_1aParser::Expression_or_cond_patternContext * ctx) override {
    PythonAPI::evalScript("exitExpression_or_cond_pattern", this, (parser_rule_context *) ctx);
  }

  void enterMatches(SV3_1aParser::MatchesContext * ctx) override {
    PythonAPI::evalScript("enterMatches", this, (parser_rule_context *) ctx);
  }
  void exitMatches(SV3_1aParser::MatchesContext * ctx) override {
    PythonAPI::evalScript("exitMatches", this, (parser_rule_context *) ctx);
  }

  void enterCase_statement(SV3_1aParser::Case_statementContext * ctx) override {
    PythonAPI::evalScript("enterCase_statement", this, (parser_rule_context *) ctx);
  }
  void exitCase_statement(SV3_1aParser::Case_statementContext * ctx) override {
    PythonAPI::evalScript("exitCase_statement", this, (parser_rule_context *) ctx);
  }

  void enterCase_keyword(SV3_1aParser::Case_keywordContext * ctx) override {
    PythonAPI::evalScript("enterCase_keyword", this, (parser_rule_context *) ctx);
  }
  void exitCase_keyword(SV3_1aParser::Case_keywordContext * ctx) override {
    PythonAPI::evalScript("exitCase_keyword", this, (parser_rule_context *) ctx);
  }

  void enterCase_item(SV3_1aParser::Case_itemContext * ctx) override {
    PythonAPI::evalScript("enterCase_item", this, (parser_rule_context *) ctx);
  }
  void exitCase_item(SV3_1aParser::Case_itemContext * ctx) override {
    PythonAPI::evalScript("exitCase_item", this, (parser_rule_context *) ctx);
  }

  void enterCase_pattern_item(SV3_1aParser::Case_pattern_itemContext * ctx) override {
    PythonAPI::evalScript("enterCase_pattern_item", this, (parser_rule_context *) ctx);
  }
  void exitCase_pattern_item(SV3_1aParser::Case_pattern_itemContext * ctx) override {
    PythonAPI::evalScript("exitCase_pattern_item", this, (parser_rule_context *) ctx);
  }

  void enterCase_inside_item(SV3_1aParser::Case_inside_itemContext * ctx) override {
    PythonAPI::evalScript("enterCase_inside_item", this, (parser_rule_context *) ctx);
  }
  void exitCase_inside_item(SV3_1aParser::Case_inside_itemContext * ctx) override {
    PythonAPI::evalScript("exitCase_inside_item", this, (parser_rule_context *) ctx);
  }

  void enterRandcase_statement(SV3_1aParser::Randcase_statementContext * ctx) override {
    PythonAPI::evalScript("enterRandcase_statement", this, (parser_rule_context *) ctx);
  }
  void exitRandcase_statement(SV3_1aParser::Randcase_statementContext * ctx) override {
    PythonAPI::evalScript("exitRandcase_statement", this, (parser_rule_context *) ctx);
  }

  void enterRandcase_item(SV3_1aParser::Randcase_itemContext * ctx) override {
    PythonAPI::evalScript("enterRandcase_item", this, (parser_rule_context *) ctx);
  }
  void exitRandcase_item(SV3_1aParser::Randcase_itemContext * ctx) override {
    PythonAPI::evalScript("exitRandcase_item", this, (parser_rule_context *) ctx);
  }

  void enterPattern(SV3_1aParser::PatternContext * ctx) override {
    PythonAPI::evalScript("enterPattern", this, (parser_rule_context *) ctx);
  }
  void exitPattern(SV3_1aParser::PatternContext * ctx) override {
    PythonAPI::evalScript("exitPattern", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_pattern(SV3_1aParser::Assignment_patternContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_pattern", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_pattern(SV3_1aParser::Assignment_patternContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_pattern", this, (parser_rule_context *) ctx);
  }

  void enterStructure_pattern_key(SV3_1aParser::Structure_pattern_keyContext * ctx) override {
    PythonAPI::evalScript("enterStructure_pattern_key", this, (parser_rule_context *) ctx);
  }
  void exitStructure_pattern_key(SV3_1aParser::Structure_pattern_keyContext * ctx) override {
    PythonAPI::evalScript("exitStructure_pattern_key", this, (parser_rule_context *) ctx);
  }

  void enterArray_pattern_key(SV3_1aParser::Array_pattern_keyContext * ctx) override {
    PythonAPI::evalScript("enterArray_pattern_key", this, (parser_rule_context *) ctx);
  }
  void exitArray_pattern_key(SV3_1aParser::Array_pattern_keyContext * ctx) override {
    PythonAPI::evalScript("exitArray_pattern_key", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_pattern_key(SV3_1aParser::Assignment_pattern_keyContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_pattern_key", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_pattern_key(SV3_1aParser::Assignment_pattern_keyContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_pattern_key", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_pattern_expression(SV3_1aParser::Assignment_pattern_expressionContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_pattern_expression", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_pattern_expression(SV3_1aParser::Assignment_pattern_expressionContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_pattern_expression", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_pattern_expression_type(SV3_1aParser::Assignment_pattern_expression_typeContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_pattern_expression_type", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_pattern_expression_type(SV3_1aParser::Assignment_pattern_expression_typeContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_pattern_expression_type", this, (parser_rule_context *) ctx);
  }

  void enterConstant_assignment_pattern_expression(SV3_1aParser::Constant_assignment_pattern_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConstant_assignment_pattern_expression", this, (parser_rule_context *) ctx);
  }
  void exitConstant_assignment_pattern_expression(SV3_1aParser::Constant_assignment_pattern_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConstant_assignment_pattern_expression", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_pattern_net_lvalue(SV3_1aParser::Assignment_pattern_net_lvalueContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_pattern_net_lvalue", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_pattern_net_lvalue(SV3_1aParser::Assignment_pattern_net_lvalueContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_pattern_net_lvalue", this, (parser_rule_context *) ctx);
  }

  void enterAssignment_pattern_variable_lvalue(SV3_1aParser::Assignment_pattern_variable_lvalueContext * ctx) override {
    PythonAPI::evalScript("enterAssignment_pattern_variable_lvalue", this, (parser_rule_context *) ctx);
  }
  void exitAssignment_pattern_variable_lvalue(SV3_1aParser::Assignment_pattern_variable_lvalueContext * ctx) override {
    PythonAPI::evalScript("exitAssignment_pattern_variable_lvalue", this, (parser_rule_context *) ctx);
  }

  void enterLoop_statement(SV3_1aParser::Loop_statementContext * ctx) override {
    PythonAPI::evalScript("enterLoop_statement", this, (parser_rule_context *) ctx);
  }
  void exitLoop_statement(SV3_1aParser::Loop_statementContext * ctx) override {
    PythonAPI::evalScript("exitLoop_statement", this, (parser_rule_context *) ctx);
  }

  void enterFor_initialization(SV3_1aParser::For_initializationContext * ctx) override {
    PythonAPI::evalScript("enterFor_initialization", this, (parser_rule_context *) ctx);
  }
  void exitFor_initialization(SV3_1aParser::For_initializationContext * ctx) override {
    PythonAPI::evalScript("exitFor_initialization", this, (parser_rule_context *) ctx);
  }

  void enterFor_variable_declaration(SV3_1aParser::For_variable_declarationContext * ctx) override {
    PythonAPI::evalScript("enterFor_variable_declaration", this, (parser_rule_context *) ctx);
  }
  void exitFor_variable_declaration(SV3_1aParser::For_variable_declarationContext * ctx) override {
    PythonAPI::evalScript("exitFor_variable_declaration", this, (parser_rule_context *) ctx);
  }

  void enterFor_step(SV3_1aParser::For_stepContext * ctx) override {
    PythonAPI::evalScript("enterFor_step", this, (parser_rule_context *) ctx);
  }
  void exitFor_step(SV3_1aParser::For_stepContext * ctx) override {
    PythonAPI::evalScript("exitFor_step", this, (parser_rule_context *) ctx);
  }

  void enterFor_step_assignment(SV3_1aParser::For_step_assignmentContext * ctx) override {
    PythonAPI::evalScript("enterFor_step_assignment", this, (parser_rule_context *) ctx);
  }
  void exitFor_step_assignment(SV3_1aParser::For_step_assignmentContext * ctx) override {
    PythonAPI::evalScript("exitFor_step_assignment", this, (parser_rule_context *) ctx);
  }

  void enterComma(SV3_1aParser::CommaContext * ctx) override {
    PythonAPI::evalScript("enterComma", this, (parser_rule_context *) ctx);
  }
  void exitComma(SV3_1aParser::CommaContext * ctx) override {
    PythonAPI::evalScript("exitComma", this, (parser_rule_context *) ctx);
  }

  void enterLoop_variables(SV3_1aParser::Loop_variablesContext * ctx) override {
    PythonAPI::evalScript("enterLoop_variables", this, (parser_rule_context *) ctx);
  }
  void exitLoop_variables(SV3_1aParser::Loop_variablesContext * ctx) override {
    PythonAPI::evalScript("exitLoop_variables", this, (parser_rule_context *) ctx);
  }

  void enterSubroutine_call_statement(SV3_1aParser::Subroutine_call_statementContext * ctx) override {
    PythonAPI::evalScript("enterSubroutine_call_statement", this, (parser_rule_context *) ctx);
  }
  void exitSubroutine_call_statement(SV3_1aParser::Subroutine_call_statementContext * ctx) override {
    PythonAPI::evalScript("exitSubroutine_call_statement", this, (parser_rule_context *) ctx);
  }

  void enterAssertion_item(SV3_1aParser::Assertion_itemContext * ctx) override {
    PythonAPI::evalScript("enterAssertion_item", this, (parser_rule_context *) ctx);
  }
  void exitAssertion_item(SV3_1aParser::Assertion_itemContext * ctx) override {
    PythonAPI::evalScript("exitAssertion_item", this, (parser_rule_context *) ctx);
  }

  void enterDeferred_immediate_assertion_item(SV3_1aParser::Deferred_immediate_assertion_itemContext * ctx) override {
    PythonAPI::evalScript("enterDeferred_immediate_assertion_item", this, (parser_rule_context *) ctx);
  }
  void exitDeferred_immediate_assertion_item(SV3_1aParser::Deferred_immediate_assertion_itemContext * ctx) override {
    PythonAPI::evalScript("exitDeferred_immediate_assertion_item", this, (parser_rule_context *) ctx);
  }

  void enterProcedural_assertion_statement(SV3_1aParser::Procedural_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("enterProcedural_assertion_statement", this, (parser_rule_context *) ctx);
  }
  void exitProcedural_assertion_statement(SV3_1aParser::Procedural_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("exitProcedural_assertion_statement", this, (parser_rule_context *) ctx);
  }

  void enterImmediate_assertion_statement(SV3_1aParser::Immediate_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("enterImmediate_assertion_statement", this, (parser_rule_context *) ctx);
  }
  void exitImmediate_assertion_statement(SV3_1aParser::Immediate_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("exitImmediate_assertion_statement", this, (parser_rule_context *) ctx);
  }

  void enterSimple_immediate_assertion_statement(SV3_1aParser::Simple_immediate_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("enterSimple_immediate_assertion_statement", this, (parser_rule_context *) ctx);
  }
  void exitSimple_immediate_assertion_statement(SV3_1aParser::Simple_immediate_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("exitSimple_immediate_assertion_statement", this, (parser_rule_context *) ctx);
  }

  void enterSimple_immediate_assert_statement(SV3_1aParser::Simple_immediate_assert_statementContext * ctx) override {
    PythonAPI::evalScript("enterSimple_immediate_assert_statement", this, (parser_rule_context *) ctx);
  }
  void exitSimple_immediate_assert_statement(SV3_1aParser::Simple_immediate_assert_statementContext * ctx) override {
    PythonAPI::evalScript("exitSimple_immediate_assert_statement", this, (parser_rule_context *) ctx);
  }

  void enterSimple_immediate_assume_statement(SV3_1aParser::Simple_immediate_assume_statementContext * ctx) override {
    PythonAPI::evalScript("enterSimple_immediate_assume_statement", this, (parser_rule_context *) ctx);
  }
  void exitSimple_immediate_assume_statement(SV3_1aParser::Simple_immediate_assume_statementContext * ctx) override {
    PythonAPI::evalScript("exitSimple_immediate_assume_statement", this, (parser_rule_context *) ctx);
  }

  void enterSimple_immediate_cover_statement(SV3_1aParser::Simple_immediate_cover_statementContext * ctx) override {
    PythonAPI::evalScript("enterSimple_immediate_cover_statement", this, (parser_rule_context *) ctx);
  }
  void exitSimple_immediate_cover_statement(SV3_1aParser::Simple_immediate_cover_statementContext * ctx) override {
    PythonAPI::evalScript("exitSimple_immediate_cover_statement", this, (parser_rule_context *) ctx);
  }

  void enterDeferred_immediate_assertion_statement(SV3_1aParser::Deferred_immediate_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("enterDeferred_immediate_assertion_statement", this, (parser_rule_context *) ctx);
  }
  void exitDeferred_immediate_assertion_statement(SV3_1aParser::Deferred_immediate_assertion_statementContext * ctx) override {
    PythonAPI::evalScript("exitDeferred_immediate_assertion_statement", this, (parser_rule_context *) ctx);
  }

  void enterDeferred_immediate_assert_statement(SV3_1aParser::Deferred_immediate_assert_statementContext * ctx) override {
    PythonAPI::evalScript("enterDeferred_immediate_assert_statement", this, (parser_rule_context *) ctx);
  }
  void exitDeferred_immediate_assert_statement(SV3_1aParser::Deferred_immediate_assert_statementContext * ctx) override {
    PythonAPI::evalScript("exitDeferred_immediate_assert_statement", this, (parser_rule_context *) ctx);
  }

  void enterDeferred_immediate_assume_statement(SV3_1aParser::Deferred_immediate_assume_statementContext * ctx) override {
    PythonAPI::evalScript("enterDeferred_immediate_assume_statement", this, (parser_rule_context *) ctx);
  }
  void exitDeferred_immediate_assume_statement(SV3_1aParser::Deferred_immediate_assume_statementContext * ctx) override {
    PythonAPI::evalScript("exitDeferred_immediate_assume_statement", this, (parser_rule_context *) ctx);
  }

  void enterDeferred_immediate_cover_statement(SV3_1aParser::Deferred_immediate_cover_statementContext * ctx) override {
    PythonAPI::evalScript("enterDeferred_immediate_cover_statement", this, (parser_rule_context *) ctx);
  }
  void exitDeferred_immediate_cover_statement(SV3_1aParser::Deferred_immediate_cover_statementContext * ctx) override {
    PythonAPI::evalScript("exitDeferred_immediate_cover_statement", this, (parser_rule_context *) ctx);
  }

  void enterClocking_declaration(SV3_1aParser::Clocking_declarationContext * ctx) override {
    PythonAPI::evalScript("enterClocking_declaration", this, (parser_rule_context *) ctx);
  }
  void exitClocking_declaration(SV3_1aParser::Clocking_declarationContext * ctx) override {
    PythonAPI::evalScript("exitClocking_declaration", this, (parser_rule_context *) ctx);
  }

  void enterClocking_event(SV3_1aParser::Clocking_eventContext * ctx) override {
    PythonAPI::evalScript("enterClocking_event", this, (parser_rule_context *) ctx);
  }
  void exitClocking_event(SV3_1aParser::Clocking_eventContext * ctx) override {
    PythonAPI::evalScript("exitClocking_event", this, (parser_rule_context *) ctx);
  }

  void enterClocking_item(SV3_1aParser::Clocking_itemContext * ctx) override {
    PythonAPI::evalScript("enterClocking_item", this, (parser_rule_context *) ctx);
  }
  void exitClocking_item(SV3_1aParser::Clocking_itemContext * ctx) override {
    PythonAPI::evalScript("exitClocking_item", this, (parser_rule_context *) ctx);
  }

  void enterDefaultSkew_Intput(SV3_1aParser::DefaultSkew_IntputContext * ctx) override {
    PythonAPI::evalScript("enterDefaultSkew_Intput", this, (parser_rule_context *) ctx);
  }
  void exitDefaultSkew_Intput(SV3_1aParser::DefaultSkew_IntputContext * ctx) override {
    PythonAPI::evalScript("exitDefaultSkew_Intput", this, (parser_rule_context *) ctx);
  }

  void enterDefaultSkew_Output(SV3_1aParser::DefaultSkew_OutputContext * ctx) override {
    PythonAPI::evalScript("enterDefaultSkew_Output", this, (parser_rule_context *) ctx);
  }
  void exitDefaultSkew_Output(SV3_1aParser::DefaultSkew_OutputContext * ctx) override {
    PythonAPI::evalScript("exitDefaultSkew_Output", this, (parser_rule_context *) ctx);
  }

  void enterDefaultSkew_IntputOutput(SV3_1aParser::DefaultSkew_IntputOutputContext * ctx) override {
    PythonAPI::evalScript("enterDefaultSkew_IntputOutput", this, (parser_rule_context *) ctx);
  }
  void exitDefaultSkew_IntputOutput(SV3_1aParser::DefaultSkew_IntputOutputContext * ctx) override {
    PythonAPI::evalScript("exitDefaultSkew_IntputOutput", this, (parser_rule_context *) ctx);
  }

  void enterClockingDir_Input(SV3_1aParser::ClockingDir_InputContext * ctx) override {
    PythonAPI::evalScript("enterClockingDir_Input", this, (parser_rule_context *) ctx);
  }
  void exitClockingDir_Input(SV3_1aParser::ClockingDir_InputContext * ctx) override {
    PythonAPI::evalScript("exitClockingDir_Input", this, (parser_rule_context *) ctx);
  }

  void enterClockingDir_Output(SV3_1aParser::ClockingDir_OutputContext * ctx) override {
    PythonAPI::evalScript("enterClockingDir_Output", this, (parser_rule_context *) ctx);
  }
  void exitClockingDir_Output(SV3_1aParser::ClockingDir_OutputContext * ctx) override {
    PythonAPI::evalScript("exitClockingDir_Output", this, (parser_rule_context *) ctx);
  }

  void enterClockingDir_InputOutput(SV3_1aParser::ClockingDir_InputOutputContext * ctx) override {
    PythonAPI::evalScript("enterClockingDir_InputOutput", this, (parser_rule_context *) ctx);
  }
  void exitClockingDir_InputOutput(SV3_1aParser::ClockingDir_InputOutputContext * ctx) override {
    PythonAPI::evalScript("exitClockingDir_InputOutput", this, (parser_rule_context *) ctx);
  }

  void enterClockingDir_Inout(SV3_1aParser::ClockingDir_InoutContext * ctx) override {
    PythonAPI::evalScript("enterClockingDir_Inout", this, (parser_rule_context *) ctx);
  }
  void exitClockingDir_Inout(SV3_1aParser::ClockingDir_InoutContext * ctx) override {
    PythonAPI::evalScript("exitClockingDir_Inout", this, (parser_rule_context *) ctx);
  }

  void enterList_of_clocking_decl_assign(SV3_1aParser::List_of_clocking_decl_assignContext * ctx) override {
    PythonAPI::evalScript("enterList_of_clocking_decl_assign", this, (parser_rule_context *) ctx);
  }
  void exitList_of_clocking_decl_assign(SV3_1aParser::List_of_clocking_decl_assignContext * ctx) override {
    PythonAPI::evalScript("exitList_of_clocking_decl_assign", this, (parser_rule_context *) ctx);
  }

  void enterClocking_decl_assign(SV3_1aParser::Clocking_decl_assignContext * ctx) override {
    PythonAPI::evalScript("enterClocking_decl_assign", this, (parser_rule_context *) ctx);
  }
  void exitClocking_decl_assign(SV3_1aParser::Clocking_decl_assignContext * ctx) override {
    PythonAPI::evalScript("exitClocking_decl_assign", this, (parser_rule_context *) ctx);
  }

  void enterClocking_skew(SV3_1aParser::Clocking_skewContext * ctx) override {
    PythonAPI::evalScript("enterClocking_skew", this, (parser_rule_context *) ctx);
  }
  void exitClocking_skew(SV3_1aParser::Clocking_skewContext * ctx) override {
    PythonAPI::evalScript("exitClocking_skew", this, (parser_rule_context *) ctx);
  }

  void enterEdge_identifier(SV3_1aParser::Edge_identifierContext * ctx) override {
    PythonAPI::evalScript("enterEdge_identifier", this, (parser_rule_context *) ctx);
  }
  void exitEdge_identifier(SV3_1aParser::Edge_identifierContext * ctx) override {
    PythonAPI::evalScript("exitEdge_identifier", this, (parser_rule_context *) ctx);
  }

  void enterClocking_drive(SV3_1aParser::Clocking_driveContext * ctx) override {
    PythonAPI::evalScript("enterClocking_drive", this, (parser_rule_context *) ctx);
  }
  void exitClocking_drive(SV3_1aParser::Clocking_driveContext * ctx) override {
    PythonAPI::evalScript("exitClocking_drive", this, (parser_rule_context *) ctx);
  }

  void enterCycle_delay(SV3_1aParser::Cycle_delayContext * ctx) override {
    PythonAPI::evalScript("enterCycle_delay", this, (parser_rule_context *) ctx);
  }
  void exitCycle_delay(SV3_1aParser::Cycle_delayContext * ctx) override {
    PythonAPI::evalScript("exitCycle_delay", this, (parser_rule_context *) ctx);
  }

  void enterClockvar(SV3_1aParser::ClockvarContext * ctx) override {
    PythonAPI::evalScript("enterClockvar", this, (parser_rule_context *) ctx);
  }
  void exitClockvar(SV3_1aParser::ClockvarContext * ctx) override {
    PythonAPI::evalScript("exitClockvar", this, (parser_rule_context *) ctx);
  }

  void enterClockvar_expression(SV3_1aParser::Clockvar_expressionContext * ctx) override {
    PythonAPI::evalScript("enterClockvar_expression", this, (parser_rule_context *) ctx);
  }
  void exitClockvar_expression(SV3_1aParser::Clockvar_expressionContext * ctx) override {
    PythonAPI::evalScript("exitClockvar_expression", this, (parser_rule_context *) ctx);
  }

  void enterRandsequence_statement(SV3_1aParser::Randsequence_statementContext * ctx) override {
    PythonAPI::evalScript("enterRandsequence_statement", this, (parser_rule_context *) ctx);
  }
  void exitRandsequence_statement(SV3_1aParser::Randsequence_statementContext * ctx) override {
    PythonAPI::evalScript("exitRandsequence_statement", this, (parser_rule_context *) ctx);
  }

  void enterProduction(SV3_1aParser::ProductionContext * ctx) override {
    PythonAPI::evalScript("enterProduction", this, (parser_rule_context *) ctx);
  }
  void exitProduction(SV3_1aParser::ProductionContext * ctx) override {
    PythonAPI::evalScript("exitProduction", this, (parser_rule_context *) ctx);
  }

  void enterRs_rule(SV3_1aParser::Rs_ruleContext * ctx) override {
    PythonAPI::evalScript("enterRs_rule", this, (parser_rule_context *) ctx);
  }
  void exitRs_rule(SV3_1aParser::Rs_ruleContext * ctx) override {
    PythonAPI::evalScript("exitRs_rule", this, (parser_rule_context *) ctx);
  }

  void enterRs_production_list(SV3_1aParser::Rs_production_listContext * ctx) override {
    PythonAPI::evalScript("enterRs_production_list", this, (parser_rule_context *) ctx);
  }
  void exitRs_production_list(SV3_1aParser::Rs_production_listContext * ctx) override {
    PythonAPI::evalScript("exitRs_production_list", this, (parser_rule_context *) ctx);
  }

  void enterRs_code_block(SV3_1aParser::Rs_code_blockContext * ctx) override {
    PythonAPI::evalScript("enterRs_code_block", this, (parser_rule_context *) ctx);
  }
  void exitRs_code_block(SV3_1aParser::Rs_code_blockContext * ctx) override {
    PythonAPI::evalScript("exitRs_code_block", this, (parser_rule_context *) ctx);
  }

  void enterRs_prod(SV3_1aParser::Rs_prodContext * ctx) override {
    PythonAPI::evalScript("enterRs_prod", this, (parser_rule_context *) ctx);
  }
  void exitRs_prod(SV3_1aParser::Rs_prodContext * ctx) override {
    PythonAPI::evalScript("exitRs_prod", this, (parser_rule_context *) ctx);
  }

  void enterProduction_item(SV3_1aParser::Production_itemContext * ctx) override {
    PythonAPI::evalScript("enterProduction_item", this, (parser_rule_context *) ctx);
  }
  void exitProduction_item(SV3_1aParser::Production_itemContext * ctx) override {
    PythonAPI::evalScript("exitProduction_item", this, (parser_rule_context *) ctx);
  }

  void enterRs_if_else(SV3_1aParser::Rs_if_elseContext * ctx) override {
    PythonAPI::evalScript("enterRs_if_else", this, (parser_rule_context *) ctx);
  }
  void exitRs_if_else(SV3_1aParser::Rs_if_elseContext * ctx) override {
    PythonAPI::evalScript("exitRs_if_else", this, (parser_rule_context *) ctx);
  }

  void enterRs_repeat(SV3_1aParser::Rs_repeatContext * ctx) override {
    PythonAPI::evalScript("enterRs_repeat", this, (parser_rule_context *) ctx);
  }
  void exitRs_repeat(SV3_1aParser::Rs_repeatContext * ctx) override {
    PythonAPI::evalScript("exitRs_repeat", this, (parser_rule_context *) ctx);
  }

  void enterRs_case(SV3_1aParser::Rs_caseContext * ctx) override {
    PythonAPI::evalScript("enterRs_case", this, (parser_rule_context *) ctx);
  }
  void exitRs_case(SV3_1aParser::Rs_caseContext * ctx) override {
    PythonAPI::evalScript("exitRs_case", this, (parser_rule_context *) ctx);
  }

  void enterRs_case_item(SV3_1aParser::Rs_case_itemContext * ctx) override {
    PythonAPI::evalScript("enterRs_case_item", this, (parser_rule_context *) ctx);
  }
  void exitRs_case_item(SV3_1aParser::Rs_case_itemContext * ctx) override {
    PythonAPI::evalScript("exitRs_case_item", this, (parser_rule_context *) ctx);
  }

  void enterSpecify_block(SV3_1aParser::Specify_blockContext * ctx) override {
    PythonAPI::evalScript("enterSpecify_block", this, (parser_rule_context *) ctx);
  }
  void exitSpecify_block(SV3_1aParser::Specify_blockContext * ctx) override {
    PythonAPI::evalScript("exitSpecify_block", this, (parser_rule_context *) ctx);
  }

  void enterSpecify_item(SV3_1aParser::Specify_itemContext * ctx) override {
    PythonAPI::evalScript("enterSpecify_item", this, (parser_rule_context *) ctx);
  }
  void exitSpecify_item(SV3_1aParser::Specify_itemContext * ctx) override {
    PythonAPI::evalScript("exitSpecify_item", this, (parser_rule_context *) ctx);
  }

  void enterPulsestyle_declaration(SV3_1aParser::Pulsestyle_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPulsestyle_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPulsestyle_declaration(SV3_1aParser::Pulsestyle_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPulsestyle_declaration", this, (parser_rule_context *) ctx);
  }

  void enterShowcancelled_declaration(SV3_1aParser::Showcancelled_declarationContext * ctx) override {
    PythonAPI::evalScript("enterShowcancelled_declaration", this, (parser_rule_context *) ctx);
  }
  void exitShowcancelled_declaration(SV3_1aParser::Showcancelled_declarationContext * ctx) override {
    PythonAPI::evalScript("exitShowcancelled_declaration", this, (parser_rule_context *) ctx);
  }

  void enterPath_declaration(SV3_1aParser::Path_declarationContext * ctx) override {
    PythonAPI::evalScript("enterPath_declaration", this, (parser_rule_context *) ctx);
  }
  void exitPath_declaration(SV3_1aParser::Path_declarationContext * ctx) override {
    PythonAPI::evalScript("exitPath_declaration", this, (parser_rule_context *) ctx);
  }

  void enterSimple_path_declaration(SV3_1aParser::Simple_path_declarationContext * ctx) override {
    PythonAPI::evalScript("enterSimple_path_declaration", this, (parser_rule_context *) ctx);
  }
  void exitSimple_path_declaration(SV3_1aParser::Simple_path_declarationContext * ctx) override {
    PythonAPI::evalScript("exitSimple_path_declaration", this, (parser_rule_context *) ctx);
  }

  void enterParallel_path_description(SV3_1aParser::Parallel_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("enterParallel_path_description", this, (parser_rule_context *) ctx);
  }
  void exitParallel_path_description(SV3_1aParser::Parallel_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("exitParallel_path_description", this, (parser_rule_context *) ctx);
  }

  void enterFull_path_description(SV3_1aParser::Full_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("enterFull_path_description", this, (parser_rule_context *) ctx);
  }
  void exitFull_path_description(SV3_1aParser::Full_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("exitFull_path_description", this, (parser_rule_context *) ctx);
  }

  void enterList_of_path_inputs(SV3_1aParser::List_of_path_inputsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_path_inputs", this, (parser_rule_context *) ctx);
  }
  void exitList_of_path_inputs(SV3_1aParser::List_of_path_inputsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_path_inputs", this, (parser_rule_context *) ctx);
  }

  void enterList_of_path_outputs(SV3_1aParser::List_of_path_outputsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_path_outputs", this, (parser_rule_context *) ctx);
  }
  void exitList_of_path_outputs(SV3_1aParser::List_of_path_outputsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_path_outputs", this, (parser_rule_context *) ctx);
  }

  void enterSpecify_input_terminal_descriptor(SV3_1aParser::Specify_input_terminal_descriptorContext * ctx) override {
    PythonAPI::evalScript("enterSpecify_input_terminal_descriptor", this, (parser_rule_context *) ctx);
  }
  void exitSpecify_input_terminal_descriptor(SV3_1aParser::Specify_input_terminal_descriptorContext * ctx) override {
    PythonAPI::evalScript("exitSpecify_input_terminal_descriptor", this, (parser_rule_context *) ctx);
  }

  void enterSpecify_output_terminal_descriptor(SV3_1aParser::Specify_output_terminal_descriptorContext * ctx) override {
    PythonAPI::evalScript("enterSpecify_output_terminal_descriptor", this, (parser_rule_context *) ctx);
  }
  void exitSpecify_output_terminal_descriptor(SV3_1aParser::Specify_output_terminal_descriptorContext * ctx) override {
    PythonAPI::evalScript("exitSpecify_output_terminal_descriptor", this, (parser_rule_context *) ctx);
  }

  void enterPath_delay_value(SV3_1aParser::Path_delay_valueContext * ctx) override {
    PythonAPI::evalScript("enterPath_delay_value", this, (parser_rule_context *) ctx);
  }
  void exitPath_delay_value(SV3_1aParser::Path_delay_valueContext * ctx) override {
    PythonAPI::evalScript("exitPath_delay_value", this, (parser_rule_context *) ctx);
  }

  void enterList_of_path_delay_expressions(SV3_1aParser::List_of_path_delay_expressionsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_path_delay_expressions", this, (parser_rule_context *) ctx);
  }
  void exitList_of_path_delay_expressions(SV3_1aParser::List_of_path_delay_expressionsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_path_delay_expressions", this, (parser_rule_context *) ctx);
  }

  void enterT_path_delay_expression(SV3_1aParser::T_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT_path_delay_expression(SV3_1aParser::T_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTrise_path_delay_expression(SV3_1aParser::Trise_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTrise_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTrise_path_delay_expression(SV3_1aParser::Trise_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTrise_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTfall_path_delay_expression(SV3_1aParser::Tfall_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTfall_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTfall_path_delay_expression(SV3_1aParser::Tfall_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTfall_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTz_path_delay_expression(SV3_1aParser::Tz_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTz_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTz_path_delay_expression(SV3_1aParser::Tz_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTz_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterT01_path_delay_expression(SV3_1aParser::T01_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT01_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT01_path_delay_expression(SV3_1aParser::T01_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT01_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterT10_path_delay_expression(SV3_1aParser::T10_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT10_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT10_path_delay_expression(SV3_1aParser::T10_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT10_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterT0z_path_delay_expression(SV3_1aParser::T0z_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT0z_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT0z_path_delay_expression(SV3_1aParser::T0z_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT0z_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTz1_path_delay_expression(SV3_1aParser::Tz1_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTz1_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTz1_path_delay_expression(SV3_1aParser::Tz1_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTz1_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterT1z_path_delay_expression(SV3_1aParser::T1z_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT1z_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT1z_path_delay_expression(SV3_1aParser::T1z_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT1z_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTz0_path_delay_expression(SV3_1aParser::Tz0_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTz0_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTz0_path_delay_expression(SV3_1aParser::Tz0_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTz0_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterT0x_path_delay_expression(SV3_1aParser::T0x_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT0x_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT0x_path_delay_expression(SV3_1aParser::T0x_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT0x_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTx1_path_delay_expression(SV3_1aParser::Tx1_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTx1_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTx1_path_delay_expression(SV3_1aParser::Tx1_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTx1_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterT1x_path_delay_expression(SV3_1aParser::T1x_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterT1x_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitT1x_path_delay_expression(SV3_1aParser::T1x_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitT1x_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTx0_path_delay_expression(SV3_1aParser::Tx0_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTx0_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTx0_path_delay_expression(SV3_1aParser::Tx0_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTx0_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTxz_path_delay_expression(SV3_1aParser::Txz_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTxz_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTxz_path_delay_expression(SV3_1aParser::Txz_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTxz_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterTzx_path_delay_expression(SV3_1aParser::Tzx_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterTzx_path_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitTzx_path_delay_expression(SV3_1aParser::Tzx_path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitTzx_path_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterPath_delay_expression(SV3_1aParser::Path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("enterPath_delay_expression", this, (parser_rule_context *) ctx);
  }
  void exitPath_delay_expression(SV3_1aParser::Path_delay_expressionContext * ctx) override {
    PythonAPI::evalScript("exitPath_delay_expression", this, (parser_rule_context *) ctx);
  }

  void enterEdge_sensitive_path_declaration(SV3_1aParser::Edge_sensitive_path_declarationContext * ctx) override {
    PythonAPI::evalScript("enterEdge_sensitive_path_declaration", this, (parser_rule_context *) ctx);
  }
  void exitEdge_sensitive_path_declaration(SV3_1aParser::Edge_sensitive_path_declarationContext * ctx) override {
    PythonAPI::evalScript("exitEdge_sensitive_path_declaration", this, (parser_rule_context *) ctx);
  }

  void enterParallel_edge_sensitive_path_description(SV3_1aParser::Parallel_edge_sensitive_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("enterParallel_edge_sensitive_path_description", this, (parser_rule_context *) ctx);
  }
  void exitParallel_edge_sensitive_path_description(SV3_1aParser::Parallel_edge_sensitive_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("exitParallel_edge_sensitive_path_description", this, (parser_rule_context *) ctx);
  }

  void enterFull_edge_sensitive_path_description(SV3_1aParser::Full_edge_sensitive_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("enterFull_edge_sensitive_path_description", this, (parser_rule_context *) ctx);
  }
  void exitFull_edge_sensitive_path_description(SV3_1aParser::Full_edge_sensitive_path_descriptionContext * ctx) override {
    PythonAPI::evalScript("exitFull_edge_sensitive_path_description", this, (parser_rule_context *) ctx);
  }

  void enterState_dependent_path_declaration(SV3_1aParser::State_dependent_path_declarationContext * ctx) override {
    PythonAPI::evalScript("enterState_dependent_path_declaration", this, (parser_rule_context *) ctx);
  }
  void exitState_dependent_path_declaration(SV3_1aParser::State_dependent_path_declarationContext * ctx) override {
    PythonAPI::evalScript("exitState_dependent_path_declaration", this, (parser_rule_context *) ctx);
  }

  void enterSystem_timing_check(SV3_1aParser::System_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterSystem_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitSystem_timing_check(SV3_1aParser::System_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitSystem_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_setup_timing_check(SV3_1aParser::Dollar_setup_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_setup_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_setup_timing_check(SV3_1aParser::Dollar_setup_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_setup_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_hold_timing_check(SV3_1aParser::Dollar_hold_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_hold_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_hold_timing_check(SV3_1aParser::Dollar_hold_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_hold_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_setuphold_timing_check(SV3_1aParser::Dollar_setuphold_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_setuphold_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_setuphold_timing_check(SV3_1aParser::Dollar_setuphold_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_setuphold_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_recovery_timing_check(SV3_1aParser::Dollar_recovery_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_recovery_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_recovery_timing_check(SV3_1aParser::Dollar_recovery_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_recovery_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_removal_timing_check(SV3_1aParser::Dollar_removal_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_removal_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_removal_timing_check(SV3_1aParser::Dollar_removal_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_removal_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_recrem_timing_check(SV3_1aParser::Dollar_recrem_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_recrem_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_recrem_timing_check(SV3_1aParser::Dollar_recrem_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_recrem_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_skew_timing_check(SV3_1aParser::Dollar_skew_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_skew_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_skew_timing_check(SV3_1aParser::Dollar_skew_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_skew_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_timeskew_timing_check(SV3_1aParser::Dollar_timeskew_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_timeskew_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_timeskew_timing_check(SV3_1aParser::Dollar_timeskew_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_timeskew_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_fullskew_timing_check(SV3_1aParser::Dollar_fullskew_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_fullskew_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_fullskew_timing_check(SV3_1aParser::Dollar_fullskew_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_fullskew_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_period_timing_check(SV3_1aParser::Dollar_period_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_period_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_period_timing_check(SV3_1aParser::Dollar_period_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_period_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_width_timing_check(SV3_1aParser::Dollar_width_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_width_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_width_timing_check(SV3_1aParser::Dollar_width_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_width_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDollar_nochange_timing_check(SV3_1aParser::Dollar_nochange_timing_checkContext * ctx) override {
    PythonAPI::evalScript("enterDollar_nochange_timing_check", this, (parser_rule_context *) ctx);
  }
  void exitDollar_nochange_timing_check(SV3_1aParser::Dollar_nochange_timing_checkContext * ctx) override {
    PythonAPI::evalScript("exitDollar_nochange_timing_check", this, (parser_rule_context *) ctx);
  }

  void enterDelayed_data(SV3_1aParser::Delayed_dataContext * ctx) override {
    PythonAPI::evalScript("enterDelayed_data", this, (parser_rule_context *) ctx);
  }
  void exitDelayed_data(SV3_1aParser::Delayed_dataContext * ctx) override {
    PythonAPI::evalScript("exitDelayed_data", this, (parser_rule_context *) ctx);
  }

  void enterDelayed_reference(SV3_1aParser::Delayed_referenceContext * ctx) override {
    PythonAPI::evalScript("enterDelayed_reference", this, (parser_rule_context *) ctx);
  }
  void exitDelayed_reference(SV3_1aParser::Delayed_referenceContext * ctx) override {
    PythonAPI::evalScript("exitDelayed_reference", this, (parser_rule_context *) ctx);
  }

  void enterEnd_edge_offset(SV3_1aParser::End_edge_offsetContext * ctx) override {
    PythonAPI::evalScript("enterEnd_edge_offset", this, (parser_rule_context *) ctx);
  }
  void exitEnd_edge_offset(SV3_1aParser::End_edge_offsetContext * ctx) override {
    PythonAPI::evalScript("exitEnd_edge_offset", this, (parser_rule_context *) ctx);
  }

  void enterEvent_based_flag(SV3_1aParser::Event_based_flagContext * ctx) override {
    PythonAPI::evalScript("enterEvent_based_flag", this, (parser_rule_context *) ctx);
  }
  void exitEvent_based_flag(SV3_1aParser::Event_based_flagContext * ctx) override {
    PythonAPI::evalScript("exitEvent_based_flag", this, (parser_rule_context *) ctx);
  }

  void enterNotifier(SV3_1aParser::NotifierContext * ctx) override {
    PythonAPI::evalScript("enterNotifier", this, (parser_rule_context *) ctx);
  }
  void exitNotifier(SV3_1aParser::NotifierContext * ctx) override {
    PythonAPI::evalScript("exitNotifier", this, (parser_rule_context *) ctx);
  }

  void enterReference_event(SV3_1aParser::Reference_eventContext * ctx) override {
    PythonAPI::evalScript("enterReference_event", this, (parser_rule_context *) ctx);
  }
  void exitReference_event(SV3_1aParser::Reference_eventContext * ctx) override {
    PythonAPI::evalScript("exitReference_event", this, (parser_rule_context *) ctx);
  }

  void enterRemain_active_flag(SV3_1aParser::Remain_active_flagContext * ctx) override {
    PythonAPI::evalScript("enterRemain_active_flag", this, (parser_rule_context *) ctx);
  }
  void exitRemain_active_flag(SV3_1aParser::Remain_active_flagContext * ctx) override {
    PythonAPI::evalScript("exitRemain_active_flag", this, (parser_rule_context *) ctx);
  }

  void enterStamptime_condition(SV3_1aParser::Stamptime_conditionContext * ctx) override {
    PythonAPI::evalScript("enterStamptime_condition", this, (parser_rule_context *) ctx);
  }
  void exitStamptime_condition(SV3_1aParser::Stamptime_conditionContext * ctx) override {
    PythonAPI::evalScript("exitStamptime_condition", this, (parser_rule_context *) ctx);
  }

  void enterStart_edge_offset(SV3_1aParser::Start_edge_offsetContext * ctx) override {
    PythonAPI::evalScript("enterStart_edge_offset", this, (parser_rule_context *) ctx);
  }
  void exitStart_edge_offset(SV3_1aParser::Start_edge_offsetContext * ctx) override {
    PythonAPI::evalScript("exitStart_edge_offset", this, (parser_rule_context *) ctx);
  }

  void enterThreshold(SV3_1aParser::ThresholdContext * ctx) override {
    PythonAPI::evalScript("enterThreshold", this, (parser_rule_context *) ctx);
  }
  void exitThreshold(SV3_1aParser::ThresholdContext * ctx) override {
    PythonAPI::evalScript("exitThreshold", this, (parser_rule_context *) ctx);
  }

  void enterTiming_check_limit(SV3_1aParser::Timing_check_limitContext * ctx) override {
    PythonAPI::evalScript("enterTiming_check_limit", this, (parser_rule_context *) ctx);
  }
  void exitTiming_check_limit(SV3_1aParser::Timing_check_limitContext * ctx) override {
    PythonAPI::evalScript("exitTiming_check_limit", this, (parser_rule_context *) ctx);
  }

  void enterTiming_check_event(SV3_1aParser::Timing_check_eventContext * ctx) override {
    PythonAPI::evalScript("enterTiming_check_event", this, (parser_rule_context *) ctx);
  }
  void exitTiming_check_event(SV3_1aParser::Timing_check_eventContext * ctx) override {
    PythonAPI::evalScript("exitTiming_check_event", this, (parser_rule_context *) ctx);
  }

  void enterControlled_timing_check_event(SV3_1aParser::Controlled_timing_check_eventContext * ctx) override {
    PythonAPI::evalScript("enterControlled_timing_check_event", this, (parser_rule_context *) ctx);
  }
  void exitControlled_timing_check_event(SV3_1aParser::Controlled_timing_check_eventContext * ctx) override {
    PythonAPI::evalScript("exitControlled_timing_check_event", this, (parser_rule_context *) ctx);
  }

  void enterTimingCheckEventControl_Posedge(SV3_1aParser::TimingCheckEventControl_PosedgeContext * ctx) override {
    PythonAPI::evalScript("enterTimingCheckEventControl_Posedge", this, (parser_rule_context *) ctx);
  }
  void exitTimingCheckEventControl_Posedge(SV3_1aParser::TimingCheckEventControl_PosedgeContext * ctx) override {
    PythonAPI::evalScript("exitTimingCheckEventControl_Posedge", this, (parser_rule_context *) ctx);
  }

  void enterTimingCheckEventControl_Negedge(SV3_1aParser::TimingCheckEventControl_NegedgeContext * ctx) override {
    PythonAPI::evalScript("enterTimingCheckEventControl_Negedge", this, (parser_rule_context *) ctx);
  }
  void exitTimingCheckEventControl_Negedge(SV3_1aParser::TimingCheckEventControl_NegedgeContext * ctx) override {
    PythonAPI::evalScript("exitTimingCheckEventControl_Negedge", this, (parser_rule_context *) ctx);
  }

  void enterTimingCheckEventControl_Edge(SV3_1aParser::TimingCheckEventControl_EdgeContext * ctx) override {
    PythonAPI::evalScript("enterTimingCheckEventControl_Edge", this, (parser_rule_context *) ctx);
  }
  void exitTimingCheckEventControl_Edge(SV3_1aParser::TimingCheckEventControl_EdgeContext * ctx) override {
    PythonAPI::evalScript("exitTimingCheckEventControl_Edge", this, (parser_rule_context *) ctx);
  }

  void enterSpecify_terminal_descriptor(SV3_1aParser::Specify_terminal_descriptorContext * ctx) override {
    PythonAPI::evalScript("enterSpecify_terminal_descriptor", this, (parser_rule_context *) ctx);
  }
  void exitSpecify_terminal_descriptor(SV3_1aParser::Specify_terminal_descriptorContext * ctx) override {
    PythonAPI::evalScript("exitSpecify_terminal_descriptor", this, (parser_rule_context *) ctx);
  }

  void enterEdge_control_specifier(SV3_1aParser::Edge_control_specifierContext * ctx) override {
    PythonAPI::evalScript("enterEdge_control_specifier", this, (parser_rule_context *) ctx);
  }
  void exitEdge_control_specifier(SV3_1aParser::Edge_control_specifierContext * ctx) override {
    PythonAPI::evalScript("exitEdge_control_specifier", this, (parser_rule_context *) ctx);
  }

  void enterEdge_descriptor(SV3_1aParser::Edge_descriptorContext * ctx) override {
    PythonAPI::evalScript("enterEdge_descriptor", this, (parser_rule_context *) ctx);
  }
  void exitEdge_descriptor(SV3_1aParser::Edge_descriptorContext * ctx) override {
    PythonAPI::evalScript("exitEdge_descriptor", this, (parser_rule_context *) ctx);
  }

  void enterTiming_check_condition(SV3_1aParser::Timing_check_conditionContext * ctx) override {
    PythonAPI::evalScript("enterTiming_check_condition", this, (parser_rule_context *) ctx);
  }
  void exitTiming_check_condition(SV3_1aParser::Timing_check_conditionContext * ctx) override {
    PythonAPI::evalScript("exitTiming_check_condition", this, (parser_rule_context *) ctx);
  }

  void enterScalar_timing_check_condition(SV3_1aParser::Scalar_timing_check_conditionContext * ctx) override {
    PythonAPI::evalScript("enterScalar_timing_check_condition", this, (parser_rule_context *) ctx);
  }
  void exitScalar_timing_check_condition(SV3_1aParser::Scalar_timing_check_conditionContext * ctx) override {
    PythonAPI::evalScript("exitScalar_timing_check_condition", this, (parser_rule_context *) ctx);
  }

  void enterScalar_1Tickb0(SV3_1aParser::Scalar_1Tickb0Context * ctx) override {
    PythonAPI::evalScript("enterScalar_1Tickb0", this, (parser_rule_context *) ctx);
  }
  void exitScalar_1Tickb0(SV3_1aParser::Scalar_1Tickb0Context * ctx) override {
    PythonAPI::evalScript("exitScalar_1Tickb0", this, (parser_rule_context *) ctx);
  }

  void enterScalar_1Tickb1(SV3_1aParser::Scalar_1Tickb1Context * ctx) override {
    PythonAPI::evalScript("enterScalar_1Tickb1", this, (parser_rule_context *) ctx);
  }
  void exitScalar_1Tickb1(SV3_1aParser::Scalar_1Tickb1Context * ctx) override {
    PythonAPI::evalScript("exitScalar_1Tickb1", this, (parser_rule_context *) ctx);
  }

  void enterScalar_1TickB0(SV3_1aParser::Scalar_1TickB0Context * ctx) override {
    PythonAPI::evalScript("enterScalar_1TickB0", this, (parser_rule_context *) ctx);
  }
  void exitScalar_1TickB0(SV3_1aParser::Scalar_1TickB0Context * ctx) override {
    PythonAPI::evalScript("exitScalar_1TickB0", this, (parser_rule_context *) ctx);
  }

  void enterScalar_1TickB1(SV3_1aParser::Scalar_1TickB1Context * ctx) override {
    PythonAPI::evalScript("enterScalar_1TickB1", this, (parser_rule_context *) ctx);
  }
  void exitScalar_1TickB1(SV3_1aParser::Scalar_1TickB1Context * ctx) override {
    PythonAPI::evalScript("exitScalar_1TickB1", this, (parser_rule_context *) ctx);
  }

  void enterScalar_Tickb0(SV3_1aParser::Scalar_Tickb0Context * ctx) override {
    PythonAPI::evalScript("enterScalar_Tickb0", this, (parser_rule_context *) ctx);
  }
  void exitScalar_Tickb0(SV3_1aParser::Scalar_Tickb0Context * ctx) override {
    PythonAPI::evalScript("exitScalar_Tickb0", this, (parser_rule_context *) ctx);
  }

  void enterScalar_Tickb1(SV3_1aParser::Scalar_Tickb1Context * ctx) override {
    PythonAPI::evalScript("enterScalar_Tickb1", this, (parser_rule_context *) ctx);
  }
  void exitScalar_Tickb1(SV3_1aParser::Scalar_Tickb1Context * ctx) override {
    PythonAPI::evalScript("exitScalar_Tickb1", this, (parser_rule_context *) ctx);
  }

  void enterScalar_TickB0(SV3_1aParser::Scalar_TickB0Context * ctx) override {
    PythonAPI::evalScript("enterScalar_TickB0", this, (parser_rule_context *) ctx);
  }
  void exitScalar_TickB0(SV3_1aParser::Scalar_TickB0Context * ctx) override {
    PythonAPI::evalScript("exitScalar_TickB0", this, (parser_rule_context *) ctx);
  }

  void enterScalar_TickB1(SV3_1aParser::Scalar_TickB1Context * ctx) override {
    PythonAPI::evalScript("enterScalar_TickB1", this, (parser_rule_context *) ctx);
  }
  void exitScalar_TickB1(SV3_1aParser::Scalar_TickB1Context * ctx) override {
    PythonAPI::evalScript("exitScalar_TickB1", this, (parser_rule_context *) ctx);
  }

  void enterScalar_Integral(SV3_1aParser::Scalar_IntegralContext * ctx) override {
    PythonAPI::evalScript("enterScalar_Integral", this, (parser_rule_context *) ctx);
  }
  void exitScalar_Integral(SV3_1aParser::Scalar_IntegralContext * ctx) override {
    PythonAPI::evalScript("exitScalar_Integral", this, (parser_rule_context *) ctx);
  }

  void enterConcatenation(SV3_1aParser::ConcatenationContext * ctx) override {
    PythonAPI::evalScript("enterConcatenation", this, (parser_rule_context *) ctx);
  }
  void exitConcatenation(SV3_1aParser::ConcatenationContext * ctx) override {
    PythonAPI::evalScript("exitConcatenation", this, (parser_rule_context *) ctx);
  }

  void enterConstant_concatenation(SV3_1aParser::Constant_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterConstant_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitConstant_concatenation(SV3_1aParser::Constant_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitConstant_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterArray_member_label(SV3_1aParser::Array_member_labelContext * ctx) override {
    PythonAPI::evalScript("enterArray_member_label", this, (parser_rule_context *) ctx);
  }
  void exitArray_member_label(SV3_1aParser::Array_member_labelContext * ctx) override {
    PythonAPI::evalScript("exitArray_member_label", this, (parser_rule_context *) ctx);
  }

  void enterConstant_multiple_concatenation(SV3_1aParser::Constant_multiple_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterConstant_multiple_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitConstant_multiple_concatenation(SV3_1aParser::Constant_multiple_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitConstant_multiple_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterModule_path_concatenation(SV3_1aParser::Module_path_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterModule_path_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitModule_path_concatenation(SV3_1aParser::Module_path_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitModule_path_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterModule_path_multiple_concatenation(SV3_1aParser::Module_path_multiple_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterModule_path_multiple_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitModule_path_multiple_concatenation(SV3_1aParser::Module_path_multiple_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitModule_path_multiple_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterMultiple_concatenation(SV3_1aParser::Multiple_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterMultiple_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitMultiple_concatenation(SV3_1aParser::Multiple_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitMultiple_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterStreaming_concatenation(SV3_1aParser::Streaming_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterStreaming_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitStreaming_concatenation(SV3_1aParser::Streaming_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitStreaming_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterStream_operator(SV3_1aParser::Stream_operatorContext * ctx) override {
    PythonAPI::evalScript("enterStream_operator", this, (parser_rule_context *) ctx);
  }
  void exitStream_operator(SV3_1aParser::Stream_operatorContext * ctx) override {
    PythonAPI::evalScript("exitStream_operator", this, (parser_rule_context *) ctx);
  }

  void enterSlice_size(SV3_1aParser::Slice_sizeContext * ctx) override {
    PythonAPI::evalScript("enterSlice_size", this, (parser_rule_context *) ctx);
  }
  void exitSlice_size(SV3_1aParser::Slice_sizeContext * ctx) override {
    PythonAPI::evalScript("exitSlice_size", this, (parser_rule_context *) ctx);
  }

  void enterStream_concatenation(SV3_1aParser::Stream_concatenationContext * ctx) override {
    PythonAPI::evalScript("enterStream_concatenation", this, (parser_rule_context *) ctx);
  }
  void exitStream_concatenation(SV3_1aParser::Stream_concatenationContext * ctx) override {
    PythonAPI::evalScript("exitStream_concatenation", this, (parser_rule_context *) ctx);
  }

  void enterStream_expression(SV3_1aParser::Stream_expressionContext * ctx) override {
    PythonAPI::evalScript("enterStream_expression", this, (parser_rule_context *) ctx);
  }
  void exitStream_expression(SV3_1aParser::Stream_expressionContext * ctx) override {
    PythonAPI::evalScript("exitStream_expression", this, (parser_rule_context *) ctx);
  }

  void enterArray_range_expression(SV3_1aParser::Array_range_expressionContext * ctx) override {
    PythonAPI::evalScript("enterArray_range_expression", this, (parser_rule_context *) ctx);
  }
  void exitArray_range_expression(SV3_1aParser::Array_range_expressionContext * ctx) override {
    PythonAPI::evalScript("exitArray_range_expression", this, (parser_rule_context *) ctx);
  }

  void enterEmpty_queue(SV3_1aParser::Empty_queueContext * ctx) override {
    PythonAPI::evalScript("enterEmpty_queue", this, (parser_rule_context *) ctx);
  }
  void exitEmpty_queue(SV3_1aParser::Empty_queueContext * ctx) override {
    PythonAPI::evalScript("exitEmpty_queue", this, (parser_rule_context *) ctx);
  }

  void enterSubroutine_call(SV3_1aParser::Subroutine_callContext * ctx) override {
    PythonAPI::evalScript("enterSubroutine_call", this, (parser_rule_context *) ctx);
  }
  void exitSubroutine_call(SV3_1aParser::Subroutine_callContext * ctx) override {
    PythonAPI::evalScript("exitSubroutine_call", this, (parser_rule_context *) ctx);
  }

  void enterArgument(SV3_1aParser::ArgumentContext * ctx) override {
    PythonAPI::evalScript("enterArgument", this, (parser_rule_context *) ctx);
  }
  void exitArgument(SV3_1aParser::ArgumentContext * ctx) override {
    PythonAPI::evalScript("exitArgument", this, (parser_rule_context *) ctx);
  }

  void enterList_of_arguments(SV3_1aParser::List_of_argumentsContext * ctx) override {
    PythonAPI::evalScript("enterList_of_arguments", this, (parser_rule_context *) ctx);
  }
  void exitList_of_arguments(SV3_1aParser::List_of_argumentsContext * ctx) override {
    PythonAPI::evalScript("exitList_of_arguments", this, (parser_rule_context *) ctx);
  }

  void enterMethod_call(SV3_1aParser::Method_callContext * ctx) override {
    PythonAPI::evalScript("enterMethod_call", this, (parser_rule_context *) ctx);
  }
  void exitMethod_call(SV3_1aParser::Method_callContext * ctx) override {
    PythonAPI::evalScript("exitMethod_call", this, (parser_rule_context *) ctx);
  }

  void enterMethod_call_body(SV3_1aParser::Method_call_bodyContext * ctx) override {
    PythonAPI::evalScript("enterMethod_call_body", this, (parser_rule_context *) ctx);
  }
  void exitMethod_call_body(SV3_1aParser::Method_call_bodyContext * ctx) override {
    PythonAPI::evalScript("exitMethod_call_body", this, (parser_rule_context *) ctx);
  }

  void enterBuilt_in_method_call(SV3_1aParser::Built_in_method_callContext * ctx) override {
    PythonAPI::evalScript("enterBuilt_in_method_call", this, (parser_rule_context *) ctx);
  }
  void exitBuilt_in_method_call(SV3_1aParser::Built_in_method_callContext * ctx) override {
    PythonAPI::evalScript("exitBuilt_in_method_call", this, (parser_rule_context *) ctx);
  }

  void enterArray_manipulation_call(SV3_1aParser::Array_manipulation_callContext * ctx) override {
    PythonAPI::evalScript("enterArray_manipulation_call", this, (parser_rule_context *) ctx);
  }
  void exitArray_manipulation_call(SV3_1aParser::Array_manipulation_callContext * ctx) override {
    PythonAPI::evalScript("exitArray_manipulation_call", this, (parser_rule_context *) ctx);
  }

  void enterRandomize_call(SV3_1aParser::Randomize_callContext * ctx) override {
    PythonAPI::evalScript("enterRandomize_call", this, (parser_rule_context *) ctx);
  }
  void exitRandomize_call(SV3_1aParser::Randomize_callContext * ctx) override {
    PythonAPI::evalScript("exitRandomize_call", this, (parser_rule_context *) ctx);
  }

  void enterMethod_call_root(SV3_1aParser::Method_call_rootContext * ctx) override {
    PythonAPI::evalScript("enterMethod_call_root", this, (parser_rule_context *) ctx);
  }
  void exitMethod_call_root(SV3_1aParser::Method_call_rootContext * ctx) override {
    PythonAPI::evalScript("exitMethod_call_root", this, (parser_rule_context *) ctx);
  }

  void enterArray_method_name(SV3_1aParser::Array_method_nameContext * ctx) override {
    PythonAPI::evalScript("enterArray_method_name", this, (parser_rule_context *) ctx);
  }
  void exitArray_method_name(SV3_1aParser::Array_method_nameContext * ctx) override {
    PythonAPI::evalScript("exitArray_method_name", this, (parser_rule_context *) ctx);
  }

  void enterUnique_call(SV3_1aParser::Unique_callContext * ctx) override {
    PythonAPI::evalScript("enterUnique_call", this, (parser_rule_context *) ctx);
  }
  void exitUnique_call(SV3_1aParser::Unique_callContext * ctx) override {
    PythonAPI::evalScript("exitUnique_call", this, (parser_rule_context *) ctx);
  }

  void enterAnd_call(SV3_1aParser::And_callContext * ctx) override {
    PythonAPI::evalScript("enterAnd_call", this, (parser_rule_context *) ctx);
  }
  void exitAnd_call(SV3_1aParser::And_callContext * ctx) override {
    PythonAPI::evalScript("exitAnd_call", this, (parser_rule_context *) ctx);
  }

  void enterOr_call(SV3_1aParser::Or_callContext * ctx) override {
    PythonAPI::evalScript("enterOr_call", this, (parser_rule_context *) ctx);
  }
  void exitOr_call(SV3_1aParser::Or_callContext * ctx) override {
    PythonAPI::evalScript("exitOr_call", this, (parser_rule_context *) ctx);
  }

  void enterXor_call(SV3_1aParser::Xor_callContext * ctx) override {
    PythonAPI::evalScript("enterXor_call", this, (parser_rule_context *) ctx);
  }
  void exitXor_call(SV3_1aParser::Xor_callContext * ctx) override {
    PythonAPI::evalScript("exitXor_call", this, (parser_rule_context *) ctx);
  }

  void enterInc_or_dec_expression(SV3_1aParser::Inc_or_dec_expressionContext * ctx) override {
    PythonAPI::evalScript("enterInc_or_dec_expression", this, (parser_rule_context *) ctx);
  }
  void exitInc_or_dec_expression(SV3_1aParser::Inc_or_dec_expressionContext * ctx) override {
    PythonAPI::evalScript("exitInc_or_dec_expression", this, (parser_rule_context *) ctx);
  }

  void enterConstant_expression(SV3_1aParser::Constant_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConstant_expression", this, (parser_rule_context *) ctx);
  }
  void exitConstant_expression(SV3_1aParser::Constant_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConstant_expression", this, (parser_rule_context *) ctx);
  }

  void enterConditional_operator(SV3_1aParser::Conditional_operatorContext * ctx) override {
    PythonAPI::evalScript("enterConditional_operator", this, (parser_rule_context *) ctx);
  }
  void exitConditional_operator(SV3_1aParser::Conditional_operatorContext * ctx) override {
    PythonAPI::evalScript("exitConditional_operator", this, (parser_rule_context *) ctx);
  }

  void enterConstant_mintypmax_expression(SV3_1aParser::Constant_mintypmax_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConstant_mintypmax_expression", this, (parser_rule_context *) ctx);
  }
  void exitConstant_mintypmax_expression(SV3_1aParser::Constant_mintypmax_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConstant_mintypmax_expression", this, (parser_rule_context *) ctx);
  }

  void enterConstant_param_expression(SV3_1aParser::Constant_param_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConstant_param_expression", this, (parser_rule_context *) ctx);
  }
  void exitConstant_param_expression(SV3_1aParser::Constant_param_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConstant_param_expression", this, (parser_rule_context *) ctx);
  }

  void enterParam_expression(SV3_1aParser::Param_expressionContext * ctx) override {
    PythonAPI::evalScript("enterParam_expression", this, (parser_rule_context *) ctx);
  }
  void exitParam_expression(SV3_1aParser::Param_expressionContext * ctx) override {
    PythonAPI::evalScript("exitParam_expression", this, (parser_rule_context *) ctx);
  }

  void enterConstant_range_expression(SV3_1aParser::Constant_range_expressionContext * ctx) override {
    PythonAPI::evalScript("enterConstant_range_expression", this, (parser_rule_context *) ctx);
  }
  void exitConstant_range_expression(SV3_1aParser::Constant_range_expressionContext * ctx) override {
    PythonAPI::evalScript("exitConstant_range_expression", this, (parser_rule_context *) ctx);
  }

  void enterConstant_part_select_range(SV3_1aParser::Constant_part_select_rangeContext * ctx) override {
    PythonAPI::evalScript("enterConstant_part_select_range", this, (parser_rule_context *) ctx);
  }
  void exitConstant_part_select_range(SV3_1aParser::Constant_part_select_rangeContext * ctx) override {
    PythonAPI::evalScript("exitConstant_part_select_range", this, (parser_rule_context *) ctx);
  }

  void enterConstant_range(SV3_1aParser::Constant_rangeContext * ctx) override {
    PythonAPI::evalScript("enterConstant_range", this, (parser_rule_context *) ctx);
  }
  void exitConstant_range(SV3_1aParser::Constant_rangeContext * ctx) override {
    PythonAPI::evalScript("exitConstant_range", this, (parser_rule_context *) ctx);
  }

  void enterConstant_indexed_range(SV3_1aParser::Constant_indexed_rangeContext * ctx) override {
    PythonAPI::evalScript("enterConstant_indexed_range", this, (parser_rule_context *) ctx);
  }
  void exitConstant_indexed_range(SV3_1aParser::Constant_indexed_rangeContext * ctx) override {
    PythonAPI::evalScript("exitConstant_indexed_range", this, (parser_rule_context *) ctx);
  }

  void enterExpression(SV3_1aParser::ExpressionContext * ctx) override {
    PythonAPI::evalScript("enterExpression", this, (parser_rule_context *) ctx);
  }
  void exitExpression(SV3_1aParser::ExpressionContext * ctx) override {
    PythonAPI::evalScript("exitExpression", this, (parser_rule_context *) ctx);
  }

  void enterValue_range(SV3_1aParser::Value_rangeContext * ctx) override {
    PythonAPI::evalScript("enterValue_range", this, (parser_rule_context *) ctx);
  }
  void exitValue_range(SV3_1aParser::Value_rangeContext * ctx) override {
    PythonAPI::evalScript("exitValue_range", this, (parser_rule_context *) ctx);
  }

  void enterMintypmax_expression(SV3_1aParser::Mintypmax_expressionContext * ctx) override {
    PythonAPI::evalScript("enterMintypmax_expression", this, (parser_rule_context *) ctx);
  }
  void exitMintypmax_expression(SV3_1aParser::Mintypmax_expressionContext * ctx) override {
    PythonAPI::evalScript("exitMintypmax_expression", this, (parser_rule_context *) ctx);
  }

  void enterModule_path_expression(SV3_1aParser::Module_path_expressionContext * ctx) override {
    PythonAPI::evalScript("enterModule_path_expression", this, (parser_rule_context *) ctx);
  }
  void exitModule_path_expression(SV3_1aParser::Module_path_expressionContext * ctx) override {
    PythonAPI::evalScript("exitModule_path_expression", this, (parser_rule_context *) ctx);
  }

  void enterModule_path_mintypmax_expression(SV3_1aParser::Module_path_mintypmax_expressionContext * ctx) override {
    PythonAPI::evalScript("enterModule_path_mintypmax_expression", this, (parser_rule_context *) ctx);
  }
  void exitModule_path_mintypmax_expression(SV3_1aParser::Module_path_mintypmax_expressionContext * ctx) override {
    PythonAPI::evalScript("exitModule_path_mintypmax_expression", this, (parser_rule_context *) ctx);
  }

  void enterRange_expression(SV3_1aParser::Range_expressionContext * ctx) override {
    PythonAPI::evalScript("enterRange_expression", this, (parser_rule_context *) ctx);
  }
  void exitRange_expression(SV3_1aParser::Range_expressionContext * ctx) override {
    PythonAPI::evalScript("exitRange_expression", this, (parser_rule_context *) ctx);
  }

  void enterPart_select_range(SV3_1aParser::Part_select_rangeContext * ctx) override {
    PythonAPI::evalScript("enterPart_select_range", this, (parser_rule_context *) ctx);
  }
  void exitPart_select_range(SV3_1aParser::Part_select_rangeContext * ctx) override {
    PythonAPI::evalScript("exitPart_select_range", this, (parser_rule_context *) ctx);
  }

  void enterPart_select_op(SV3_1aParser::Part_select_opContext * ctx) override {
    PythonAPI::evalScript("enterPart_select_op", this, (parser_rule_context *) ctx);
  }
  void exitPart_select_op(SV3_1aParser::Part_select_opContext * ctx) override {
    PythonAPI::evalScript("exitPart_select_op", this, (parser_rule_context *) ctx);
  }

  void enterPart_select_op_colon(SV3_1aParser::Part_select_op_colonContext * ctx) override {
    PythonAPI::evalScript("enterPart_select_op_colon", this, (parser_rule_context *) ctx);
  }
  void exitPart_select_op_colon(SV3_1aParser::Part_select_op_colonContext * ctx) override {
    PythonAPI::evalScript("exitPart_select_op_colon", this, (parser_rule_context *) ctx);
  }

  void enterIndexed_range(SV3_1aParser::Indexed_rangeContext * ctx) override {
    PythonAPI::evalScript("enterIndexed_range", this, (parser_rule_context *) ctx);
  }
  void exitIndexed_range(SV3_1aParser::Indexed_rangeContext * ctx) override {
    PythonAPI::evalScript("exitIndexed_range", this, (parser_rule_context *) ctx);
  }

  void enterConstant_primary(SV3_1aParser::Constant_primaryContext * ctx) override {
    PythonAPI::evalScript("enterConstant_primary", this, (parser_rule_context *) ctx);
  }
  void exitConstant_primary(SV3_1aParser::Constant_primaryContext * ctx) override {
    PythonAPI::evalScript("exitConstant_primary", this, (parser_rule_context *) ctx);
  }

  void enterModule_path_primary(SV3_1aParser::Module_path_primaryContext * ctx) override {
    PythonAPI::evalScript("enterModule_path_primary", this, (parser_rule_context *) ctx);
  }
  void exitModule_path_primary(SV3_1aParser::Module_path_primaryContext * ctx) override {
    PythonAPI::evalScript("exitModule_path_primary", this, (parser_rule_context *) ctx);
  }

  void enterComplex_func_call(SV3_1aParser::Complex_func_callContext * ctx) override {
    PythonAPI::evalScript("enterComplex_func_call", this, (parser_rule_context *) ctx);
  }
  void exitComplex_func_call(SV3_1aParser::Complex_func_callContext * ctx) override {
    PythonAPI::evalScript("exitComplex_func_call", this, (parser_rule_context *) ctx);
  }

  void enterPrimary(SV3_1aParser::PrimaryContext * ctx) override {
    PythonAPI::evalScript("enterPrimary", this, (parser_rule_context *) ctx);
  }
  void exitPrimary(SV3_1aParser::PrimaryContext * ctx) override {
    PythonAPI::evalScript("exitPrimary", this, (parser_rule_context *) ctx);
  }

  void enterThis_keyword(SV3_1aParser::This_keywordContext * ctx) override {
    PythonAPI::evalScript("enterThis_keyword", this, (parser_rule_context *) ctx);
  }
  void exitThis_keyword(SV3_1aParser::This_keywordContext * ctx) override {
    PythonAPI::evalScript("exitThis_keyword", this, (parser_rule_context *) ctx);
  }

  void enterSuper_keyword(SV3_1aParser::Super_keywordContext * ctx) override {
    PythonAPI::evalScript("enterSuper_keyword", this, (parser_rule_context *) ctx);
  }
  void exitSuper_keyword(SV3_1aParser::Super_keywordContext * ctx) override {
    PythonAPI::evalScript("exitSuper_keyword", this, (parser_rule_context *) ctx);
  }

  void enterDollar_keyword(SV3_1aParser::Dollar_keywordContext * ctx) override {
    PythonAPI::evalScript("enterDollar_keyword", this, (parser_rule_context *) ctx);
  }
  void exitDollar_keyword(SV3_1aParser::Dollar_keywordContext * ctx) override {
    PythonAPI::evalScript("exitDollar_keyword", this, (parser_rule_context *) ctx);
  }

  void enterDollar_root_keyword(SV3_1aParser::Dollar_root_keywordContext * ctx) override {
    PythonAPI::evalScript("enterDollar_root_keyword", this, (parser_rule_context *) ctx);
  }
  void exitDollar_root_keyword(SV3_1aParser::Dollar_root_keywordContext * ctx) override {
    PythonAPI::evalScript("exitDollar_root_keyword", this, (parser_rule_context *) ctx);
  }

  void enterThis_dot_super(SV3_1aParser::This_dot_superContext * ctx) override {
    PythonAPI::evalScript("enterThis_dot_super", this, (parser_rule_context *) ctx);
  }
  void exitThis_dot_super(SV3_1aParser::This_dot_superContext * ctx) override {
    PythonAPI::evalScript("exitThis_dot_super", this, (parser_rule_context *) ctx);
  }

  void enterNull_keyword(SV3_1aParser::Null_keywordContext * ctx) override {
    PythonAPI::evalScript("enterNull_keyword", this, (parser_rule_context *) ctx);
  }
  void exitNull_keyword(SV3_1aParser::Null_keywordContext * ctx) override {
    PythonAPI::evalScript("exitNull_keyword", this, (parser_rule_context *) ctx);
  }

  void enterTime_literal(SV3_1aParser::Time_literalContext * ctx) override {
    PythonAPI::evalScript("enterTime_literal", this, (parser_rule_context *) ctx);
  }
  void exitTime_literal(SV3_1aParser::Time_literalContext * ctx) override {
    PythonAPI::evalScript("exitTime_literal", this, (parser_rule_context *) ctx);
  }

  void enterTime_unit(SV3_1aParser::Time_unitContext * ctx) override {
    PythonAPI::evalScript("enterTime_unit", this, (parser_rule_context *) ctx);
  }
  void exitTime_unit(SV3_1aParser::Time_unitContext * ctx) override {
    PythonAPI::evalScript("exitTime_unit", this, (parser_rule_context *) ctx);
  }

  void enterImplicit_class_handle(SV3_1aParser::Implicit_class_handleContext * ctx) override {
    PythonAPI::evalScript("enterImplicit_class_handle", this, (parser_rule_context *) ctx);
  }
  void exitImplicit_class_handle(SV3_1aParser::Implicit_class_handleContext * ctx) override {
    PythonAPI::evalScript("exitImplicit_class_handle", this, (parser_rule_context *) ctx);
  }

  void enterBit_select(SV3_1aParser::Bit_selectContext * ctx) override {
    PythonAPI::evalScript("enterBit_select", this, (parser_rule_context *) ctx);
  }
  void exitBit_select(SV3_1aParser::Bit_selectContext * ctx) override {
    PythonAPI::evalScript("exitBit_select", this, (parser_rule_context *) ctx);
  }

  void enterSelect(SV3_1aParser::SelectContext * ctx) override {
    PythonAPI::evalScript("enterSelect", this, (parser_rule_context *) ctx);
  }
  void exitSelect(SV3_1aParser::SelectContext * ctx) override {
    PythonAPI::evalScript("exitSelect", this, (parser_rule_context *) ctx);
  }

  void enterNonrange_select(SV3_1aParser::Nonrange_selectContext * ctx) override {
    PythonAPI::evalScript("enterNonrange_select", this, (parser_rule_context *) ctx);
  }
  void exitNonrange_select(SV3_1aParser::Nonrange_selectContext * ctx) override {
    PythonAPI::evalScript("exitNonrange_select", this, (parser_rule_context *) ctx);
  }

  void enterConstant_bit_select(SV3_1aParser::Constant_bit_selectContext * ctx) override {
    PythonAPI::evalScript("enterConstant_bit_select", this, (parser_rule_context *) ctx);
  }
  void exitConstant_bit_select(SV3_1aParser::Constant_bit_selectContext * ctx) override {
    PythonAPI::evalScript("exitConstant_bit_select", this, (parser_rule_context *) ctx);
  }

  void enterConstant_select(SV3_1aParser::Constant_selectContext * ctx) override {
    PythonAPI::evalScript("enterConstant_select", this, (parser_rule_context *) ctx);
  }
  void exitConstant_select(SV3_1aParser::Constant_selectContext * ctx) override {
    PythonAPI::evalScript("exitConstant_select", this, (parser_rule_context *) ctx);
  }

  void enterPrimary_literal(SV3_1aParser::Primary_literalContext * ctx) override {
    PythonAPI::evalScript("enterPrimary_literal", this, (parser_rule_context *) ctx);
  }
  void exitPrimary_literal(SV3_1aParser::Primary_literalContext * ctx) override {
    PythonAPI::evalScript("exitPrimary_literal", this, (parser_rule_context *) ctx);
  }

  void enterConstant_cast(SV3_1aParser::Constant_castContext * ctx) override {
    PythonAPI::evalScript("enterConstant_cast", this, (parser_rule_context *) ctx);
  }
  void exitConstant_cast(SV3_1aParser::Constant_castContext * ctx) override {
    PythonAPI::evalScript("exitConstant_cast", this, (parser_rule_context *) ctx);
  }

  void enterCast(SV3_1aParser::CastContext * ctx) override {
    PythonAPI::evalScript("enterCast", this, (parser_rule_context *) ctx);
  }
  void exitCast(SV3_1aParser::CastContext * ctx) override {
    PythonAPI::evalScript("exitCast", this, (parser_rule_context *) ctx);
  }

  void enterNet_lvalue(SV3_1aParser::Net_lvalueContext * ctx) override {
    PythonAPI::evalScript("enterNet_lvalue", this, (parser_rule_context *) ctx);
  }
  void exitNet_lvalue(SV3_1aParser::Net_lvalueContext * ctx) override {
    PythonAPI::evalScript("exitNet_lvalue", this, (parser_rule_context *) ctx);
  }

  void enterVariable_lvalue(SV3_1aParser::Variable_lvalueContext * ctx) override {
    PythonAPI::evalScript("enterVariable_lvalue", this, (parser_rule_context *) ctx);
  }
  void exitVariable_lvalue(SV3_1aParser::Variable_lvalueContext * ctx) override {
    PythonAPI::evalScript("exitVariable_lvalue", this, (parser_rule_context *) ctx);
  }

  void enterNonrange_variable_lvalue(SV3_1aParser::Nonrange_variable_lvalueContext * ctx) override {
    PythonAPI::evalScript("enterNonrange_variable_lvalue", this, (parser_rule_context *) ctx);
  }
  void exitNonrange_variable_lvalue(SV3_1aParser::Nonrange_variable_lvalueContext * ctx) override {
    PythonAPI::evalScript("exitNonrange_variable_lvalue", this, (parser_rule_context *) ctx);
  }

  void enterInc_or_dec_operator(SV3_1aParser::Inc_or_dec_operatorContext * ctx) override {
    PythonAPI::evalScript("enterInc_or_dec_operator", this, (parser_rule_context *) ctx);
  }
  void exitInc_or_dec_operator(SV3_1aParser::Inc_or_dec_operatorContext * ctx) override {
    PythonAPI::evalScript("exitInc_or_dec_operator", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_Not(SV3_1aParser::UnaryModOp_NotContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_Not", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_Not(SV3_1aParser::UnaryModOp_NotContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_Not", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_Tilda(SV3_1aParser::UnaryModOp_TildaContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_Tilda", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_Tilda(SV3_1aParser::UnaryModOp_TildaContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_Tilda", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_BitwAnd(SV3_1aParser::UnaryModOp_BitwAndContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_BitwAnd", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_BitwAnd(SV3_1aParser::UnaryModOp_BitwAndContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_BitwAnd", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_ReductNand(SV3_1aParser::UnaryModOp_ReductNandContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_ReductNand", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_ReductNand(SV3_1aParser::UnaryModOp_ReductNandContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_ReductNand", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_BitwOr(SV3_1aParser::UnaryModOp_BitwOrContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_BitwOr", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_BitwOr(SV3_1aParser::UnaryModOp_BitwOrContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_BitwOr", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_ReductNor(SV3_1aParser::UnaryModOp_ReductNorContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_ReductNor", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_ReductNor(SV3_1aParser::UnaryModOp_ReductNorContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_ReductNor", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_BitwXor(SV3_1aParser::UnaryModOp_BitwXorContext * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_BitwXor", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_BitwXor(SV3_1aParser::UnaryModOp_BitwXorContext * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_BitwXor", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_ReductXNor1(SV3_1aParser::UnaryModOp_ReductXNor1Context * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_ReductXNor1", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_ReductXNor1(SV3_1aParser::UnaryModOp_ReductXNor1Context * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_ReductXNor1", this, (parser_rule_context *) ctx);
  }

  void enterUnaryModOp_ReductXnor2(SV3_1aParser::UnaryModOp_ReductXnor2Context * ctx) override {
    PythonAPI::evalScript("enterUnaryModOp_ReductXnor2", this, (parser_rule_context *) ctx);
  }
  void exitUnaryModOp_ReductXnor2(SV3_1aParser::UnaryModOp_ReductXnor2Context * ctx) override {
    PythonAPI::evalScript("exitUnaryModOp_ReductXnor2", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_Equiv(SV3_1aParser::BinModOp_EquivContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_Equiv", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_Equiv(SV3_1aParser::BinModOp_EquivContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_Equiv", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_NotEqual(SV3_1aParser::BinModOp_NotEqualContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_NotEqual", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_NotEqual(SV3_1aParser::BinModOp_NotEqualContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_NotEqual", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_LogicAnd(SV3_1aParser::BinModOp_LogicAndContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_LogicAnd", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_LogicAnd(SV3_1aParser::BinModOp_LogicAndContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_LogicAnd", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_LogicOr(SV3_1aParser::BinModOp_LogicOrContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_LogicOr", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_LogicOr(SV3_1aParser::BinModOp_LogicOrContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_LogicOr", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_BitwAnd(SV3_1aParser::BinModOp_BitwAndContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_BitwAnd", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_BitwAnd(SV3_1aParser::BinModOp_BitwAndContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_BitwAnd", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_BitwOr(SV3_1aParser::BinModOp_BitwOrContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_BitwOr", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_BitwOr(SV3_1aParser::BinModOp_BitwOrContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_BitwOr", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_BitwXor(SV3_1aParser::BinModOp_BitwXorContext * ctx) override {
    PythonAPI::evalScript("enterBinModOp_BitwXor", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_BitwXor(SV3_1aParser::BinModOp_BitwXorContext * ctx) override {
    PythonAPI::evalScript("exitBinModOp_BitwXor", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_ReductXnor1(SV3_1aParser::BinModOp_ReductXnor1Context * ctx) override {
    PythonAPI::evalScript("enterBinModOp_ReductXnor1", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_ReductXnor1(SV3_1aParser::BinModOp_ReductXnor1Context * ctx) override {
    PythonAPI::evalScript("exitBinModOp_ReductXnor1", this, (parser_rule_context *) ctx);
  }

  void enterBinModOp_ReductXnor2(SV3_1aParser::BinModOp_ReductXnor2Context * ctx) override {
    PythonAPI::evalScript("enterBinModOp_ReductXnor2", this, (parser_rule_context *) ctx);
  }
  void exitBinModOp_ReductXnor2(SV3_1aParser::BinModOp_ReductXnor2Context * ctx) override {
    PythonAPI::evalScript("exitBinModOp_ReductXnor2", this, (parser_rule_context *) ctx);
  }

  void enterNumber(SV3_1aParser::NumberContext * ctx) override {
    PythonAPI::evalScript("enterNumber", this, (parser_rule_context *) ctx);
  }
  void exitNumber(SV3_1aParser::NumberContext * ctx) override {
    PythonAPI::evalScript("exitNumber", this, (parser_rule_context *) ctx);
  }

  void enterUnbased_unsized_literal(SV3_1aParser::Unbased_unsized_literalContext * ctx) override {
    PythonAPI::evalScript("enterUnbased_unsized_literal", this, (parser_rule_context *) ctx);
  }
  void exitUnbased_unsized_literal(SV3_1aParser::Unbased_unsized_literalContext * ctx) override {
    PythonAPI::evalScript("exitUnbased_unsized_literal", this, (parser_rule_context *) ctx);
  }

  void enterAttribute_instance(SV3_1aParser::Attribute_instanceContext * ctx) override {
    PythonAPI::evalScript("enterAttribute_instance", this, (parser_rule_context *) ctx);
  }
  void exitAttribute_instance(SV3_1aParser::Attribute_instanceContext * ctx) override {
    PythonAPI::evalScript("exitAttribute_instance", this, (parser_rule_context *) ctx);
  }

  void enterAttr_spec(SV3_1aParser::Attr_specContext * ctx) override {
    PythonAPI::evalScript("enterAttr_spec", this, (parser_rule_context *) ctx);
  }
  void exitAttr_spec(SV3_1aParser::Attr_specContext * ctx) override {
    PythonAPI::evalScript("exitAttr_spec", this, (parser_rule_context *) ctx);
  }

  void enterAttr_name(SV3_1aParser::Attr_nameContext * ctx) override {
    PythonAPI::evalScript("enterAttr_name", this, (parser_rule_context *) ctx);
  }
  void exitAttr_name(SV3_1aParser::Attr_nameContext * ctx) override {
    PythonAPI::evalScript("exitAttr_name", this, (parser_rule_context *) ctx);
  }

  void enterHierarchical_identifier(SV3_1aParser::Hierarchical_identifierContext * ctx) override {
    PythonAPI::evalScript("enterHierarchical_identifier", this, (parser_rule_context *) ctx);
  }
  void exitHierarchical_identifier(SV3_1aParser::Hierarchical_identifierContext * ctx) override {
    PythonAPI::evalScript("exitHierarchical_identifier", this, (parser_rule_context *) ctx);
  }

  void enterIdentifier(SV3_1aParser::IdentifierContext * ctx) override {
    PythonAPI::evalScript("enterIdentifier", this, (parser_rule_context *) ctx);
  }
  void exitIdentifier(SV3_1aParser::IdentifierContext * ctx) override {
    PythonAPI::evalScript("exitIdentifier", this, (parser_rule_context *) ctx);
  }

  void enterInterface_identifier(SV3_1aParser::Interface_identifierContext * ctx) override {
    PythonAPI::evalScript("enterInterface_identifier", this, (parser_rule_context *) ctx);
  }
  void exitInterface_identifier(SV3_1aParser::Interface_identifierContext * ctx) override {
    PythonAPI::evalScript("exitInterface_identifier", this, (parser_rule_context *) ctx);
  }

  void enterPackage_scope(SV3_1aParser::Package_scopeContext * ctx) override {
    PythonAPI::evalScript("enterPackage_scope", this, (parser_rule_context *) ctx);
  }
  void exitPackage_scope(SV3_1aParser::Package_scopeContext * ctx) override {
    PythonAPI::evalScript("exitPackage_scope", this, (parser_rule_context *) ctx);
  }

  void enterPs_identifier(SV3_1aParser::Ps_identifierContext * ctx) override {
    PythonAPI::evalScript("enterPs_identifier", this, (parser_rule_context *) ctx);
  }
  void exitPs_identifier(SV3_1aParser::Ps_identifierContext * ctx) override {
    PythonAPI::evalScript("exitPs_identifier", this, (parser_rule_context *) ctx);
  }

  void enterPs_or_hierarchical_identifier(SV3_1aParser::Ps_or_hierarchical_identifierContext * ctx) override {
    PythonAPI::evalScript("enterPs_or_hierarchical_identifier", this, (parser_rule_context *) ctx);
  }
  void exitPs_or_hierarchical_identifier(SV3_1aParser::Ps_or_hierarchical_identifierContext * ctx) override {
    PythonAPI::evalScript("exitPs_or_hierarchical_identifier", this, (parser_rule_context *) ctx);
  }

  void enterPs_or_hierarchical_array_identifier(SV3_1aParser::Ps_or_hierarchical_array_identifierContext * ctx) override {
    PythonAPI::evalScript("enterPs_or_hierarchical_array_identifier", this, (parser_rule_context *) ctx);
  }
  void exitPs_or_hierarchical_array_identifier(SV3_1aParser::Ps_or_hierarchical_array_identifierContext * ctx) override {
    PythonAPI::evalScript("exitPs_or_hierarchical_array_identifier", this, (parser_rule_context *) ctx);
  }

  void enterPs_or_hierarchical_sequence_identifier(SV3_1aParser::Ps_or_hierarchical_sequence_identifierContext * ctx) override {
    PythonAPI::evalScript("enterPs_or_hierarchical_sequence_identifier", this, (parser_rule_context *) ctx);
  }
  void exitPs_or_hierarchical_sequence_identifier(SV3_1aParser::Ps_or_hierarchical_sequence_identifierContext * ctx) override {
    PythonAPI::evalScript("exitPs_or_hierarchical_sequence_identifier", this, (parser_rule_context *) ctx);
  }

  void enterPs_type_identifier(SV3_1aParser::Ps_type_identifierContext * ctx) override {
    PythonAPI::evalScript("enterPs_type_identifier", this, (parser_rule_context *) ctx);
  }
  void exitPs_type_identifier(SV3_1aParser::Ps_type_identifierContext * ctx) override {
    PythonAPI::evalScript("exitPs_type_identifier", this, (parser_rule_context *) ctx);
  }

  void enterSystem_task(SV3_1aParser::System_taskContext * ctx) override {
    PythonAPI::evalScript("enterSystem_task", this, (parser_rule_context *) ctx);
  }
  void exitSystem_task(SV3_1aParser::System_taskContext * ctx) override {
    PythonAPI::evalScript("exitSystem_task", this, (parser_rule_context *) ctx);
  }

  void enterSystem_task_names(SV3_1aParser::System_task_namesContext * ctx) override {
    PythonAPI::evalScript("enterSystem_task_names", this, (parser_rule_context *) ctx);
  }
  void exitSystem_task_names(SV3_1aParser::System_task_namesContext * ctx) override {
    PythonAPI::evalScript("exitSystem_task_names", this, (parser_rule_context *) ctx);
  }

  void enterTop_directives(SV3_1aParser::Top_directivesContext * ctx) override {
    PythonAPI::evalScript("enterTop_directives", this, (parser_rule_context *) ctx);
  }
  void exitTop_directives(SV3_1aParser::Top_directivesContext * ctx) override {
    PythonAPI::evalScript("exitTop_directives", this, (parser_rule_context *) ctx);
  }

  void enterPragma_directive(SV3_1aParser::Pragma_directiveContext * ctx) override {
    PythonAPI::evalScript("enterPragma_directive", this, (parser_rule_context *) ctx);
  }
  void exitPragma_directive(SV3_1aParser::Pragma_directiveContext * ctx) override {
    PythonAPI::evalScript("exitPragma_directive", this, (parser_rule_context *) ctx);
  }

  void enterPragma_expression(SV3_1aParser::Pragma_expressionContext * ctx) override {
    PythonAPI::evalScript("enterPragma_expression", this, (parser_rule_context *) ctx);
  }
  void exitPragma_expression(SV3_1aParser::Pragma_expressionContext * ctx) override {
    PythonAPI::evalScript("exitPragma_expression", this, (parser_rule_context *) ctx);
  }

  void enterPragma_value(SV3_1aParser::Pragma_valueContext * ctx) override {
    PythonAPI::evalScript("enterPragma_value", this, (parser_rule_context *) ctx);
  }
  void exitPragma_value(SV3_1aParser::Pragma_valueContext * ctx) override {
    PythonAPI::evalScript("exitPragma_value", this, (parser_rule_context *) ctx);
  }

  void enterTimescale_directive(SV3_1aParser::Timescale_directiveContext * ctx) override {
    PythonAPI::evalScript("enterTimescale_directive", this, (parser_rule_context *) ctx);
  }
  void exitTimescale_directive(SV3_1aParser::Timescale_directiveContext * ctx) override {
    PythonAPI::evalScript("exitTimescale_directive", this, (parser_rule_context *) ctx);
  }

  void enterBegin_keywords_directive(SV3_1aParser::Begin_keywords_directiveContext * ctx) override {
    PythonAPI::evalScript("enterBegin_keywords_directive", this, (parser_rule_context *) ctx);
  }
  void exitBegin_keywords_directive(SV3_1aParser::Begin_keywords_directiveContext * ctx) override {
    PythonAPI::evalScript("exitBegin_keywords_directive", this, (parser_rule_context *) ctx);
  }

  void enterEnd_keywords_directive(SV3_1aParser::End_keywords_directiveContext * ctx) override {
    PythonAPI::evalScript("enterEnd_keywords_directive", this, (parser_rule_context *) ctx);
  }
  void exitEnd_keywords_directive(SV3_1aParser::End_keywords_directiveContext * ctx) override {
    PythonAPI::evalScript("exitEnd_keywords_directive", this, (parser_rule_context *) ctx);
  }

  void enterUnconnected_drive_directive(SV3_1aParser::Unconnected_drive_directiveContext * ctx) override {
    PythonAPI::evalScript("enterUnconnected_drive_directive", this, (parser_rule_context *) ctx);
  }
  void exitUnconnected_drive_directive(SV3_1aParser::Unconnected_drive_directiveContext * ctx) override {
    PythonAPI::evalScript("exitUnconnected_drive_directive", this, (parser_rule_context *) ctx);
  }

  void enterNounconnected_drive_directive(SV3_1aParser::Nounconnected_drive_directiveContext * ctx) override {
    PythonAPI::evalScript("enterNounconnected_drive_directive", this, (parser_rule_context *) ctx);
  }
  void exitNounconnected_drive_directive(SV3_1aParser::Nounconnected_drive_directiveContext * ctx) override {
    PythonAPI::evalScript("exitNounconnected_drive_directive", this, (parser_rule_context *) ctx);
  }

  void enterDefault_nettype_directive(SV3_1aParser::Default_nettype_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDefault_nettype_directive", this, (parser_rule_context *) ctx);
  }
  void exitDefault_nettype_directive(SV3_1aParser::Default_nettype_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDefault_nettype_directive", this, (parser_rule_context *) ctx);
  }

  void enterUselib_directive(SV3_1aParser::Uselib_directiveContext * ctx) override {
    PythonAPI::evalScript("enterUselib_directive", this, (parser_rule_context *) ctx);
  }
  void exitUselib_directive(SV3_1aParser::Uselib_directiveContext * ctx) override {
    PythonAPI::evalScript("exitUselib_directive", this, (parser_rule_context *) ctx);
  }

  void enterCelldefine_directive(SV3_1aParser::Celldefine_directiveContext * ctx) override {
    PythonAPI::evalScript("enterCelldefine_directive", this, (parser_rule_context *) ctx);
  }
  void exitCelldefine_directive(SV3_1aParser::Celldefine_directiveContext * ctx) override {
    PythonAPI::evalScript("exitCelldefine_directive", this, (parser_rule_context *) ctx);
  }

  void enterEndcelldefine_directive(SV3_1aParser::Endcelldefine_directiveContext * ctx) override {
    PythonAPI::evalScript("enterEndcelldefine_directive", this, (parser_rule_context *) ctx);
  }
  void exitEndcelldefine_directive(SV3_1aParser::Endcelldefine_directiveContext * ctx) override {
    PythonAPI::evalScript("exitEndcelldefine_directive", this, (parser_rule_context *) ctx);
  }

  void enterProtect_directive(SV3_1aParser::Protect_directiveContext * ctx) override {
    PythonAPI::evalScript("enterProtect_directive", this, (parser_rule_context *) ctx);
  }
  void exitProtect_directive(SV3_1aParser::Protect_directiveContext * ctx) override {
    PythonAPI::evalScript("exitProtect_directive", this, (parser_rule_context *) ctx);
  }

  void enterEndprotect_directive(SV3_1aParser::Endprotect_directiveContext * ctx) override {
    PythonAPI::evalScript("enterEndprotect_directive", this, (parser_rule_context *) ctx);
  }
  void exitEndprotect_directive(SV3_1aParser::Endprotect_directiveContext * ctx) override {
    PythonAPI::evalScript("exitEndprotect_directive", this, (parser_rule_context *) ctx);
  }

  void enterProtected_directive(SV3_1aParser::Protected_directiveContext * ctx) override {
    PythonAPI::evalScript("enterProtected_directive", this, (parser_rule_context *) ctx);
  }
  void exitProtected_directive(SV3_1aParser::Protected_directiveContext * ctx) override {
    PythonAPI::evalScript("exitProtected_directive", this, (parser_rule_context *) ctx);
  }

  void enterEndprotected_directive(SV3_1aParser::Endprotected_directiveContext * ctx) override {
    PythonAPI::evalScript("enterEndprotected_directive", this, (parser_rule_context *) ctx);
  }
  void exitEndprotected_directive(SV3_1aParser::Endprotected_directiveContext * ctx) override {
    PythonAPI::evalScript("exitEndprotected_directive", this, (parser_rule_context *) ctx);
  }

  void enterExpand_vectornets_directive(SV3_1aParser::Expand_vectornets_directiveContext * ctx) override {
    PythonAPI::evalScript("enterExpand_vectornets_directive", this, (parser_rule_context *) ctx);
  }
  void exitExpand_vectornets_directive(SV3_1aParser::Expand_vectornets_directiveContext * ctx) override {
    PythonAPI::evalScript("exitExpand_vectornets_directive", this, (parser_rule_context *) ctx);
  }

  void enterNoexpand_vectornets_directive(SV3_1aParser::Noexpand_vectornets_directiveContext * ctx) override {
    PythonAPI::evalScript("enterNoexpand_vectornets_directive", this, (parser_rule_context *) ctx);
  }
  void exitNoexpand_vectornets_directive(SV3_1aParser::Noexpand_vectornets_directiveContext * ctx) override {
    PythonAPI::evalScript("exitNoexpand_vectornets_directive", this, (parser_rule_context *) ctx);
  }

  void enterAutoexpand_vectornets_directive(SV3_1aParser::Autoexpand_vectornets_directiveContext * ctx) override {
    PythonAPI::evalScript("enterAutoexpand_vectornets_directive", this, (parser_rule_context *) ctx);
  }
  void exitAutoexpand_vectornets_directive(SV3_1aParser::Autoexpand_vectornets_directiveContext * ctx) override {
    PythonAPI::evalScript("exitAutoexpand_vectornets_directive", this, (parser_rule_context *) ctx);
  }

  void enterDisable_portfaults_directive(SV3_1aParser::Disable_portfaults_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDisable_portfaults_directive", this, (parser_rule_context *) ctx);
  }
  void exitDisable_portfaults_directive(SV3_1aParser::Disable_portfaults_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDisable_portfaults_directive", this, (parser_rule_context *) ctx);
  }

  void enterEnable_portfaults_directive(SV3_1aParser::Enable_portfaults_directiveContext * ctx) override {
    PythonAPI::evalScript("enterEnable_portfaults_directive", this, (parser_rule_context *) ctx);
  }
  void exitEnable_portfaults_directive(SV3_1aParser::Enable_portfaults_directiveContext * ctx) override {
    PythonAPI::evalScript("exitEnable_portfaults_directive", this, (parser_rule_context *) ctx);
  }

  void enterNosuppress_faults_directive(SV3_1aParser::Nosuppress_faults_directiveContext * ctx) override {
    PythonAPI::evalScript("enterNosuppress_faults_directive", this, (parser_rule_context *) ctx);
  }
  void exitNosuppress_faults_directive(SV3_1aParser::Nosuppress_faults_directiveContext * ctx) override {
    PythonAPI::evalScript("exitNosuppress_faults_directive", this, (parser_rule_context *) ctx);
  }

  void enterSuppress_faults_directive(SV3_1aParser::Suppress_faults_directiveContext * ctx) override {
    PythonAPI::evalScript("enterSuppress_faults_directive", this, (parser_rule_context *) ctx);
  }
  void exitSuppress_faults_directive(SV3_1aParser::Suppress_faults_directiveContext * ctx) override {
    PythonAPI::evalScript("exitSuppress_faults_directive", this, (parser_rule_context *) ctx);
  }

  void enterSigned_directive(SV3_1aParser::Signed_directiveContext * ctx) override {
    PythonAPI::evalScript("enterSigned_directive", this, (parser_rule_context *) ctx);
  }
  void exitSigned_directive(SV3_1aParser::Signed_directiveContext * ctx) override {
    PythonAPI::evalScript("exitSigned_directive", this, (parser_rule_context *) ctx);
  }

  void enterUnsigned_directive(SV3_1aParser::Unsigned_directiveContext * ctx) override {
    PythonAPI::evalScript("enterUnsigned_directive", this, (parser_rule_context *) ctx);
  }
  void exitUnsigned_directive(SV3_1aParser::Unsigned_directiveContext * ctx) override {
    PythonAPI::evalScript("exitUnsigned_directive", this, (parser_rule_context *) ctx);
  }

  void enterRemove_gatename_directive(SV3_1aParser::Remove_gatename_directiveContext * ctx) override {
    PythonAPI::evalScript("enterRemove_gatename_directive", this, (parser_rule_context *) ctx);
  }
  void exitRemove_gatename_directive(SV3_1aParser::Remove_gatename_directiveContext * ctx) override {
    PythonAPI::evalScript("exitRemove_gatename_directive", this, (parser_rule_context *) ctx);
  }

  void enterNoremove_gatenames_directive(SV3_1aParser::Noremove_gatenames_directiveContext * ctx) override {
    PythonAPI::evalScript("enterNoremove_gatenames_directive", this, (parser_rule_context *) ctx);
  }
  void exitNoremove_gatenames_directive(SV3_1aParser::Noremove_gatenames_directiveContext * ctx) override {
    PythonAPI::evalScript("exitNoremove_gatenames_directive", this, (parser_rule_context *) ctx);
  }

  void enterRemove_netname_directive(SV3_1aParser::Remove_netname_directiveContext * ctx) override {
    PythonAPI::evalScript("enterRemove_netname_directive", this, (parser_rule_context *) ctx);
  }
  void exitRemove_netname_directive(SV3_1aParser::Remove_netname_directiveContext * ctx) override {
    PythonAPI::evalScript("exitRemove_netname_directive", this, (parser_rule_context *) ctx);
  }

  void enterNoremove_netnames_directive(SV3_1aParser::Noremove_netnames_directiveContext * ctx) override {
    PythonAPI::evalScript("enterNoremove_netnames_directive", this, (parser_rule_context *) ctx);
  }
  void exitNoremove_netnames_directive(SV3_1aParser::Noremove_netnames_directiveContext * ctx) override {
    PythonAPI::evalScript("exitNoremove_netnames_directive", this, (parser_rule_context *) ctx);
  }

  void enterAccelerate_directive(SV3_1aParser::Accelerate_directiveContext * ctx) override {
    PythonAPI::evalScript("enterAccelerate_directive", this, (parser_rule_context *) ctx);
  }
  void exitAccelerate_directive(SV3_1aParser::Accelerate_directiveContext * ctx) override {
    PythonAPI::evalScript("exitAccelerate_directive", this, (parser_rule_context *) ctx);
  }

  void enterNoaccelerate_directive(SV3_1aParser::Noaccelerate_directiveContext * ctx) override {
    PythonAPI::evalScript("enterNoaccelerate_directive", this, (parser_rule_context *) ctx);
  }
  void exitNoaccelerate_directive(SV3_1aParser::Noaccelerate_directiveContext * ctx) override {
    PythonAPI::evalScript("exitNoaccelerate_directive", this, (parser_rule_context *) ctx);
  }

  void enterDefault_trireg_strenght_directive(SV3_1aParser::Default_trireg_strenght_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDefault_trireg_strenght_directive", this, (parser_rule_context *) ctx);
  }
  void exitDefault_trireg_strenght_directive(SV3_1aParser::Default_trireg_strenght_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDefault_trireg_strenght_directive", this, (parser_rule_context *) ctx);
  }

  void enterDefault_decay_time_directive(SV3_1aParser::Default_decay_time_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDefault_decay_time_directive", this, (parser_rule_context *) ctx);
  }
  void exitDefault_decay_time_directive(SV3_1aParser::Default_decay_time_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDefault_decay_time_directive", this, (parser_rule_context *) ctx);
  }

  void enterDelay_mode_distributed_directive(SV3_1aParser::Delay_mode_distributed_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDelay_mode_distributed_directive", this, (parser_rule_context *) ctx);
  }
  void exitDelay_mode_distributed_directive(SV3_1aParser::Delay_mode_distributed_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDelay_mode_distributed_directive", this, (parser_rule_context *) ctx);
  }

  void enterDelay_mode_path_directive(SV3_1aParser::Delay_mode_path_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDelay_mode_path_directive", this, (parser_rule_context *) ctx);
  }
  void exitDelay_mode_path_directive(SV3_1aParser::Delay_mode_path_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDelay_mode_path_directive", this, (parser_rule_context *) ctx);
  }

  void enterDelay_mode_unit_directive(SV3_1aParser::Delay_mode_unit_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDelay_mode_unit_directive", this, (parser_rule_context *) ctx);
  }
  void exitDelay_mode_unit_directive(SV3_1aParser::Delay_mode_unit_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDelay_mode_unit_directive", this, (parser_rule_context *) ctx);
  }

  void enterDelay_mode_zero_directive(SV3_1aParser::Delay_mode_zero_directiveContext * ctx) override {
    PythonAPI::evalScript("enterDelay_mode_zero_directive", this, (parser_rule_context *) ctx);
  }
  void exitDelay_mode_zero_directive(SV3_1aParser::Delay_mode_zero_directiveContext * ctx) override {
    PythonAPI::evalScript("exitDelay_mode_zero_directive", this, (parser_rule_context *) ctx);
  }

  void enterSurelog_macro_not_defined(SV3_1aParser::Surelog_macro_not_definedContext * ctx) override {
    PythonAPI::evalScript("enterSurelog_macro_not_defined", this, (parser_rule_context *) ctx);
  }
  void exitSurelog_macro_not_defined(SV3_1aParser::Surelog_macro_not_definedContext * ctx) override {
    PythonAPI::evalScript("exitSurelog_macro_not_defined", this, (parser_rule_context *) ctx);
  }

  void enterSlline(SV3_1aParser::SllineContext * ctx) override {
    PythonAPI::evalScript("enterSlline", this, (parser_rule_context *) ctx);
  }
  void exitSlline(SV3_1aParser::SllineContext * ctx) override {
    PythonAPI::evalScript("exitSlline", this, (parser_rule_context *) ctx);
  }

  void enterConfig_declaration(SV3_1aParser::Config_declarationContext * ctx) override {
    PythonAPI::evalScript("enterConfig_declaration", this, (parser_rule_context *) ctx);
  }
  void exitConfig_declaration(SV3_1aParser::Config_declarationContext * ctx) override {
    PythonAPI::evalScript("exitConfig_declaration", this, (parser_rule_context *) ctx);
  }

  void enterDesign_statement(SV3_1aParser::Design_statementContext * ctx) override {
    PythonAPI::evalScript("enterDesign_statement", this, (parser_rule_context *) ctx);
  }
  void exitDesign_statement(SV3_1aParser::Design_statementContext * ctx) override {
    PythonAPI::evalScript("exitDesign_statement", this, (parser_rule_context *) ctx);
  }

  void enterConfig_rule_statement(SV3_1aParser::Config_rule_statementContext * ctx) override {
    PythonAPI::evalScript("enterConfig_rule_statement", this, (parser_rule_context *) ctx);
  }
  void exitConfig_rule_statement(SV3_1aParser::Config_rule_statementContext * ctx) override {
    PythonAPI::evalScript("exitConfig_rule_statement", this, (parser_rule_context *) ctx);
  }

  void enterDefault_clause(SV3_1aParser::Default_clauseContext * ctx) override {
    PythonAPI::evalScript("enterDefault_clause", this, (parser_rule_context *) ctx);
  }
  void exitDefault_clause(SV3_1aParser::Default_clauseContext * ctx) override {
    PythonAPI::evalScript("exitDefault_clause", this, (parser_rule_context *) ctx);
  }

  void enterInst_clause(SV3_1aParser::Inst_clauseContext * ctx) override {
    PythonAPI::evalScript("enterInst_clause", this, (parser_rule_context *) ctx);
  }
  void exitInst_clause(SV3_1aParser::Inst_clauseContext * ctx) override {
    PythonAPI::evalScript("exitInst_clause", this, (parser_rule_context *) ctx);
  }

  void enterInst_name(SV3_1aParser::Inst_nameContext * ctx) override {
    PythonAPI::evalScript("enterInst_name", this, (parser_rule_context *) ctx);
  }
  void exitInst_name(SV3_1aParser::Inst_nameContext * ctx) override {
    PythonAPI::evalScript("exitInst_name", this, (parser_rule_context *) ctx);
  }

  void enterCell_clause(SV3_1aParser::Cell_clauseContext * ctx) override {
    PythonAPI::evalScript("enterCell_clause", this, (parser_rule_context *) ctx);
  }
  void exitCell_clause(SV3_1aParser::Cell_clauseContext * ctx) override {
    PythonAPI::evalScript("exitCell_clause", this, (parser_rule_context *) ctx);
  }

  void enterLiblist_clause(SV3_1aParser::Liblist_clauseContext * ctx) override {
    PythonAPI::evalScript("enterLiblist_clause", this, (parser_rule_context *) ctx);
  }
  void exitLiblist_clause(SV3_1aParser::Liblist_clauseContext * ctx) override {
    PythonAPI::evalScript("exitLiblist_clause", this, (parser_rule_context *) ctx);
  }

  void enterUse_clause_config(SV3_1aParser::Use_clause_configContext * ctx) override {
    PythonAPI::evalScript("enterUse_clause_config", this, (parser_rule_context *) ctx);
  }
  void exitUse_clause_config(SV3_1aParser::Use_clause_configContext * ctx) override {
    PythonAPI::evalScript("exitUse_clause_config", this, (parser_rule_context *) ctx);
  }

  void enterUse_clause(SV3_1aParser::Use_clauseContext * ctx) override {
    PythonAPI::evalScript("enterUse_clause", this, (parser_rule_context *) ctx);
  }
  void exitUse_clause(SV3_1aParser::Use_clauseContext * ctx) override {
    PythonAPI::evalScript("exitUse_clause", this, (parser_rule_context *) ctx);
  }


  void enterEveryRule(antlr4::ParserRuleContext * ctx) override {
    PythonAPI::evalScript("enterEveryRule", this, (parser_rule_context *) ctx);
  }
  void exitEveryRule(antlr4::ParserRuleContext * ctx) override {
    PythonAPI::evalScript("exitEveryRule", this, (parser_rule_context *) ctx);
  }
  void visitTerminal(antlr4::tree::TerminalNode * node) override {
    PythonAPI::evalScript("visitTerminal", this, (parser_rule_context *) node);
  }
  void visitErrorNode(antlr4::tree::ErrorNode * node) override {
    PythonAPI::evalScript("visitErrorNode", this, (parser_rule_context *) node);
  }


};
}  // namespace SURELOG

#endif  /* SURELOG_SV3_1APYTHONLISTENER_H */
